#ifndef _H_4A6B93D612BCF6803E143453C2E97D43_TypeDef_DCPS_H_
#define _H_4A6B93D612BCF6803E143453C2E97D43_TypeDef_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TypeDef_.h"


namespace rosapi
{
    namespace msg
    {
        namespace dds_
        {
            class TypeDef_TypeSupportInterface;

            typedef TypeDef_TypeSupportInterface * TypeDef_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TypeDef_TypeSupportInterface> TypeDef_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TypeDef_TypeSupportInterface> TypeDef_TypeSupportInterface_out;


            class TypeDef_DataWriter;

            typedef TypeDef_DataWriter * TypeDef_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TypeDef_DataWriter> TypeDef_DataWriter_var;
            typedef DDS_DCPSInterface_out < TypeDef_DataWriter> TypeDef_DataWriter_out;


            class TypeDef_DataReader;

            typedef TypeDef_DataReader * TypeDef_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TypeDef_DataReader> TypeDef_DataReader_var;
            typedef DDS_DCPSInterface_out < TypeDef_DataReader> TypeDef_DataReader_out;


            class TypeDef_DataReaderView;

            typedef TypeDef_DataReaderView * TypeDef_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TypeDef_DataReaderView> TypeDef_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TypeDef_DataReaderView> TypeDef_DataReaderView_out;

            struct TypeDef_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TypeDef_, struct TypeDef_Seq_uniq_> TypeDef_Seq;
            typedef DDS_DCPSSequence_var < TypeDef_Seq> TypeDef_Seq_var;
            typedef DDS_DCPSSequence_out < TypeDef_Seq> TypeDef_Seq_out;

            class  TypeDef_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TypeDef_TypeSupportInterface_ptr _ptr_type;
                typedef TypeDef_TypeSupportInterface_var _var_type;

                static TypeDef_TypeSupportInterface_ptr _duplicate (TypeDef_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TypeDef_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TypeDef_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TypeDef_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TypeDef_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TypeDef_TypeSupportInterface () {};
                ~TypeDef_TypeSupportInterface () {};
            private:
                TypeDef_TypeSupportInterface (const TypeDef_TypeSupportInterface &);
                TypeDef_TypeSupportInterface & operator = (const TypeDef_TypeSupportInterface &);
            };

            class  TypeDef_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TypeDef_DataWriter_ptr _ptr_type;
                typedef TypeDef_DataWriter_var _var_type;

                static TypeDef_DataWriter_ptr _duplicate (TypeDef_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TypeDef_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TypeDef_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TypeDef_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TypeDef_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TypeDef_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TypeDef_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TypeDef_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TypeDef_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TypeDef_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TypeDef_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TypeDef_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TypeDef_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TypeDef_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TypeDef_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TypeDef_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TypeDef_& instance_data) = 0;

            protected:
                TypeDef_DataWriter () {};
                ~TypeDef_DataWriter () {};
            private:
                TypeDef_DataWriter (const TypeDef_DataWriter &);
                TypeDef_DataWriter & operator = (const TypeDef_DataWriter &);
            };

            class  TypeDef_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TypeDef_DataReader_ptr _ptr_type;
                typedef TypeDef_DataReader_var _var_type;

                static TypeDef_DataReader_ptr _duplicate (TypeDef_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TypeDef_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TypeDef_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TypeDef_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TypeDef_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TypeDef_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TypeDef_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TypeDef_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TypeDef_& instance) = 0;

            protected:
                TypeDef_DataReader () {};
                ~TypeDef_DataReader () {};
            private:
                TypeDef_DataReader (const TypeDef_DataReader &);
                TypeDef_DataReader & operator = (const TypeDef_DataReader &);
            };

            class  TypeDef_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TypeDef_DataReaderView_ptr _ptr_type;
                typedef TypeDef_DataReaderView_var _var_type;

                static TypeDef_DataReaderView_ptr _duplicate (TypeDef_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TypeDef_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TypeDef_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TypeDef_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TypeDef_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TypeDef_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TypeDef_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TypeDef_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TypeDef_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TypeDef_& instance) = 0;

            protected:
                TypeDef_DataReaderView () {};
                ~TypeDef_DataReaderView () {};
            private:
                TypeDef_DataReaderView (const TypeDef_DataReaderView &);
                TypeDef_DataReaderView & operator = (const TypeDef_DataReaderView &);
            };
        }

    }

}

#endif
