#ifndef _H_9B7A40FAA79E3A602DDAE5AB57430BE1_DeleteParam_DCPS_H_
#define _H_9B7A40FAA79E3A602DDAE5AB57430BE1_DeleteParam_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeleteParam_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class DeleteParam_Request_TypeSupportInterface;

            typedef DeleteParam_Request_TypeSupportInterface * DeleteParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Request_TypeSupportInterface> DeleteParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Request_TypeSupportInterface> DeleteParam_Request_TypeSupportInterface_out;


            class DeleteParam_Request_DataWriter;

            typedef DeleteParam_Request_DataWriter * DeleteParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Request_DataWriter> DeleteParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Request_DataWriter> DeleteParam_Request_DataWriter_out;


            class DeleteParam_Request_DataReader;

            typedef DeleteParam_Request_DataReader * DeleteParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Request_DataReader> DeleteParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Request_DataReader> DeleteParam_Request_DataReader_out;


            class DeleteParam_Request_DataReaderView;

            typedef DeleteParam_Request_DataReaderView * DeleteParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Request_DataReaderView> DeleteParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Request_DataReaderView> DeleteParam_Request_DataReaderView_out;

            struct DeleteParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteParam_Request_, struct DeleteParam_Request_Seq_uniq_> DeleteParam_Request_Seq;
            typedef DDS_DCPSSequence_var < DeleteParam_Request_Seq> DeleteParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteParam_Request_Seq> DeleteParam_Request_Seq_out;

            class  DeleteParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteParam_Request_TypeSupportInterface_var _var_type;

                static DeleteParam_Request_TypeSupportInterface_ptr _duplicate (DeleteParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteParam_Request_TypeSupportInterface () {};
                ~DeleteParam_Request_TypeSupportInterface () {};
            private:
                DeleteParam_Request_TypeSupportInterface (const DeleteParam_Request_TypeSupportInterface &);
                DeleteParam_Request_TypeSupportInterface & operator = (const DeleteParam_Request_TypeSupportInterface &);
            };

            class  DeleteParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteParam_Request_DataWriter_ptr _ptr_type;
                typedef DeleteParam_Request_DataWriter_var _var_type;

                static DeleteParam_Request_DataWriter_ptr _duplicate (DeleteParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteParam_Request_& instance_data) = 0;

            protected:
                DeleteParam_Request_DataWriter () {};
                ~DeleteParam_Request_DataWriter () {};
            private:
                DeleteParam_Request_DataWriter (const DeleteParam_Request_DataWriter &);
                DeleteParam_Request_DataWriter & operator = (const DeleteParam_Request_DataWriter &);
            };

            class  DeleteParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteParam_Request_DataReader_ptr _ptr_type;
                typedef DeleteParam_Request_DataReader_var _var_type;

                static DeleteParam_Request_DataReader_ptr _duplicate (DeleteParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteParam_Request_& instance) = 0;

            protected:
                DeleteParam_Request_DataReader () {};
                ~DeleteParam_Request_DataReader () {};
            private:
                DeleteParam_Request_DataReader (const DeleteParam_Request_DataReader &);
                DeleteParam_Request_DataReader & operator = (const DeleteParam_Request_DataReader &);
            };

            class  DeleteParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteParam_Request_DataReaderView_ptr _ptr_type;
                typedef DeleteParam_Request_DataReaderView_var _var_type;

                static DeleteParam_Request_DataReaderView_ptr _duplicate (DeleteParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteParam_Request_& instance) = 0;

            protected:
                DeleteParam_Request_DataReaderView () {};
                ~DeleteParam_Request_DataReaderView () {};
            private:
                DeleteParam_Request_DataReaderView (const DeleteParam_Request_DataReaderView &);
                DeleteParam_Request_DataReaderView & operator = (const DeleteParam_Request_DataReaderView &);
            };
            class DeleteParam_Response_TypeSupportInterface;

            typedef DeleteParam_Response_TypeSupportInterface * DeleteParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Response_TypeSupportInterface> DeleteParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Response_TypeSupportInterface> DeleteParam_Response_TypeSupportInterface_out;


            class DeleteParam_Response_DataWriter;

            typedef DeleteParam_Response_DataWriter * DeleteParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Response_DataWriter> DeleteParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Response_DataWriter> DeleteParam_Response_DataWriter_out;


            class DeleteParam_Response_DataReader;

            typedef DeleteParam_Response_DataReader * DeleteParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Response_DataReader> DeleteParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Response_DataReader> DeleteParam_Response_DataReader_out;


            class DeleteParam_Response_DataReaderView;

            typedef DeleteParam_Response_DataReaderView * DeleteParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteParam_Response_DataReaderView> DeleteParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteParam_Response_DataReaderView> DeleteParam_Response_DataReaderView_out;

            struct DeleteParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DeleteParam_Response_, struct DeleteParam_Response_Seq_uniq_> DeleteParam_Response_Seq;
            typedef DDS_DCPSSequence_var < DeleteParam_Response_Seq> DeleteParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteParam_Response_Seq> DeleteParam_Response_Seq_out;

            class  DeleteParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteParam_Response_TypeSupportInterface_var _var_type;

                static DeleteParam_Response_TypeSupportInterface_ptr _duplicate (DeleteParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteParam_Response_TypeSupportInterface () {};
                ~DeleteParam_Response_TypeSupportInterface () {};
            private:
                DeleteParam_Response_TypeSupportInterface (const DeleteParam_Response_TypeSupportInterface &);
                DeleteParam_Response_TypeSupportInterface & operator = (const DeleteParam_Response_TypeSupportInterface &);
            };

            class  DeleteParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteParam_Response_DataWriter_ptr _ptr_type;
                typedef DeleteParam_Response_DataWriter_var _var_type;

                static DeleteParam_Response_DataWriter_ptr _duplicate (DeleteParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteParam_Response_& instance_data) = 0;

            protected:
                DeleteParam_Response_DataWriter () {};
                ~DeleteParam_Response_DataWriter () {};
            private:
                DeleteParam_Response_DataWriter (const DeleteParam_Response_DataWriter &);
                DeleteParam_Response_DataWriter & operator = (const DeleteParam_Response_DataWriter &);
            };

            class  DeleteParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteParam_Response_DataReader_ptr _ptr_type;
                typedef DeleteParam_Response_DataReader_var _var_type;

                static DeleteParam_Response_DataReader_ptr _duplicate (DeleteParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteParam_Response_& instance) = 0;

            protected:
                DeleteParam_Response_DataReader () {};
                ~DeleteParam_Response_DataReader () {};
            private:
                DeleteParam_Response_DataReader (const DeleteParam_Response_DataReader &);
                DeleteParam_Response_DataReader & operator = (const DeleteParam_Response_DataReader &);
            };

            class  DeleteParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteParam_Response_DataReaderView_ptr _ptr_type;
                typedef DeleteParam_Response_DataReaderView_var _var_type;

                static DeleteParam_Response_DataReaderView_ptr _duplicate (DeleteParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteParam_Response_& instance) = 0;

            protected:
                DeleteParam_Response_DataReaderView () {};
                ~DeleteParam_Response_DataReaderView () {};
            private:
                DeleteParam_Response_DataReaderView (const DeleteParam_Response_DataReaderView &);
                DeleteParam_Response_DataReaderView & operator = (const DeleteParam_Response_DataReaderView &);
            };
            class Sample_DeleteParam_Request_TypeSupportInterface;

            typedef Sample_DeleteParam_Request_TypeSupportInterface * Sample_DeleteParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Request_TypeSupportInterface> Sample_DeleteParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Request_TypeSupportInterface> Sample_DeleteParam_Request_TypeSupportInterface_out;


            class Sample_DeleteParam_Request_DataWriter;

            typedef Sample_DeleteParam_Request_DataWriter * Sample_DeleteParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Request_DataWriter> Sample_DeleteParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Request_DataWriter> Sample_DeleteParam_Request_DataWriter_out;


            class Sample_DeleteParam_Request_DataReader;

            typedef Sample_DeleteParam_Request_DataReader * Sample_DeleteParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Request_DataReader> Sample_DeleteParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Request_DataReader> Sample_DeleteParam_Request_DataReader_out;


            class Sample_DeleteParam_Request_DataReaderView;

            typedef Sample_DeleteParam_Request_DataReaderView * Sample_DeleteParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Request_DataReaderView> Sample_DeleteParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Request_DataReaderView> Sample_DeleteParam_Request_DataReaderView_out;

            struct Sample_DeleteParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DeleteParam_Request_, struct Sample_DeleteParam_Request_Seq_uniq_> Sample_DeleteParam_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeleteParam_Request_Seq> Sample_DeleteParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeleteParam_Request_Seq> Sample_DeleteParam_Request_Seq_out;

            class  Sample_DeleteParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeleteParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeleteParam_Request_TypeSupportInterface_var _var_type;

                static Sample_DeleteParam_Request_TypeSupportInterface_ptr _duplicate (Sample_DeleteParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeleteParam_Request_TypeSupportInterface () {};
                ~Sample_DeleteParam_Request_TypeSupportInterface () {};
            private:
                Sample_DeleteParam_Request_TypeSupportInterface (const Sample_DeleteParam_Request_TypeSupportInterface &);
                Sample_DeleteParam_Request_TypeSupportInterface & operator = (const Sample_DeleteParam_Request_TypeSupportInterface &);
            };

            class  Sample_DeleteParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeleteParam_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DeleteParam_Request_DataWriter_var _var_type;

                static Sample_DeleteParam_Request_DataWriter_ptr _duplicate (Sample_DeleteParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeleteParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeleteParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeleteParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteParam_Request_& instance_data) = 0;

            protected:
                Sample_DeleteParam_Request_DataWriter () {};
                ~Sample_DeleteParam_Request_DataWriter () {};
            private:
                Sample_DeleteParam_Request_DataWriter (const Sample_DeleteParam_Request_DataWriter &);
                Sample_DeleteParam_Request_DataWriter & operator = (const Sample_DeleteParam_Request_DataWriter &);
            };

            class  Sample_DeleteParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeleteParam_Request_DataReader_ptr _ptr_type;
                typedef Sample_DeleteParam_Request_DataReader_var _var_type;

                static Sample_DeleteParam_Request_DataReader_ptr _duplicate (Sample_DeleteParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteParam_Request_& instance) = 0;

            protected:
                Sample_DeleteParam_Request_DataReader () {};
                ~Sample_DeleteParam_Request_DataReader () {};
            private:
                Sample_DeleteParam_Request_DataReader (const Sample_DeleteParam_Request_DataReader &);
                Sample_DeleteParam_Request_DataReader & operator = (const Sample_DeleteParam_Request_DataReader &);
            };

            class  Sample_DeleteParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeleteParam_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DeleteParam_Request_DataReaderView_var _var_type;

                static Sample_DeleteParam_Request_DataReaderView_ptr _duplicate (Sample_DeleteParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteParam_Request_& instance) = 0;

            protected:
                Sample_DeleteParam_Request_DataReaderView () {};
                ~Sample_DeleteParam_Request_DataReaderView () {};
            private:
                Sample_DeleteParam_Request_DataReaderView (const Sample_DeleteParam_Request_DataReaderView &);
                Sample_DeleteParam_Request_DataReaderView & operator = (const Sample_DeleteParam_Request_DataReaderView &);
            };
            class Sample_DeleteParam_Response_TypeSupportInterface;

            typedef Sample_DeleteParam_Response_TypeSupportInterface * Sample_DeleteParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Response_TypeSupportInterface> Sample_DeleteParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Response_TypeSupportInterface> Sample_DeleteParam_Response_TypeSupportInterface_out;


            class Sample_DeleteParam_Response_DataWriter;

            typedef Sample_DeleteParam_Response_DataWriter * Sample_DeleteParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Response_DataWriter> Sample_DeleteParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Response_DataWriter> Sample_DeleteParam_Response_DataWriter_out;


            class Sample_DeleteParam_Response_DataReader;

            typedef Sample_DeleteParam_Response_DataReader * Sample_DeleteParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Response_DataReader> Sample_DeleteParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Response_DataReader> Sample_DeleteParam_Response_DataReader_out;


            class Sample_DeleteParam_Response_DataReaderView;

            typedef Sample_DeleteParam_Response_DataReaderView * Sample_DeleteParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteParam_Response_DataReaderView> Sample_DeleteParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteParam_Response_DataReaderView> Sample_DeleteParam_Response_DataReaderView_out;

            struct Sample_DeleteParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_DeleteParam_Response_, struct Sample_DeleteParam_Response_Seq_uniq_> Sample_DeleteParam_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeleteParam_Response_Seq> Sample_DeleteParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeleteParam_Response_Seq> Sample_DeleteParam_Response_Seq_out;

            class  Sample_DeleteParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeleteParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeleteParam_Response_TypeSupportInterface_var _var_type;

                static Sample_DeleteParam_Response_TypeSupportInterface_ptr _duplicate (Sample_DeleteParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeleteParam_Response_TypeSupportInterface () {};
                ~Sample_DeleteParam_Response_TypeSupportInterface () {};
            private:
                Sample_DeleteParam_Response_TypeSupportInterface (const Sample_DeleteParam_Response_TypeSupportInterface &);
                Sample_DeleteParam_Response_TypeSupportInterface & operator = (const Sample_DeleteParam_Response_TypeSupportInterface &);
            };

            class  Sample_DeleteParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeleteParam_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DeleteParam_Response_DataWriter_var _var_type;

                static Sample_DeleteParam_Response_DataWriter_ptr _duplicate (Sample_DeleteParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeleteParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeleteParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeleteParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteParam_Response_& instance_data) = 0;

            protected:
                Sample_DeleteParam_Response_DataWriter () {};
                ~Sample_DeleteParam_Response_DataWriter () {};
            private:
                Sample_DeleteParam_Response_DataWriter (const Sample_DeleteParam_Response_DataWriter &);
                Sample_DeleteParam_Response_DataWriter & operator = (const Sample_DeleteParam_Response_DataWriter &);
            };

            class  Sample_DeleteParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeleteParam_Response_DataReader_ptr _ptr_type;
                typedef Sample_DeleteParam_Response_DataReader_var _var_type;

                static Sample_DeleteParam_Response_DataReader_ptr _duplicate (Sample_DeleteParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteParam_Response_& instance) = 0;

            protected:
                Sample_DeleteParam_Response_DataReader () {};
                ~Sample_DeleteParam_Response_DataReader () {};
            private:
                Sample_DeleteParam_Response_DataReader (const Sample_DeleteParam_Response_DataReader &);
                Sample_DeleteParam_Response_DataReader & operator = (const Sample_DeleteParam_Response_DataReader &);
            };

            class  Sample_DeleteParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeleteParam_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DeleteParam_Response_DataReaderView_var _var_type;

                static Sample_DeleteParam_Response_DataReaderView_ptr _duplicate (Sample_DeleteParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteParam_Response_& instance) = 0;

            protected:
                Sample_DeleteParam_Response_DataReaderView () {};
                ~Sample_DeleteParam_Response_DataReaderView () {};
            private:
                Sample_DeleteParam_Response_DataReaderView (const Sample_DeleteParam_Response_DataReaderView &);
                Sample_DeleteParam_Response_DataReaderView & operator = (const Sample_DeleteParam_Response_DataReaderView &);
            };
        }

    }

}

#endif
