#ifndef _H_E0C5F99A84247E94361CB5ADB901124C_GetActionServers_DCPS_H_
#define _H_E0C5F99A84247E94361CB5ADB901124C_GetActionServers_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetActionServers_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class GetActionServers_Request_TypeSupportInterface;

            typedef GetActionServers_Request_TypeSupportInterface * GetActionServers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Request_TypeSupportInterface> GetActionServers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Request_TypeSupportInterface> GetActionServers_Request_TypeSupportInterface_out;


            class GetActionServers_Request_DataWriter;

            typedef GetActionServers_Request_DataWriter * GetActionServers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Request_DataWriter> GetActionServers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Request_DataWriter> GetActionServers_Request_DataWriter_out;


            class GetActionServers_Request_DataReader;

            typedef GetActionServers_Request_DataReader * GetActionServers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Request_DataReader> GetActionServers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Request_DataReader> GetActionServers_Request_DataReader_out;


            class GetActionServers_Request_DataReaderView;

            typedef GetActionServers_Request_DataReaderView * GetActionServers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Request_DataReaderView> GetActionServers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Request_DataReaderView> GetActionServers_Request_DataReaderView_out;

            struct GetActionServers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetActionServers_Request_, struct GetActionServers_Request_Seq_uniq_> GetActionServers_Request_Seq;
            typedef DDS_DCPSSequence_var < GetActionServers_Request_Seq> GetActionServers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetActionServers_Request_Seq> GetActionServers_Request_Seq_out;

            class  GetActionServers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetActionServers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetActionServers_Request_TypeSupportInterface_var _var_type;

                static GetActionServers_Request_TypeSupportInterface_ptr _duplicate (GetActionServers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetActionServers_Request_TypeSupportInterface () {};
                ~GetActionServers_Request_TypeSupportInterface () {};
            private:
                GetActionServers_Request_TypeSupportInterface (const GetActionServers_Request_TypeSupportInterface &);
                GetActionServers_Request_TypeSupportInterface & operator = (const GetActionServers_Request_TypeSupportInterface &);
            };

            class  GetActionServers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetActionServers_Request_DataWriter_ptr _ptr_type;
                typedef GetActionServers_Request_DataWriter_var _var_type;

                static GetActionServers_Request_DataWriter_ptr _duplicate (GetActionServers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetActionServers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetActionServers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetActionServers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetActionServers_Request_& instance_data) = 0;

            protected:
                GetActionServers_Request_DataWriter () {};
                ~GetActionServers_Request_DataWriter () {};
            private:
                GetActionServers_Request_DataWriter (const GetActionServers_Request_DataWriter &);
                GetActionServers_Request_DataWriter & operator = (const GetActionServers_Request_DataWriter &);
            };

            class  GetActionServers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetActionServers_Request_DataReader_ptr _ptr_type;
                typedef GetActionServers_Request_DataReader_var _var_type;

                static GetActionServers_Request_DataReader_ptr _duplicate (GetActionServers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetActionServers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetActionServers_Request_& instance) = 0;

            protected:
                GetActionServers_Request_DataReader () {};
                ~GetActionServers_Request_DataReader () {};
            private:
                GetActionServers_Request_DataReader (const GetActionServers_Request_DataReader &);
                GetActionServers_Request_DataReader & operator = (const GetActionServers_Request_DataReader &);
            };

            class  GetActionServers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetActionServers_Request_DataReaderView_ptr _ptr_type;
                typedef GetActionServers_Request_DataReaderView_var _var_type;

                static GetActionServers_Request_DataReaderView_ptr _duplicate (GetActionServers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetActionServers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetActionServers_Request_& instance) = 0;

            protected:
                GetActionServers_Request_DataReaderView () {};
                ~GetActionServers_Request_DataReaderView () {};
            private:
                GetActionServers_Request_DataReaderView (const GetActionServers_Request_DataReaderView &);
                GetActionServers_Request_DataReaderView & operator = (const GetActionServers_Request_DataReaderView &);
            };
            class GetActionServers_Response_TypeSupportInterface;

            typedef GetActionServers_Response_TypeSupportInterface * GetActionServers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Response_TypeSupportInterface> GetActionServers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Response_TypeSupportInterface> GetActionServers_Response_TypeSupportInterface_out;


            class GetActionServers_Response_DataWriter;

            typedef GetActionServers_Response_DataWriter * GetActionServers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Response_DataWriter> GetActionServers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Response_DataWriter> GetActionServers_Response_DataWriter_out;


            class GetActionServers_Response_DataReader;

            typedef GetActionServers_Response_DataReader * GetActionServers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Response_DataReader> GetActionServers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Response_DataReader> GetActionServers_Response_DataReader_out;


            class GetActionServers_Response_DataReaderView;

            typedef GetActionServers_Response_DataReaderView * GetActionServers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetActionServers_Response_DataReaderView> GetActionServers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetActionServers_Response_DataReaderView> GetActionServers_Response_DataReaderView_out;

            struct GetActionServers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetActionServers_Response_, struct GetActionServers_Response_Seq_uniq_> GetActionServers_Response_Seq;
            typedef DDS_DCPSSequence_var < GetActionServers_Response_Seq> GetActionServers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetActionServers_Response_Seq> GetActionServers_Response_Seq_out;

            class  GetActionServers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetActionServers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetActionServers_Response_TypeSupportInterface_var _var_type;

                static GetActionServers_Response_TypeSupportInterface_ptr _duplicate (GetActionServers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetActionServers_Response_TypeSupportInterface () {};
                ~GetActionServers_Response_TypeSupportInterface () {};
            private:
                GetActionServers_Response_TypeSupportInterface (const GetActionServers_Response_TypeSupportInterface &);
                GetActionServers_Response_TypeSupportInterface & operator = (const GetActionServers_Response_TypeSupportInterface &);
            };

            class  GetActionServers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetActionServers_Response_DataWriter_ptr _ptr_type;
                typedef GetActionServers_Response_DataWriter_var _var_type;

                static GetActionServers_Response_DataWriter_ptr _duplicate (GetActionServers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetActionServers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetActionServers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetActionServers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetActionServers_Response_& instance_data) = 0;

            protected:
                GetActionServers_Response_DataWriter () {};
                ~GetActionServers_Response_DataWriter () {};
            private:
                GetActionServers_Response_DataWriter (const GetActionServers_Response_DataWriter &);
                GetActionServers_Response_DataWriter & operator = (const GetActionServers_Response_DataWriter &);
            };

            class  GetActionServers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetActionServers_Response_DataReader_ptr _ptr_type;
                typedef GetActionServers_Response_DataReader_var _var_type;

                static GetActionServers_Response_DataReader_ptr _duplicate (GetActionServers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetActionServers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetActionServers_Response_& instance) = 0;

            protected:
                GetActionServers_Response_DataReader () {};
                ~GetActionServers_Response_DataReader () {};
            private:
                GetActionServers_Response_DataReader (const GetActionServers_Response_DataReader &);
                GetActionServers_Response_DataReader & operator = (const GetActionServers_Response_DataReader &);
            };

            class  GetActionServers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetActionServers_Response_DataReaderView_ptr _ptr_type;
                typedef GetActionServers_Response_DataReaderView_var _var_type;

                static GetActionServers_Response_DataReaderView_ptr _duplicate (GetActionServers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetActionServers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetActionServers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetActionServers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetActionServers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetActionServers_Response_& instance) = 0;

            protected:
                GetActionServers_Response_DataReaderView () {};
                ~GetActionServers_Response_DataReaderView () {};
            private:
                GetActionServers_Response_DataReaderView (const GetActionServers_Response_DataReaderView &);
                GetActionServers_Response_DataReaderView & operator = (const GetActionServers_Response_DataReaderView &);
            };
            class Sample_GetActionServers_Request_TypeSupportInterface;

            typedef Sample_GetActionServers_Request_TypeSupportInterface * Sample_GetActionServers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Request_TypeSupportInterface> Sample_GetActionServers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Request_TypeSupportInterface> Sample_GetActionServers_Request_TypeSupportInterface_out;


            class Sample_GetActionServers_Request_DataWriter;

            typedef Sample_GetActionServers_Request_DataWriter * Sample_GetActionServers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Request_DataWriter> Sample_GetActionServers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Request_DataWriter> Sample_GetActionServers_Request_DataWriter_out;


            class Sample_GetActionServers_Request_DataReader;

            typedef Sample_GetActionServers_Request_DataReader * Sample_GetActionServers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Request_DataReader> Sample_GetActionServers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Request_DataReader> Sample_GetActionServers_Request_DataReader_out;


            class Sample_GetActionServers_Request_DataReaderView;

            typedef Sample_GetActionServers_Request_DataReaderView * Sample_GetActionServers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Request_DataReaderView> Sample_GetActionServers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Request_DataReaderView> Sample_GetActionServers_Request_DataReaderView_out;

            struct Sample_GetActionServers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetActionServers_Request_, struct Sample_GetActionServers_Request_Seq_uniq_> Sample_GetActionServers_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetActionServers_Request_Seq> Sample_GetActionServers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetActionServers_Request_Seq> Sample_GetActionServers_Request_Seq_out;

            class  Sample_GetActionServers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetActionServers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetActionServers_Request_TypeSupportInterface_var _var_type;

                static Sample_GetActionServers_Request_TypeSupportInterface_ptr _duplicate (Sample_GetActionServers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetActionServers_Request_TypeSupportInterface () {};
                ~Sample_GetActionServers_Request_TypeSupportInterface () {};
            private:
                Sample_GetActionServers_Request_TypeSupportInterface (const Sample_GetActionServers_Request_TypeSupportInterface &);
                Sample_GetActionServers_Request_TypeSupportInterface & operator = (const Sample_GetActionServers_Request_TypeSupportInterface &);
            };

            class  Sample_GetActionServers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetActionServers_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetActionServers_Request_DataWriter_var _var_type;

                static Sample_GetActionServers_Request_DataWriter_ptr _duplicate (Sample_GetActionServers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetActionServers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetActionServers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetActionServers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetActionServers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetActionServers_Request_& instance_data) = 0;

            protected:
                Sample_GetActionServers_Request_DataWriter () {};
                ~Sample_GetActionServers_Request_DataWriter () {};
            private:
                Sample_GetActionServers_Request_DataWriter (const Sample_GetActionServers_Request_DataWriter &);
                Sample_GetActionServers_Request_DataWriter & operator = (const Sample_GetActionServers_Request_DataWriter &);
            };

            class  Sample_GetActionServers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetActionServers_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetActionServers_Request_DataReader_var _var_type;

                static Sample_GetActionServers_Request_DataReader_ptr _duplicate (Sample_GetActionServers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetActionServers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetActionServers_Request_& instance) = 0;

            protected:
                Sample_GetActionServers_Request_DataReader () {};
                ~Sample_GetActionServers_Request_DataReader () {};
            private:
                Sample_GetActionServers_Request_DataReader (const Sample_GetActionServers_Request_DataReader &);
                Sample_GetActionServers_Request_DataReader & operator = (const Sample_GetActionServers_Request_DataReader &);
            };

            class  Sample_GetActionServers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetActionServers_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetActionServers_Request_DataReaderView_var _var_type;

                static Sample_GetActionServers_Request_DataReaderView_ptr _duplicate (Sample_GetActionServers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetActionServers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetActionServers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetActionServers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetActionServers_Request_& instance) = 0;

            protected:
                Sample_GetActionServers_Request_DataReaderView () {};
                ~Sample_GetActionServers_Request_DataReaderView () {};
            private:
                Sample_GetActionServers_Request_DataReaderView (const Sample_GetActionServers_Request_DataReaderView &);
                Sample_GetActionServers_Request_DataReaderView & operator = (const Sample_GetActionServers_Request_DataReaderView &);
            };
            class Sample_GetActionServers_Response_TypeSupportInterface;

            typedef Sample_GetActionServers_Response_TypeSupportInterface * Sample_GetActionServers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Response_TypeSupportInterface> Sample_GetActionServers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Response_TypeSupportInterface> Sample_GetActionServers_Response_TypeSupportInterface_out;


            class Sample_GetActionServers_Response_DataWriter;

            typedef Sample_GetActionServers_Response_DataWriter * Sample_GetActionServers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Response_DataWriter> Sample_GetActionServers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Response_DataWriter> Sample_GetActionServers_Response_DataWriter_out;


            class Sample_GetActionServers_Response_DataReader;

            typedef Sample_GetActionServers_Response_DataReader * Sample_GetActionServers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Response_DataReader> Sample_GetActionServers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Response_DataReader> Sample_GetActionServers_Response_DataReader_out;


            class Sample_GetActionServers_Response_DataReaderView;

            typedef Sample_GetActionServers_Response_DataReaderView * Sample_GetActionServers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetActionServers_Response_DataReaderView> Sample_GetActionServers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetActionServers_Response_DataReaderView> Sample_GetActionServers_Response_DataReaderView_out;

            struct Sample_GetActionServers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetActionServers_Response_, struct Sample_GetActionServers_Response_Seq_uniq_> Sample_GetActionServers_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetActionServers_Response_Seq> Sample_GetActionServers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetActionServers_Response_Seq> Sample_GetActionServers_Response_Seq_out;

            class  Sample_GetActionServers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetActionServers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetActionServers_Response_TypeSupportInterface_var _var_type;

                static Sample_GetActionServers_Response_TypeSupportInterface_ptr _duplicate (Sample_GetActionServers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetActionServers_Response_TypeSupportInterface () {};
                ~Sample_GetActionServers_Response_TypeSupportInterface () {};
            private:
                Sample_GetActionServers_Response_TypeSupportInterface (const Sample_GetActionServers_Response_TypeSupportInterface &);
                Sample_GetActionServers_Response_TypeSupportInterface & operator = (const Sample_GetActionServers_Response_TypeSupportInterface &);
            };

            class  Sample_GetActionServers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetActionServers_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetActionServers_Response_DataWriter_var _var_type;

                static Sample_GetActionServers_Response_DataWriter_ptr _duplicate (Sample_GetActionServers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetActionServers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetActionServers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetActionServers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetActionServers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetActionServers_Response_& instance_data) = 0;

            protected:
                Sample_GetActionServers_Response_DataWriter () {};
                ~Sample_GetActionServers_Response_DataWriter () {};
            private:
                Sample_GetActionServers_Response_DataWriter (const Sample_GetActionServers_Response_DataWriter &);
                Sample_GetActionServers_Response_DataWriter & operator = (const Sample_GetActionServers_Response_DataWriter &);
            };

            class  Sample_GetActionServers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetActionServers_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetActionServers_Response_DataReader_var _var_type;

                static Sample_GetActionServers_Response_DataReader_ptr _duplicate (Sample_GetActionServers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetActionServers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetActionServers_Response_& instance) = 0;

            protected:
                Sample_GetActionServers_Response_DataReader () {};
                ~Sample_GetActionServers_Response_DataReader () {};
            private:
                Sample_GetActionServers_Response_DataReader (const Sample_GetActionServers_Response_DataReader &);
                Sample_GetActionServers_Response_DataReader & operator = (const Sample_GetActionServers_Response_DataReader &);
            };

            class  Sample_GetActionServers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetActionServers_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetActionServers_Response_DataReaderView_var _var_type;

                static Sample_GetActionServers_Response_DataReaderView_ptr _duplicate (Sample_GetActionServers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetActionServers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetActionServers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetActionServers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetActionServers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetActionServers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetActionServers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetActionServers_Response_& instance) = 0;

            protected:
                Sample_GetActionServers_Response_DataReaderView () {};
                ~Sample_GetActionServers_Response_DataReaderView () {};
            private:
                Sample_GetActionServers_Response_DataReaderView (const Sample_GetActionServers_Response_DataReaderView &);
                Sample_GetActionServers_Response_DataReaderView & operator = (const Sample_GetActionServers_Response_DataReaderView &);
            };
        }

    }

}

#endif
