#ifndef _H_69E7421B7060014F0D24982D81F8F92E_GetParam__H_
#define _H_69E7421B7060014F0D24982D81F8F92E_GetParam__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetParam_Request_
            {
                ::DDS::String_mgr name_;
                ::DDS::String_mgr default_value_;
            };

            typedef DDS_DCPSStruct_var<GetParam_Request_> GetParam_Request__var;
            typedef DDS_DCPSStruct_out < GetParam_Request_> GetParam_Request__out;

            struct  GetParam_Response_
            {
                ::DDS::String_mgr value_;
            };

            typedef DDS_DCPSStruct_var<GetParam_Response_> GetParam_Response__var;
            typedef DDS_DCPSStruct_out < GetParam_Response_> GetParam_Response__out;

            struct  Sample_GetParam_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetParam_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetParam_Request_> Sample_GetParam_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetParam_Request_> Sample_GetParam_Request__out;

            struct  Sample_GetParam_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetParam_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetParam_Response_> Sample_GetParam_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetParam_Response_> Sample_GetParam_Response__out;

        }

    }

}

#endif /* _H_69E7421B7060014F0D24982D81F8F92E_GetParam__H_ */
