#ifndef _H_3949F857A423F28F86550A5D098FFE67_ServiceHost_DCPS_H_
#define _H_3949F857A423F28F86550A5D098FFE67_ServiceHost_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceHost_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class ServiceHost_Request_TypeSupportInterface;

            typedef ServiceHost_Request_TypeSupportInterface * ServiceHost_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Request_TypeSupportInterface> ServiceHost_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Request_TypeSupportInterface> ServiceHost_Request_TypeSupportInterface_out;


            class ServiceHost_Request_DataWriter;

            typedef ServiceHost_Request_DataWriter * ServiceHost_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Request_DataWriter> ServiceHost_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Request_DataWriter> ServiceHost_Request_DataWriter_out;


            class ServiceHost_Request_DataReader;

            typedef ServiceHost_Request_DataReader * ServiceHost_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Request_DataReader> ServiceHost_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Request_DataReader> ServiceHost_Request_DataReader_out;


            class ServiceHost_Request_DataReaderView;

            typedef ServiceHost_Request_DataReaderView * ServiceHost_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Request_DataReaderView> ServiceHost_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Request_DataReaderView> ServiceHost_Request_DataReaderView_out;

            struct ServiceHost_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceHost_Request_, struct ServiceHost_Request_Seq_uniq_> ServiceHost_Request_Seq;
            typedef DDS_DCPSSequence_var < ServiceHost_Request_Seq> ServiceHost_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceHost_Request_Seq> ServiceHost_Request_Seq_out;

            class  ServiceHost_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceHost_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceHost_Request_TypeSupportInterface_var _var_type;

                static ServiceHost_Request_TypeSupportInterface_ptr _duplicate (ServiceHost_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceHost_Request_TypeSupportInterface () {};
                ~ServiceHost_Request_TypeSupportInterface () {};
            private:
                ServiceHost_Request_TypeSupportInterface (const ServiceHost_Request_TypeSupportInterface &);
                ServiceHost_Request_TypeSupportInterface & operator = (const ServiceHost_Request_TypeSupportInterface &);
            };

            class  ServiceHost_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceHost_Request_DataWriter_ptr _ptr_type;
                typedef ServiceHost_Request_DataWriter_var _var_type;

                static ServiceHost_Request_DataWriter_ptr _duplicate (ServiceHost_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceHost_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceHost_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceHost_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHost_Request_& instance_data) = 0;

            protected:
                ServiceHost_Request_DataWriter () {};
                ~ServiceHost_Request_DataWriter () {};
            private:
                ServiceHost_Request_DataWriter (const ServiceHost_Request_DataWriter &);
                ServiceHost_Request_DataWriter & operator = (const ServiceHost_Request_DataWriter &);
            };

            class  ServiceHost_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceHost_Request_DataReader_ptr _ptr_type;
                typedef ServiceHost_Request_DataReader_var _var_type;

                static ServiceHost_Request_DataReader_ptr _duplicate (ServiceHost_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceHost_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHost_Request_& instance) = 0;

            protected:
                ServiceHost_Request_DataReader () {};
                ~ServiceHost_Request_DataReader () {};
            private:
                ServiceHost_Request_DataReader (const ServiceHost_Request_DataReader &);
                ServiceHost_Request_DataReader & operator = (const ServiceHost_Request_DataReader &);
            };

            class  ServiceHost_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceHost_Request_DataReaderView_ptr _ptr_type;
                typedef ServiceHost_Request_DataReaderView_var _var_type;

                static ServiceHost_Request_DataReaderView_ptr _duplicate (ServiceHost_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceHost_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHost_Request_& instance) = 0;

            protected:
                ServiceHost_Request_DataReaderView () {};
                ~ServiceHost_Request_DataReaderView () {};
            private:
                ServiceHost_Request_DataReaderView (const ServiceHost_Request_DataReaderView &);
                ServiceHost_Request_DataReaderView & operator = (const ServiceHost_Request_DataReaderView &);
            };
            class ServiceHost_Response_TypeSupportInterface;

            typedef ServiceHost_Response_TypeSupportInterface * ServiceHost_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Response_TypeSupportInterface> ServiceHost_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Response_TypeSupportInterface> ServiceHost_Response_TypeSupportInterface_out;


            class ServiceHost_Response_DataWriter;

            typedef ServiceHost_Response_DataWriter * ServiceHost_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Response_DataWriter> ServiceHost_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Response_DataWriter> ServiceHost_Response_DataWriter_out;


            class ServiceHost_Response_DataReader;

            typedef ServiceHost_Response_DataReader * ServiceHost_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Response_DataReader> ServiceHost_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Response_DataReader> ServiceHost_Response_DataReader_out;


            class ServiceHost_Response_DataReaderView;

            typedef ServiceHost_Response_DataReaderView * ServiceHost_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceHost_Response_DataReaderView> ServiceHost_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceHost_Response_DataReaderView> ServiceHost_Response_DataReaderView_out;

            struct ServiceHost_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceHost_Response_, struct ServiceHost_Response_Seq_uniq_> ServiceHost_Response_Seq;
            typedef DDS_DCPSSequence_var < ServiceHost_Response_Seq> ServiceHost_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceHost_Response_Seq> ServiceHost_Response_Seq_out;

            class  ServiceHost_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceHost_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceHost_Response_TypeSupportInterface_var _var_type;

                static ServiceHost_Response_TypeSupportInterface_ptr _duplicate (ServiceHost_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceHost_Response_TypeSupportInterface () {};
                ~ServiceHost_Response_TypeSupportInterface () {};
            private:
                ServiceHost_Response_TypeSupportInterface (const ServiceHost_Response_TypeSupportInterface &);
                ServiceHost_Response_TypeSupportInterface & operator = (const ServiceHost_Response_TypeSupportInterface &);
            };

            class  ServiceHost_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceHost_Response_DataWriter_ptr _ptr_type;
                typedef ServiceHost_Response_DataWriter_var _var_type;

                static ServiceHost_Response_DataWriter_ptr _duplicate (ServiceHost_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceHost_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceHost_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceHost_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHost_Response_& instance_data) = 0;

            protected:
                ServiceHost_Response_DataWriter () {};
                ~ServiceHost_Response_DataWriter () {};
            private:
                ServiceHost_Response_DataWriter (const ServiceHost_Response_DataWriter &);
                ServiceHost_Response_DataWriter & operator = (const ServiceHost_Response_DataWriter &);
            };

            class  ServiceHost_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceHost_Response_DataReader_ptr _ptr_type;
                typedef ServiceHost_Response_DataReader_var _var_type;

                static ServiceHost_Response_DataReader_ptr _duplicate (ServiceHost_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceHost_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHost_Response_& instance) = 0;

            protected:
                ServiceHost_Response_DataReader () {};
                ~ServiceHost_Response_DataReader () {};
            private:
                ServiceHost_Response_DataReader (const ServiceHost_Response_DataReader &);
                ServiceHost_Response_DataReader & operator = (const ServiceHost_Response_DataReader &);
            };

            class  ServiceHost_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceHost_Response_DataReaderView_ptr _ptr_type;
                typedef ServiceHost_Response_DataReaderView_var _var_type;

                static ServiceHost_Response_DataReaderView_ptr _duplicate (ServiceHost_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceHost_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceHost_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceHost_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceHost_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceHost_Response_& instance) = 0;

            protected:
                ServiceHost_Response_DataReaderView () {};
                ~ServiceHost_Response_DataReaderView () {};
            private:
                ServiceHost_Response_DataReaderView (const ServiceHost_Response_DataReaderView &);
                ServiceHost_Response_DataReaderView & operator = (const ServiceHost_Response_DataReaderView &);
            };
            class Sample_ServiceHost_Request_TypeSupportInterface;

            typedef Sample_ServiceHost_Request_TypeSupportInterface * Sample_ServiceHost_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Request_TypeSupportInterface> Sample_ServiceHost_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Request_TypeSupportInterface> Sample_ServiceHost_Request_TypeSupportInterface_out;


            class Sample_ServiceHost_Request_DataWriter;

            typedef Sample_ServiceHost_Request_DataWriter * Sample_ServiceHost_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Request_DataWriter> Sample_ServiceHost_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Request_DataWriter> Sample_ServiceHost_Request_DataWriter_out;


            class Sample_ServiceHost_Request_DataReader;

            typedef Sample_ServiceHost_Request_DataReader * Sample_ServiceHost_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Request_DataReader> Sample_ServiceHost_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Request_DataReader> Sample_ServiceHost_Request_DataReader_out;


            class Sample_ServiceHost_Request_DataReaderView;

            typedef Sample_ServiceHost_Request_DataReaderView * Sample_ServiceHost_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Request_DataReaderView> Sample_ServiceHost_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Request_DataReaderView> Sample_ServiceHost_Request_DataReaderView_out;

            struct Sample_ServiceHost_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceHost_Request_, struct Sample_ServiceHost_Request_Seq_uniq_> Sample_ServiceHost_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceHost_Request_Seq> Sample_ServiceHost_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceHost_Request_Seq> Sample_ServiceHost_Request_Seq_out;

            class  Sample_ServiceHost_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceHost_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceHost_Request_TypeSupportInterface_var _var_type;

                static Sample_ServiceHost_Request_TypeSupportInterface_ptr _duplicate (Sample_ServiceHost_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceHost_Request_TypeSupportInterface () {};
                ~Sample_ServiceHost_Request_TypeSupportInterface () {};
            private:
                Sample_ServiceHost_Request_TypeSupportInterface (const Sample_ServiceHost_Request_TypeSupportInterface &);
                Sample_ServiceHost_Request_TypeSupportInterface & operator = (const Sample_ServiceHost_Request_TypeSupportInterface &);
            };

            class  Sample_ServiceHost_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceHost_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceHost_Request_DataWriter_var _var_type;

                static Sample_ServiceHost_Request_DataWriter_ptr _duplicate (Sample_ServiceHost_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceHost_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceHost_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceHost_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceHost_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceHost_Request_& instance_data) = 0;

            protected:
                Sample_ServiceHost_Request_DataWriter () {};
                ~Sample_ServiceHost_Request_DataWriter () {};
            private:
                Sample_ServiceHost_Request_DataWriter (const Sample_ServiceHost_Request_DataWriter &);
                Sample_ServiceHost_Request_DataWriter & operator = (const Sample_ServiceHost_Request_DataWriter &);
            };

            class  Sample_ServiceHost_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceHost_Request_DataReader_ptr _ptr_type;
                typedef Sample_ServiceHost_Request_DataReader_var _var_type;

                static Sample_ServiceHost_Request_DataReader_ptr _duplicate (Sample_ServiceHost_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceHost_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceHost_Request_& instance) = 0;

            protected:
                Sample_ServiceHost_Request_DataReader () {};
                ~Sample_ServiceHost_Request_DataReader () {};
            private:
                Sample_ServiceHost_Request_DataReader (const Sample_ServiceHost_Request_DataReader &);
                Sample_ServiceHost_Request_DataReader & operator = (const Sample_ServiceHost_Request_DataReader &);
            };

            class  Sample_ServiceHost_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceHost_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceHost_Request_DataReaderView_var _var_type;

                static Sample_ServiceHost_Request_DataReaderView_ptr _duplicate (Sample_ServiceHost_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceHost_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceHost_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceHost_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceHost_Request_& instance) = 0;

            protected:
                Sample_ServiceHost_Request_DataReaderView () {};
                ~Sample_ServiceHost_Request_DataReaderView () {};
            private:
                Sample_ServiceHost_Request_DataReaderView (const Sample_ServiceHost_Request_DataReaderView &);
                Sample_ServiceHost_Request_DataReaderView & operator = (const Sample_ServiceHost_Request_DataReaderView &);
            };
            class Sample_ServiceHost_Response_TypeSupportInterface;

            typedef Sample_ServiceHost_Response_TypeSupportInterface * Sample_ServiceHost_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Response_TypeSupportInterface> Sample_ServiceHost_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Response_TypeSupportInterface> Sample_ServiceHost_Response_TypeSupportInterface_out;


            class Sample_ServiceHost_Response_DataWriter;

            typedef Sample_ServiceHost_Response_DataWriter * Sample_ServiceHost_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Response_DataWriter> Sample_ServiceHost_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Response_DataWriter> Sample_ServiceHost_Response_DataWriter_out;


            class Sample_ServiceHost_Response_DataReader;

            typedef Sample_ServiceHost_Response_DataReader * Sample_ServiceHost_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Response_DataReader> Sample_ServiceHost_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Response_DataReader> Sample_ServiceHost_Response_DataReader_out;


            class Sample_ServiceHost_Response_DataReaderView;

            typedef Sample_ServiceHost_Response_DataReaderView * Sample_ServiceHost_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceHost_Response_DataReaderView> Sample_ServiceHost_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceHost_Response_DataReaderView> Sample_ServiceHost_Response_DataReaderView_out;

            struct Sample_ServiceHost_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceHost_Response_, struct Sample_ServiceHost_Response_Seq_uniq_> Sample_ServiceHost_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceHost_Response_Seq> Sample_ServiceHost_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceHost_Response_Seq> Sample_ServiceHost_Response_Seq_out;

            class  Sample_ServiceHost_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceHost_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceHost_Response_TypeSupportInterface_var _var_type;

                static Sample_ServiceHost_Response_TypeSupportInterface_ptr _duplicate (Sample_ServiceHost_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceHost_Response_TypeSupportInterface () {};
                ~Sample_ServiceHost_Response_TypeSupportInterface () {};
            private:
                Sample_ServiceHost_Response_TypeSupportInterface (const Sample_ServiceHost_Response_TypeSupportInterface &);
                Sample_ServiceHost_Response_TypeSupportInterface & operator = (const Sample_ServiceHost_Response_TypeSupportInterface &);
            };

            class  Sample_ServiceHost_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceHost_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceHost_Response_DataWriter_var _var_type;

                static Sample_ServiceHost_Response_DataWriter_ptr _duplicate (Sample_ServiceHost_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceHost_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceHost_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceHost_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceHost_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceHost_Response_& instance_data) = 0;

            protected:
                Sample_ServiceHost_Response_DataWriter () {};
                ~Sample_ServiceHost_Response_DataWriter () {};
            private:
                Sample_ServiceHost_Response_DataWriter (const Sample_ServiceHost_Response_DataWriter &);
                Sample_ServiceHost_Response_DataWriter & operator = (const Sample_ServiceHost_Response_DataWriter &);
            };

            class  Sample_ServiceHost_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceHost_Response_DataReader_ptr _ptr_type;
                typedef Sample_ServiceHost_Response_DataReader_var _var_type;

                static Sample_ServiceHost_Response_DataReader_ptr _duplicate (Sample_ServiceHost_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceHost_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceHost_Response_& instance) = 0;

            protected:
                Sample_ServiceHost_Response_DataReader () {};
                ~Sample_ServiceHost_Response_DataReader () {};
            private:
                Sample_ServiceHost_Response_DataReader (const Sample_ServiceHost_Response_DataReader &);
                Sample_ServiceHost_Response_DataReader & operator = (const Sample_ServiceHost_Response_DataReader &);
            };

            class  Sample_ServiceHost_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceHost_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceHost_Response_DataReaderView_var _var_type;

                static Sample_ServiceHost_Response_DataReaderView_ptr _duplicate (Sample_ServiceHost_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceHost_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceHost_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceHost_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceHost_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceHost_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceHost_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceHost_Response_& instance) = 0;

            protected:
                Sample_ServiceHost_Response_DataReaderView () {};
                ~Sample_ServiceHost_Response_DataReaderView () {};
            private:
                Sample_ServiceHost_Response_DataReaderView (const Sample_ServiceHost_Response_DataReaderView &);
                Sample_ServiceHost_Response_DataReaderView & operator = (const Sample_ServiceHost_Response_DataReaderView &);
            };
        }

    }

}

#endif
