#ifndef _H_4818C23DB260717E683CC5FD1FF91DB1_ServiceResponseDetails_DCPS_H_
#define _H_4818C23DB260717E683CC5FD1FF91DB1_ServiceResponseDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceResponseDetails_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class ServiceResponseDetails_Request_TypeSupportInterface;

            typedef ServiceResponseDetails_Request_TypeSupportInterface * ServiceResponseDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Request_TypeSupportInterface> ServiceResponseDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Request_TypeSupportInterface> ServiceResponseDetails_Request_TypeSupportInterface_out;


            class ServiceResponseDetails_Request_DataWriter;

            typedef ServiceResponseDetails_Request_DataWriter * ServiceResponseDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Request_DataWriter> ServiceResponseDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Request_DataWriter> ServiceResponseDetails_Request_DataWriter_out;


            class ServiceResponseDetails_Request_DataReader;

            typedef ServiceResponseDetails_Request_DataReader * ServiceResponseDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Request_DataReader> ServiceResponseDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Request_DataReader> ServiceResponseDetails_Request_DataReader_out;


            class ServiceResponseDetails_Request_DataReaderView;

            typedef ServiceResponseDetails_Request_DataReaderView * ServiceResponseDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Request_DataReaderView> ServiceResponseDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Request_DataReaderView> ServiceResponseDetails_Request_DataReaderView_out;

            struct ServiceResponseDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceResponseDetails_Request_, struct ServiceResponseDetails_Request_Seq_uniq_> ServiceResponseDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < ServiceResponseDetails_Request_Seq> ServiceResponseDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceResponseDetails_Request_Seq> ServiceResponseDetails_Request_Seq_out;

            class  ServiceResponseDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceResponseDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceResponseDetails_Request_TypeSupportInterface_var _var_type;

                static ServiceResponseDetails_Request_TypeSupportInterface_ptr _duplicate (ServiceResponseDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceResponseDetails_Request_TypeSupportInterface () {};
                ~ServiceResponseDetails_Request_TypeSupportInterface () {};
            private:
                ServiceResponseDetails_Request_TypeSupportInterface (const ServiceResponseDetails_Request_TypeSupportInterface &);
                ServiceResponseDetails_Request_TypeSupportInterface & operator = (const ServiceResponseDetails_Request_TypeSupportInterface &);
            };

            class  ServiceResponseDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceResponseDetails_Request_DataWriter_ptr _ptr_type;
                typedef ServiceResponseDetails_Request_DataWriter_var _var_type;

                static ServiceResponseDetails_Request_DataWriter_ptr _duplicate (ServiceResponseDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceResponseDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceResponseDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceResponseDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceResponseDetails_Request_& instance_data) = 0;

            protected:
                ServiceResponseDetails_Request_DataWriter () {};
                ~ServiceResponseDetails_Request_DataWriter () {};
            private:
                ServiceResponseDetails_Request_DataWriter (const ServiceResponseDetails_Request_DataWriter &);
                ServiceResponseDetails_Request_DataWriter & operator = (const ServiceResponseDetails_Request_DataWriter &);
            };

            class  ServiceResponseDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceResponseDetails_Request_DataReader_ptr _ptr_type;
                typedef ServiceResponseDetails_Request_DataReader_var _var_type;

                static ServiceResponseDetails_Request_DataReader_ptr _duplicate (ServiceResponseDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceResponseDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceResponseDetails_Request_& instance) = 0;

            protected:
                ServiceResponseDetails_Request_DataReader () {};
                ~ServiceResponseDetails_Request_DataReader () {};
            private:
                ServiceResponseDetails_Request_DataReader (const ServiceResponseDetails_Request_DataReader &);
                ServiceResponseDetails_Request_DataReader & operator = (const ServiceResponseDetails_Request_DataReader &);
            };

            class  ServiceResponseDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceResponseDetails_Request_DataReaderView_ptr _ptr_type;
                typedef ServiceResponseDetails_Request_DataReaderView_var _var_type;

                static ServiceResponseDetails_Request_DataReaderView_ptr _duplicate (ServiceResponseDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceResponseDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceResponseDetails_Request_& instance) = 0;

            protected:
                ServiceResponseDetails_Request_DataReaderView () {};
                ~ServiceResponseDetails_Request_DataReaderView () {};
            private:
                ServiceResponseDetails_Request_DataReaderView (const ServiceResponseDetails_Request_DataReaderView &);
                ServiceResponseDetails_Request_DataReaderView & operator = (const ServiceResponseDetails_Request_DataReaderView &);
            };
            class ServiceResponseDetails_Response_TypeSupportInterface;

            typedef ServiceResponseDetails_Response_TypeSupportInterface * ServiceResponseDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Response_TypeSupportInterface> ServiceResponseDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Response_TypeSupportInterface> ServiceResponseDetails_Response_TypeSupportInterface_out;


            class ServiceResponseDetails_Response_DataWriter;

            typedef ServiceResponseDetails_Response_DataWriter * ServiceResponseDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Response_DataWriter> ServiceResponseDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Response_DataWriter> ServiceResponseDetails_Response_DataWriter_out;


            class ServiceResponseDetails_Response_DataReader;

            typedef ServiceResponseDetails_Response_DataReader * ServiceResponseDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Response_DataReader> ServiceResponseDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Response_DataReader> ServiceResponseDetails_Response_DataReader_out;


            class ServiceResponseDetails_Response_DataReaderView;

            typedef ServiceResponseDetails_Response_DataReaderView * ServiceResponseDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceResponseDetails_Response_DataReaderView> ServiceResponseDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceResponseDetails_Response_DataReaderView> ServiceResponseDetails_Response_DataReaderView_out;

            struct ServiceResponseDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceResponseDetails_Response_, struct ServiceResponseDetails_Response_Seq_uniq_> ServiceResponseDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < ServiceResponseDetails_Response_Seq> ServiceResponseDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceResponseDetails_Response_Seq> ServiceResponseDetails_Response_Seq_out;

            class  ServiceResponseDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceResponseDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceResponseDetails_Response_TypeSupportInterface_var _var_type;

                static ServiceResponseDetails_Response_TypeSupportInterface_ptr _duplicate (ServiceResponseDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceResponseDetails_Response_TypeSupportInterface () {};
                ~ServiceResponseDetails_Response_TypeSupportInterface () {};
            private:
                ServiceResponseDetails_Response_TypeSupportInterface (const ServiceResponseDetails_Response_TypeSupportInterface &);
                ServiceResponseDetails_Response_TypeSupportInterface & operator = (const ServiceResponseDetails_Response_TypeSupportInterface &);
            };

            class  ServiceResponseDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceResponseDetails_Response_DataWriter_ptr _ptr_type;
                typedef ServiceResponseDetails_Response_DataWriter_var _var_type;

                static ServiceResponseDetails_Response_DataWriter_ptr _duplicate (ServiceResponseDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceResponseDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceResponseDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceResponseDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceResponseDetails_Response_& instance_data) = 0;

            protected:
                ServiceResponseDetails_Response_DataWriter () {};
                ~ServiceResponseDetails_Response_DataWriter () {};
            private:
                ServiceResponseDetails_Response_DataWriter (const ServiceResponseDetails_Response_DataWriter &);
                ServiceResponseDetails_Response_DataWriter & operator = (const ServiceResponseDetails_Response_DataWriter &);
            };

            class  ServiceResponseDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceResponseDetails_Response_DataReader_ptr _ptr_type;
                typedef ServiceResponseDetails_Response_DataReader_var _var_type;

                static ServiceResponseDetails_Response_DataReader_ptr _duplicate (ServiceResponseDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceResponseDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceResponseDetails_Response_& instance) = 0;

            protected:
                ServiceResponseDetails_Response_DataReader () {};
                ~ServiceResponseDetails_Response_DataReader () {};
            private:
                ServiceResponseDetails_Response_DataReader (const ServiceResponseDetails_Response_DataReader &);
                ServiceResponseDetails_Response_DataReader & operator = (const ServiceResponseDetails_Response_DataReader &);
            };

            class  ServiceResponseDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceResponseDetails_Response_DataReaderView_ptr _ptr_type;
                typedef ServiceResponseDetails_Response_DataReaderView_var _var_type;

                static ServiceResponseDetails_Response_DataReaderView_ptr _duplicate (ServiceResponseDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceResponseDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceResponseDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceResponseDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceResponseDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceResponseDetails_Response_& instance) = 0;

            protected:
                ServiceResponseDetails_Response_DataReaderView () {};
                ~ServiceResponseDetails_Response_DataReaderView () {};
            private:
                ServiceResponseDetails_Response_DataReaderView (const ServiceResponseDetails_Response_DataReaderView &);
                ServiceResponseDetails_Response_DataReaderView & operator = (const ServiceResponseDetails_Response_DataReaderView &);
            };
            class Sample_ServiceResponseDetails_Request_TypeSupportInterface;

            typedef Sample_ServiceResponseDetails_Request_TypeSupportInterface * Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Request_TypeSupportInterface> Sample_ServiceResponseDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Request_TypeSupportInterface> Sample_ServiceResponseDetails_Request_TypeSupportInterface_out;


            class Sample_ServiceResponseDetails_Request_DataWriter;

            typedef Sample_ServiceResponseDetails_Request_DataWriter * Sample_ServiceResponseDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Request_DataWriter> Sample_ServiceResponseDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Request_DataWriter> Sample_ServiceResponseDetails_Request_DataWriter_out;


            class Sample_ServiceResponseDetails_Request_DataReader;

            typedef Sample_ServiceResponseDetails_Request_DataReader * Sample_ServiceResponseDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Request_DataReader> Sample_ServiceResponseDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Request_DataReader> Sample_ServiceResponseDetails_Request_DataReader_out;


            class Sample_ServiceResponseDetails_Request_DataReaderView;

            typedef Sample_ServiceResponseDetails_Request_DataReaderView * Sample_ServiceResponseDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Request_DataReaderView> Sample_ServiceResponseDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Request_DataReaderView> Sample_ServiceResponseDetails_Request_DataReaderView_out;

            struct Sample_ServiceResponseDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceResponseDetails_Request_, struct Sample_ServiceResponseDetails_Request_Seq_uniq_> Sample_ServiceResponseDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceResponseDetails_Request_Seq> Sample_ServiceResponseDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceResponseDetails_Request_Seq> Sample_ServiceResponseDetails_Request_Seq_out;

            class  Sample_ServiceResponseDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceResponseDetails_Request_TypeSupportInterface () {};
                ~Sample_ServiceResponseDetails_Request_TypeSupportInterface () {};
            private:
                Sample_ServiceResponseDetails_Request_TypeSupportInterface (const Sample_ServiceResponseDetails_Request_TypeSupportInterface &);
                Sample_ServiceResponseDetails_Request_TypeSupportInterface & operator = (const Sample_ServiceResponseDetails_Request_TypeSupportInterface &);
            };

            class  Sample_ServiceResponseDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceResponseDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Request_DataWriter_var _var_type;

                static Sample_ServiceResponseDetails_Request_DataWriter_ptr _duplicate (Sample_ServiceResponseDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceResponseDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceResponseDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceResponseDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceResponseDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceResponseDetails_Request_& instance_data) = 0;

            protected:
                Sample_ServiceResponseDetails_Request_DataWriter () {};
                ~Sample_ServiceResponseDetails_Request_DataWriter () {};
            private:
                Sample_ServiceResponseDetails_Request_DataWriter (const Sample_ServiceResponseDetails_Request_DataWriter &);
                Sample_ServiceResponseDetails_Request_DataWriter & operator = (const Sample_ServiceResponseDetails_Request_DataWriter &);
            };

            class  Sample_ServiceResponseDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceResponseDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Request_DataReader_var _var_type;

                static Sample_ServiceResponseDetails_Request_DataReader_ptr _duplicate (Sample_ServiceResponseDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceResponseDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceResponseDetails_Request_& instance) = 0;

            protected:
                Sample_ServiceResponseDetails_Request_DataReader () {};
                ~Sample_ServiceResponseDetails_Request_DataReader () {};
            private:
                Sample_ServiceResponseDetails_Request_DataReader (const Sample_ServiceResponseDetails_Request_DataReader &);
                Sample_ServiceResponseDetails_Request_DataReader & operator = (const Sample_ServiceResponseDetails_Request_DataReader &);
            };

            class  Sample_ServiceResponseDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceResponseDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Request_DataReaderView_var _var_type;

                static Sample_ServiceResponseDetails_Request_DataReaderView_ptr _duplicate (Sample_ServiceResponseDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceResponseDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceResponseDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceResponseDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceResponseDetails_Request_& instance) = 0;

            protected:
                Sample_ServiceResponseDetails_Request_DataReaderView () {};
                ~Sample_ServiceResponseDetails_Request_DataReaderView () {};
            private:
                Sample_ServiceResponseDetails_Request_DataReaderView (const Sample_ServiceResponseDetails_Request_DataReaderView &);
                Sample_ServiceResponseDetails_Request_DataReaderView & operator = (const Sample_ServiceResponseDetails_Request_DataReaderView &);
            };
            class Sample_ServiceResponseDetails_Response_TypeSupportInterface;

            typedef Sample_ServiceResponseDetails_Response_TypeSupportInterface * Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Response_TypeSupportInterface> Sample_ServiceResponseDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Response_TypeSupportInterface> Sample_ServiceResponseDetails_Response_TypeSupportInterface_out;


            class Sample_ServiceResponseDetails_Response_DataWriter;

            typedef Sample_ServiceResponseDetails_Response_DataWriter * Sample_ServiceResponseDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Response_DataWriter> Sample_ServiceResponseDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Response_DataWriter> Sample_ServiceResponseDetails_Response_DataWriter_out;


            class Sample_ServiceResponseDetails_Response_DataReader;

            typedef Sample_ServiceResponseDetails_Response_DataReader * Sample_ServiceResponseDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Response_DataReader> Sample_ServiceResponseDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Response_DataReader> Sample_ServiceResponseDetails_Response_DataReader_out;


            class Sample_ServiceResponseDetails_Response_DataReaderView;

            typedef Sample_ServiceResponseDetails_Response_DataReaderView * Sample_ServiceResponseDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceResponseDetails_Response_DataReaderView> Sample_ServiceResponseDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceResponseDetails_Response_DataReaderView> Sample_ServiceResponseDetails_Response_DataReaderView_out;

            struct Sample_ServiceResponseDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceResponseDetails_Response_, struct Sample_ServiceResponseDetails_Response_Seq_uniq_> Sample_ServiceResponseDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceResponseDetails_Response_Seq> Sample_ServiceResponseDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceResponseDetails_Response_Seq> Sample_ServiceResponseDetails_Response_Seq_out;

            class  Sample_ServiceResponseDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceResponseDetails_Response_TypeSupportInterface () {};
                ~Sample_ServiceResponseDetails_Response_TypeSupportInterface () {};
            private:
                Sample_ServiceResponseDetails_Response_TypeSupportInterface (const Sample_ServiceResponseDetails_Response_TypeSupportInterface &);
                Sample_ServiceResponseDetails_Response_TypeSupportInterface & operator = (const Sample_ServiceResponseDetails_Response_TypeSupportInterface &);
            };

            class  Sample_ServiceResponseDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceResponseDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Response_DataWriter_var _var_type;

                static Sample_ServiceResponseDetails_Response_DataWriter_ptr _duplicate (Sample_ServiceResponseDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceResponseDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceResponseDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceResponseDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceResponseDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceResponseDetails_Response_& instance_data) = 0;

            protected:
                Sample_ServiceResponseDetails_Response_DataWriter () {};
                ~Sample_ServiceResponseDetails_Response_DataWriter () {};
            private:
                Sample_ServiceResponseDetails_Response_DataWriter (const Sample_ServiceResponseDetails_Response_DataWriter &);
                Sample_ServiceResponseDetails_Response_DataWriter & operator = (const Sample_ServiceResponseDetails_Response_DataWriter &);
            };

            class  Sample_ServiceResponseDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceResponseDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Response_DataReader_var _var_type;

                static Sample_ServiceResponseDetails_Response_DataReader_ptr _duplicate (Sample_ServiceResponseDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceResponseDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceResponseDetails_Response_& instance) = 0;

            protected:
                Sample_ServiceResponseDetails_Response_DataReader () {};
                ~Sample_ServiceResponseDetails_Response_DataReader () {};
            private:
                Sample_ServiceResponseDetails_Response_DataReader (const Sample_ServiceResponseDetails_Response_DataReader &);
                Sample_ServiceResponseDetails_Response_DataReader & operator = (const Sample_ServiceResponseDetails_Response_DataReader &);
            };

            class  Sample_ServiceResponseDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceResponseDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceResponseDetails_Response_DataReaderView_var _var_type;

                static Sample_ServiceResponseDetails_Response_DataReaderView_ptr _duplicate (Sample_ServiceResponseDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceResponseDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceResponseDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceResponseDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceResponseDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceResponseDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceResponseDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceResponseDetails_Response_& instance) = 0;

            protected:
                Sample_ServiceResponseDetails_Response_DataReaderView () {};
                ~Sample_ServiceResponseDetails_Response_DataReaderView () {};
            private:
                Sample_ServiceResponseDetails_Response_DataReaderView (const Sample_ServiceResponseDetails_Response_DataReaderView &);
                Sample_ServiceResponseDetails_Response_DataReaderView & operator = (const Sample_ServiceResponseDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
