#ifndef _H_FA8E67E2D109ACD3D4F76EF35A09ABCE_ServiceType__H_
#define _H_FA8E67E2D109ACD3D4F76EF35A09ABCE_ServiceType__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  ServiceType_Request_
            {
                ::DDS::String_mgr service_;
            };

            typedef DDS_DCPSStruct_var<ServiceType_Request_> ServiceType_Request__var;
            typedef DDS_DCPSStruct_out < ServiceType_Request_> ServiceType_Request__out;

            struct  ServiceType_Response_
            {
                ::DDS::String_mgr type_;
            };

            typedef DDS_DCPSStruct_var<ServiceType_Response_> ServiceType_Response__var;
            typedef DDS_DCPSStruct_out < ServiceType_Response_> ServiceType_Response__out;

            struct  Sample_ServiceType_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceType_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceType_Request_> Sample_ServiceType_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceType_Request_> Sample_ServiceType_Request__out;

            struct  Sample_ServiceType_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceType_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceType_Response_> Sample_ServiceType_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceType_Response_> Sample_ServiceType_Response__out;

        }

    }

}

#endif /* _H_FA8E67E2D109ACD3D4F76EF35A09ABCE_ServiceType__H_ */
