#ifndef _H_FA8E67E2D109ACD3D4F76EF35A09ABCE_ServiceType_DCPS_H_
#define _H_FA8E67E2D109ACD3D4F76EF35A09ABCE_ServiceType_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceType_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class ServiceType_Request_TypeSupportInterface;

            typedef ServiceType_Request_TypeSupportInterface * ServiceType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Request_TypeSupportInterface> ServiceType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceType_Request_TypeSupportInterface> ServiceType_Request_TypeSupportInterface_out;


            class ServiceType_Request_DataWriter;

            typedef ServiceType_Request_DataWriter * ServiceType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Request_DataWriter> ServiceType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceType_Request_DataWriter> ServiceType_Request_DataWriter_out;


            class ServiceType_Request_DataReader;

            typedef ServiceType_Request_DataReader * ServiceType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Request_DataReader> ServiceType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceType_Request_DataReader> ServiceType_Request_DataReader_out;


            class ServiceType_Request_DataReaderView;

            typedef ServiceType_Request_DataReaderView * ServiceType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Request_DataReaderView> ServiceType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceType_Request_DataReaderView> ServiceType_Request_DataReaderView_out;

            struct ServiceType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceType_Request_, struct ServiceType_Request_Seq_uniq_> ServiceType_Request_Seq;
            typedef DDS_DCPSSequence_var < ServiceType_Request_Seq> ServiceType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceType_Request_Seq> ServiceType_Request_Seq_out;

            class  ServiceType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceType_Request_TypeSupportInterface_var _var_type;

                static ServiceType_Request_TypeSupportInterface_ptr _duplicate (ServiceType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceType_Request_TypeSupportInterface () {};
                ~ServiceType_Request_TypeSupportInterface () {};
            private:
                ServiceType_Request_TypeSupportInterface (const ServiceType_Request_TypeSupportInterface &);
                ServiceType_Request_TypeSupportInterface & operator = (const ServiceType_Request_TypeSupportInterface &);
            };

            class  ServiceType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceType_Request_DataWriter_ptr _ptr_type;
                typedef ServiceType_Request_DataWriter_var _var_type;

                static ServiceType_Request_DataWriter_ptr _duplicate (ServiceType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceType_Request_& instance_data) = 0;

            protected:
                ServiceType_Request_DataWriter () {};
                ~ServiceType_Request_DataWriter () {};
            private:
                ServiceType_Request_DataWriter (const ServiceType_Request_DataWriter &);
                ServiceType_Request_DataWriter & operator = (const ServiceType_Request_DataWriter &);
            };

            class  ServiceType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceType_Request_DataReader_ptr _ptr_type;
                typedef ServiceType_Request_DataReader_var _var_type;

                static ServiceType_Request_DataReader_ptr _duplicate (ServiceType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceType_Request_& instance) = 0;

            protected:
                ServiceType_Request_DataReader () {};
                ~ServiceType_Request_DataReader () {};
            private:
                ServiceType_Request_DataReader (const ServiceType_Request_DataReader &);
                ServiceType_Request_DataReader & operator = (const ServiceType_Request_DataReader &);
            };

            class  ServiceType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceType_Request_DataReaderView_ptr _ptr_type;
                typedef ServiceType_Request_DataReaderView_var _var_type;

                static ServiceType_Request_DataReaderView_ptr _duplicate (ServiceType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceType_Request_& instance) = 0;

            protected:
                ServiceType_Request_DataReaderView () {};
                ~ServiceType_Request_DataReaderView () {};
            private:
                ServiceType_Request_DataReaderView (const ServiceType_Request_DataReaderView &);
                ServiceType_Request_DataReaderView & operator = (const ServiceType_Request_DataReaderView &);
            };
            class ServiceType_Response_TypeSupportInterface;

            typedef ServiceType_Response_TypeSupportInterface * ServiceType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Response_TypeSupportInterface> ServiceType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceType_Response_TypeSupportInterface> ServiceType_Response_TypeSupportInterface_out;


            class ServiceType_Response_DataWriter;

            typedef ServiceType_Response_DataWriter * ServiceType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Response_DataWriter> ServiceType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceType_Response_DataWriter> ServiceType_Response_DataWriter_out;


            class ServiceType_Response_DataReader;

            typedef ServiceType_Response_DataReader * ServiceType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Response_DataReader> ServiceType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceType_Response_DataReader> ServiceType_Response_DataReader_out;


            class ServiceType_Response_DataReaderView;

            typedef ServiceType_Response_DataReaderView * ServiceType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceType_Response_DataReaderView> ServiceType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceType_Response_DataReaderView> ServiceType_Response_DataReaderView_out;

            struct ServiceType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceType_Response_, struct ServiceType_Response_Seq_uniq_> ServiceType_Response_Seq;
            typedef DDS_DCPSSequence_var < ServiceType_Response_Seq> ServiceType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceType_Response_Seq> ServiceType_Response_Seq_out;

            class  ServiceType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceType_Response_TypeSupportInterface_var _var_type;

                static ServiceType_Response_TypeSupportInterface_ptr _duplicate (ServiceType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceType_Response_TypeSupportInterface () {};
                ~ServiceType_Response_TypeSupportInterface () {};
            private:
                ServiceType_Response_TypeSupportInterface (const ServiceType_Response_TypeSupportInterface &);
                ServiceType_Response_TypeSupportInterface & operator = (const ServiceType_Response_TypeSupportInterface &);
            };

            class  ServiceType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceType_Response_DataWriter_ptr _ptr_type;
                typedef ServiceType_Response_DataWriter_var _var_type;

                static ServiceType_Response_DataWriter_ptr _duplicate (ServiceType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceType_Response_& instance_data) = 0;

            protected:
                ServiceType_Response_DataWriter () {};
                ~ServiceType_Response_DataWriter () {};
            private:
                ServiceType_Response_DataWriter (const ServiceType_Response_DataWriter &);
                ServiceType_Response_DataWriter & operator = (const ServiceType_Response_DataWriter &);
            };

            class  ServiceType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceType_Response_DataReader_ptr _ptr_type;
                typedef ServiceType_Response_DataReader_var _var_type;

                static ServiceType_Response_DataReader_ptr _duplicate (ServiceType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceType_Response_& instance) = 0;

            protected:
                ServiceType_Response_DataReader () {};
                ~ServiceType_Response_DataReader () {};
            private:
                ServiceType_Response_DataReader (const ServiceType_Response_DataReader &);
                ServiceType_Response_DataReader & operator = (const ServiceType_Response_DataReader &);
            };

            class  ServiceType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceType_Response_DataReaderView_ptr _ptr_type;
                typedef ServiceType_Response_DataReaderView_var _var_type;

                static ServiceType_Response_DataReaderView_ptr _duplicate (ServiceType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceType_Response_& instance) = 0;

            protected:
                ServiceType_Response_DataReaderView () {};
                ~ServiceType_Response_DataReaderView () {};
            private:
                ServiceType_Response_DataReaderView (const ServiceType_Response_DataReaderView &);
                ServiceType_Response_DataReaderView & operator = (const ServiceType_Response_DataReaderView &);
            };
            class Sample_ServiceType_Request_TypeSupportInterface;

            typedef Sample_ServiceType_Request_TypeSupportInterface * Sample_ServiceType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Request_TypeSupportInterface> Sample_ServiceType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Request_TypeSupportInterface> Sample_ServiceType_Request_TypeSupportInterface_out;


            class Sample_ServiceType_Request_DataWriter;

            typedef Sample_ServiceType_Request_DataWriter * Sample_ServiceType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Request_DataWriter> Sample_ServiceType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Request_DataWriter> Sample_ServiceType_Request_DataWriter_out;


            class Sample_ServiceType_Request_DataReader;

            typedef Sample_ServiceType_Request_DataReader * Sample_ServiceType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Request_DataReader> Sample_ServiceType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Request_DataReader> Sample_ServiceType_Request_DataReader_out;


            class Sample_ServiceType_Request_DataReaderView;

            typedef Sample_ServiceType_Request_DataReaderView * Sample_ServiceType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Request_DataReaderView> Sample_ServiceType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Request_DataReaderView> Sample_ServiceType_Request_DataReaderView_out;

            struct Sample_ServiceType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceType_Request_, struct Sample_ServiceType_Request_Seq_uniq_> Sample_ServiceType_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceType_Request_Seq> Sample_ServiceType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceType_Request_Seq> Sample_ServiceType_Request_Seq_out;

            class  Sample_ServiceType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceType_Request_TypeSupportInterface_var _var_type;

                static Sample_ServiceType_Request_TypeSupportInterface_ptr _duplicate (Sample_ServiceType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceType_Request_TypeSupportInterface () {};
                ~Sample_ServiceType_Request_TypeSupportInterface () {};
            private:
                Sample_ServiceType_Request_TypeSupportInterface (const Sample_ServiceType_Request_TypeSupportInterface &);
                Sample_ServiceType_Request_TypeSupportInterface & operator = (const Sample_ServiceType_Request_TypeSupportInterface &);
            };

            class  Sample_ServiceType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceType_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceType_Request_DataWriter_var _var_type;

                static Sample_ServiceType_Request_DataWriter_ptr _duplicate (Sample_ServiceType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceType_Request_& instance_data) = 0;

            protected:
                Sample_ServiceType_Request_DataWriter () {};
                ~Sample_ServiceType_Request_DataWriter () {};
            private:
                Sample_ServiceType_Request_DataWriter (const Sample_ServiceType_Request_DataWriter &);
                Sample_ServiceType_Request_DataWriter & operator = (const Sample_ServiceType_Request_DataWriter &);
            };

            class  Sample_ServiceType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceType_Request_DataReader_ptr _ptr_type;
                typedef Sample_ServiceType_Request_DataReader_var _var_type;

                static Sample_ServiceType_Request_DataReader_ptr _duplicate (Sample_ServiceType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceType_Request_& instance) = 0;

            protected:
                Sample_ServiceType_Request_DataReader () {};
                ~Sample_ServiceType_Request_DataReader () {};
            private:
                Sample_ServiceType_Request_DataReader (const Sample_ServiceType_Request_DataReader &);
                Sample_ServiceType_Request_DataReader & operator = (const Sample_ServiceType_Request_DataReader &);
            };

            class  Sample_ServiceType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceType_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceType_Request_DataReaderView_var _var_type;

                static Sample_ServiceType_Request_DataReaderView_ptr _duplicate (Sample_ServiceType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceType_Request_& instance) = 0;

            protected:
                Sample_ServiceType_Request_DataReaderView () {};
                ~Sample_ServiceType_Request_DataReaderView () {};
            private:
                Sample_ServiceType_Request_DataReaderView (const Sample_ServiceType_Request_DataReaderView &);
                Sample_ServiceType_Request_DataReaderView & operator = (const Sample_ServiceType_Request_DataReaderView &);
            };
            class Sample_ServiceType_Response_TypeSupportInterface;

            typedef Sample_ServiceType_Response_TypeSupportInterface * Sample_ServiceType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Response_TypeSupportInterface> Sample_ServiceType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Response_TypeSupportInterface> Sample_ServiceType_Response_TypeSupportInterface_out;


            class Sample_ServiceType_Response_DataWriter;

            typedef Sample_ServiceType_Response_DataWriter * Sample_ServiceType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Response_DataWriter> Sample_ServiceType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Response_DataWriter> Sample_ServiceType_Response_DataWriter_out;


            class Sample_ServiceType_Response_DataReader;

            typedef Sample_ServiceType_Response_DataReader * Sample_ServiceType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Response_DataReader> Sample_ServiceType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Response_DataReader> Sample_ServiceType_Response_DataReader_out;


            class Sample_ServiceType_Response_DataReaderView;

            typedef Sample_ServiceType_Response_DataReaderView * Sample_ServiceType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceType_Response_DataReaderView> Sample_ServiceType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceType_Response_DataReaderView> Sample_ServiceType_Response_DataReaderView_out;

            struct Sample_ServiceType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceType_Response_, struct Sample_ServiceType_Response_Seq_uniq_> Sample_ServiceType_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceType_Response_Seq> Sample_ServiceType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceType_Response_Seq> Sample_ServiceType_Response_Seq_out;

            class  Sample_ServiceType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceType_Response_TypeSupportInterface_var _var_type;

                static Sample_ServiceType_Response_TypeSupportInterface_ptr _duplicate (Sample_ServiceType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceType_Response_TypeSupportInterface () {};
                ~Sample_ServiceType_Response_TypeSupportInterface () {};
            private:
                Sample_ServiceType_Response_TypeSupportInterface (const Sample_ServiceType_Response_TypeSupportInterface &);
                Sample_ServiceType_Response_TypeSupportInterface & operator = (const Sample_ServiceType_Response_TypeSupportInterface &);
            };

            class  Sample_ServiceType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceType_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceType_Response_DataWriter_var _var_type;

                static Sample_ServiceType_Response_DataWriter_ptr _duplicate (Sample_ServiceType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceType_Response_& instance_data) = 0;

            protected:
                Sample_ServiceType_Response_DataWriter () {};
                ~Sample_ServiceType_Response_DataWriter () {};
            private:
                Sample_ServiceType_Response_DataWriter (const Sample_ServiceType_Response_DataWriter &);
                Sample_ServiceType_Response_DataWriter & operator = (const Sample_ServiceType_Response_DataWriter &);
            };

            class  Sample_ServiceType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceType_Response_DataReader_ptr _ptr_type;
                typedef Sample_ServiceType_Response_DataReader_var _var_type;

                static Sample_ServiceType_Response_DataReader_ptr _duplicate (Sample_ServiceType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceType_Response_& instance) = 0;

            protected:
                Sample_ServiceType_Response_DataReader () {};
                ~Sample_ServiceType_Response_DataReader () {};
            private:
                Sample_ServiceType_Response_DataReader (const Sample_ServiceType_Response_DataReader &);
                Sample_ServiceType_Response_DataReader & operator = (const Sample_ServiceType_Response_DataReader &);
            };

            class  Sample_ServiceType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceType_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceType_Response_DataReaderView_var _var_type;

                static Sample_ServiceType_Response_DataReaderView_ptr _duplicate (Sample_ServiceType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceType_Response_& instance) = 0;

            protected:
                Sample_ServiceType_Response_DataReaderView () {};
                ~Sample_ServiceType_Response_DataReaderView () {};
            private:
                Sample_ServiceType_Response_DataReaderView (const Sample_ServiceType_Response_DataReaderView &);
                Sample_ServiceType_Response_DataReaderView & operator = (const Sample_ServiceType_Response_DataReaderView &);
            };
        }

    }

}

#endif
