#ifndef _H_2ACCD677C0CA37F5E5728D1014DB8809_ServicesForType__H_
#define _H_2ACCD677C0CA37F5E5728D1014DB8809_ServicesForType__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  ServicesForType_Request_
            {
                ::DDS::String_mgr type_;
            };

            typedef DDS_DCPSStruct_var<ServicesForType_Request_> ServicesForType_Request__var;
            typedef DDS_DCPSStruct_out < ServicesForType_Request_> ServicesForType_Request__out;

            struct  ServicesForType_Response_
            {
                struct _services__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _services__seq_uniq_ > _services__seq;
                typedef DDS_DCPSUStrSeq_var< _services__seq > _services__seq_var;
                typedef DDS_DCPSUStrSeq_out< _services__seq > _services__seq_out;
                _services__seq services_;
            };

            typedef DDS_DCPSStruct_var<ServicesForType_Response_> ServicesForType_Response__var;
            typedef DDS_DCPSStruct_out < ServicesForType_Response_> ServicesForType_Response__out;

            struct  Sample_ServicesForType_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServicesForType_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServicesForType_Request_> Sample_ServicesForType_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ServicesForType_Request_> Sample_ServicesForType_Request__out;

            struct  Sample_ServicesForType_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServicesForType_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServicesForType_Response_> Sample_ServicesForType_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ServicesForType_Response_> Sample_ServicesForType_Response__out;

        }

    }

}

#endif /* _H_2ACCD677C0CA37F5E5728D1014DB8809_ServicesForType__H_ */
