#ifndef _H_48449DAB6605FEBAF8C4082CCAA457F0_TopicType__H_
#define _H_48449DAB6605FEBAF8C4082CCAA457F0_TopicType__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  TopicType_Request_
            {
                ::DDS::String_mgr topic_;
            };

            typedef DDS_DCPSStruct_var<TopicType_Request_> TopicType_Request__var;
            typedef DDS_DCPSStruct_out < TopicType_Request_> TopicType_Request__out;

            struct  TopicType_Response_
            {
                ::DDS::String_mgr type_;
            };

            typedef DDS_DCPSStruct_var<TopicType_Response_> TopicType_Response__var;
            typedef DDS_DCPSStruct_out < TopicType_Response_> TopicType_Response__out;

            struct  Sample_TopicType_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::TopicType_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_TopicType_Request_> Sample_TopicType_Request__var;
            typedef DDS_DCPSStruct_out < Sample_TopicType_Request_> Sample_TopicType_Request__out;

            struct  Sample_TopicType_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::TopicType_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_TopicType_Response_> Sample_TopicType_Response__var;
            typedef DDS_DCPSStruct_out < Sample_TopicType_Response_> Sample_TopicType_Response__out;

        }

    }

}

#endif /* _H_48449DAB6605FEBAF8C4082CCAA457F0_TopicType__H_ */
