#ifndef _H_FC475E61CDFDCF8527AAF2A5F0F819F9_TopicsForType__H_
#define _H_FC475E61CDFDCF8527AAF2A5F0F819F9_TopicsForType__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  TopicsForType_Request_
            {
                ::DDS::String_mgr type_;
            };

            typedef DDS_DCPSStruct_var<TopicsForType_Request_> TopicsForType_Request__var;
            typedef DDS_DCPSStruct_out < TopicsForType_Request_> TopicsForType_Request__out;

            struct  TopicsForType_Response_
            {
                struct _topics__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _topics__seq_uniq_ > _topics__seq;
                typedef DDS_DCPSUStrSeq_var< _topics__seq > _topics__seq_var;
                typedef DDS_DCPSUStrSeq_out< _topics__seq > _topics__seq_out;
                _topics__seq topics_;
            };

            typedef DDS_DCPSStruct_var<TopicsForType_Response_> TopicsForType_Response__var;
            typedef DDS_DCPSStruct_out < TopicsForType_Response_> TopicsForType_Response__out;

            struct  Sample_TopicsForType_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::TopicsForType_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_TopicsForType_Request_> Sample_TopicsForType_Request__var;
            typedef DDS_DCPSStruct_out < Sample_TopicsForType_Request_> Sample_TopicsForType_Request__out;

            struct  Sample_TopicsForType_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::TopicsForType_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_TopicsForType_Response_> Sample_TopicsForType_Response__var;
            typedef DDS_DCPSStruct_out < Sample_TopicsForType_Response_> Sample_TopicsForType_Response__out;

        }

    }

}

#endif /* _H_FC475E61CDFDCF8527AAF2A5F0F819F9_TopicsForType__H_ */
