#ifndef _H_FC475E61CDFDCF8527AAF2A5F0F819F9_TopicsForType_DCPS_H_
#define _H_FC475E61CDFDCF8527AAF2A5F0F819F9_TopicsForType_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TopicsForType_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class TopicsForType_Request_TypeSupportInterface;

            typedef TopicsForType_Request_TypeSupportInterface * TopicsForType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Request_TypeSupportInterface> TopicsForType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Request_TypeSupportInterface> TopicsForType_Request_TypeSupportInterface_out;


            class TopicsForType_Request_DataWriter;

            typedef TopicsForType_Request_DataWriter * TopicsForType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Request_DataWriter> TopicsForType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Request_DataWriter> TopicsForType_Request_DataWriter_out;


            class TopicsForType_Request_DataReader;

            typedef TopicsForType_Request_DataReader * TopicsForType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Request_DataReader> TopicsForType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Request_DataReader> TopicsForType_Request_DataReader_out;


            class TopicsForType_Request_DataReaderView;

            typedef TopicsForType_Request_DataReaderView * TopicsForType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Request_DataReaderView> TopicsForType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Request_DataReaderView> TopicsForType_Request_DataReaderView_out;

            struct TopicsForType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TopicsForType_Request_, struct TopicsForType_Request_Seq_uniq_> TopicsForType_Request_Seq;
            typedef DDS_DCPSSequence_var < TopicsForType_Request_Seq> TopicsForType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < TopicsForType_Request_Seq> TopicsForType_Request_Seq_out;

            class  TopicsForType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TopicsForType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef TopicsForType_Request_TypeSupportInterface_var _var_type;

                static TopicsForType_Request_TypeSupportInterface_ptr _duplicate (TopicsForType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TopicsForType_Request_TypeSupportInterface () {};
                ~TopicsForType_Request_TypeSupportInterface () {};
            private:
                TopicsForType_Request_TypeSupportInterface (const TopicsForType_Request_TypeSupportInterface &);
                TopicsForType_Request_TypeSupportInterface & operator = (const TopicsForType_Request_TypeSupportInterface &);
            };

            class  TopicsForType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TopicsForType_Request_DataWriter_ptr _ptr_type;
                typedef TopicsForType_Request_DataWriter_var _var_type;

                static TopicsForType_Request_DataWriter_ptr _duplicate (TopicsForType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TopicsForType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TopicsForType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TopicsForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicsForType_Request_& instance_data) = 0;

            protected:
                TopicsForType_Request_DataWriter () {};
                ~TopicsForType_Request_DataWriter () {};
            private:
                TopicsForType_Request_DataWriter (const TopicsForType_Request_DataWriter &);
                TopicsForType_Request_DataWriter & operator = (const TopicsForType_Request_DataWriter &);
            };

            class  TopicsForType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TopicsForType_Request_DataReader_ptr _ptr_type;
                typedef TopicsForType_Request_DataReader_var _var_type;

                static TopicsForType_Request_DataReader_ptr _duplicate (TopicsForType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicsForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicsForType_Request_& instance) = 0;

            protected:
                TopicsForType_Request_DataReader () {};
                ~TopicsForType_Request_DataReader () {};
            private:
                TopicsForType_Request_DataReader (const TopicsForType_Request_DataReader &);
                TopicsForType_Request_DataReader & operator = (const TopicsForType_Request_DataReader &);
            };

            class  TopicsForType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TopicsForType_Request_DataReaderView_ptr _ptr_type;
                typedef TopicsForType_Request_DataReaderView_var _var_type;

                static TopicsForType_Request_DataReaderView_ptr _duplicate (TopicsForType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicsForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicsForType_Request_& instance) = 0;

            protected:
                TopicsForType_Request_DataReaderView () {};
                ~TopicsForType_Request_DataReaderView () {};
            private:
                TopicsForType_Request_DataReaderView (const TopicsForType_Request_DataReaderView &);
                TopicsForType_Request_DataReaderView & operator = (const TopicsForType_Request_DataReaderView &);
            };
            class TopicsForType_Response_TypeSupportInterface;

            typedef TopicsForType_Response_TypeSupportInterface * TopicsForType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Response_TypeSupportInterface> TopicsForType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Response_TypeSupportInterface> TopicsForType_Response_TypeSupportInterface_out;


            class TopicsForType_Response_DataWriter;

            typedef TopicsForType_Response_DataWriter * TopicsForType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Response_DataWriter> TopicsForType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Response_DataWriter> TopicsForType_Response_DataWriter_out;


            class TopicsForType_Response_DataReader;

            typedef TopicsForType_Response_DataReader * TopicsForType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Response_DataReader> TopicsForType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Response_DataReader> TopicsForType_Response_DataReader_out;


            class TopicsForType_Response_DataReaderView;

            typedef TopicsForType_Response_DataReaderView * TopicsForType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TopicsForType_Response_DataReaderView> TopicsForType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TopicsForType_Response_DataReaderView> TopicsForType_Response_DataReaderView_out;

            struct TopicsForType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TopicsForType_Response_, struct TopicsForType_Response_Seq_uniq_> TopicsForType_Response_Seq;
            typedef DDS_DCPSSequence_var < TopicsForType_Response_Seq> TopicsForType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < TopicsForType_Response_Seq> TopicsForType_Response_Seq_out;

            class  TopicsForType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TopicsForType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef TopicsForType_Response_TypeSupportInterface_var _var_type;

                static TopicsForType_Response_TypeSupportInterface_ptr _duplicate (TopicsForType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TopicsForType_Response_TypeSupportInterface () {};
                ~TopicsForType_Response_TypeSupportInterface () {};
            private:
                TopicsForType_Response_TypeSupportInterface (const TopicsForType_Response_TypeSupportInterface &);
                TopicsForType_Response_TypeSupportInterface & operator = (const TopicsForType_Response_TypeSupportInterface &);
            };

            class  TopicsForType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TopicsForType_Response_DataWriter_ptr _ptr_type;
                typedef TopicsForType_Response_DataWriter_var _var_type;

                static TopicsForType_Response_DataWriter_ptr _duplicate (TopicsForType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TopicsForType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TopicsForType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TopicsForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicsForType_Response_& instance_data) = 0;

            protected:
                TopicsForType_Response_DataWriter () {};
                ~TopicsForType_Response_DataWriter () {};
            private:
                TopicsForType_Response_DataWriter (const TopicsForType_Response_DataWriter &);
                TopicsForType_Response_DataWriter & operator = (const TopicsForType_Response_DataWriter &);
            };

            class  TopicsForType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TopicsForType_Response_DataReader_ptr _ptr_type;
                typedef TopicsForType_Response_DataReader_var _var_type;

                static TopicsForType_Response_DataReader_ptr _duplicate (TopicsForType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicsForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicsForType_Response_& instance) = 0;

            protected:
                TopicsForType_Response_DataReader () {};
                ~TopicsForType_Response_DataReader () {};
            private:
                TopicsForType_Response_DataReader (const TopicsForType_Response_DataReader &);
                TopicsForType_Response_DataReader & operator = (const TopicsForType_Response_DataReader &);
            };

            class  TopicsForType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TopicsForType_Response_DataReaderView_ptr _ptr_type;
                typedef TopicsForType_Response_DataReaderView_var _var_type;

                static TopicsForType_Response_DataReaderView_ptr _duplicate (TopicsForType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicsForType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicsForType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicsForType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicsForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicsForType_Response_& instance) = 0;

            protected:
                TopicsForType_Response_DataReaderView () {};
                ~TopicsForType_Response_DataReaderView () {};
            private:
                TopicsForType_Response_DataReaderView (const TopicsForType_Response_DataReaderView &);
                TopicsForType_Response_DataReaderView & operator = (const TopicsForType_Response_DataReaderView &);
            };
            class Sample_TopicsForType_Request_TypeSupportInterface;

            typedef Sample_TopicsForType_Request_TypeSupportInterface * Sample_TopicsForType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Request_TypeSupportInterface> Sample_TopicsForType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Request_TypeSupportInterface> Sample_TopicsForType_Request_TypeSupportInterface_out;


            class Sample_TopicsForType_Request_DataWriter;

            typedef Sample_TopicsForType_Request_DataWriter * Sample_TopicsForType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Request_DataWriter> Sample_TopicsForType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Request_DataWriter> Sample_TopicsForType_Request_DataWriter_out;


            class Sample_TopicsForType_Request_DataReader;

            typedef Sample_TopicsForType_Request_DataReader * Sample_TopicsForType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Request_DataReader> Sample_TopicsForType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Request_DataReader> Sample_TopicsForType_Request_DataReader_out;


            class Sample_TopicsForType_Request_DataReaderView;

            typedef Sample_TopicsForType_Request_DataReaderView * Sample_TopicsForType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Request_DataReaderView> Sample_TopicsForType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Request_DataReaderView> Sample_TopicsForType_Request_DataReaderView_out;

            struct Sample_TopicsForType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_TopicsForType_Request_, struct Sample_TopicsForType_Request_Seq_uniq_> Sample_TopicsForType_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_TopicsForType_Request_Seq> Sample_TopicsForType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_TopicsForType_Request_Seq> Sample_TopicsForType_Request_Seq_out;

            class  Sample_TopicsForType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_TopicsForType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_TopicsForType_Request_TypeSupportInterface_var _var_type;

                static Sample_TopicsForType_Request_TypeSupportInterface_ptr _duplicate (Sample_TopicsForType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_TopicsForType_Request_TypeSupportInterface () {};
                ~Sample_TopicsForType_Request_TypeSupportInterface () {};
            private:
                Sample_TopicsForType_Request_TypeSupportInterface (const Sample_TopicsForType_Request_TypeSupportInterface &);
                Sample_TopicsForType_Request_TypeSupportInterface & operator = (const Sample_TopicsForType_Request_TypeSupportInterface &);
            };

            class  Sample_TopicsForType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_TopicsForType_Request_DataWriter_ptr _ptr_type;
                typedef Sample_TopicsForType_Request_DataWriter_var _var_type;

                static Sample_TopicsForType_Request_DataWriter_ptr _duplicate (Sample_TopicsForType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_TopicsForType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_TopicsForType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_TopicsForType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_TopicsForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicsForType_Request_& instance_data) = 0;

            protected:
                Sample_TopicsForType_Request_DataWriter () {};
                ~Sample_TopicsForType_Request_DataWriter () {};
            private:
                Sample_TopicsForType_Request_DataWriter (const Sample_TopicsForType_Request_DataWriter &);
                Sample_TopicsForType_Request_DataWriter & operator = (const Sample_TopicsForType_Request_DataWriter &);
            };

            class  Sample_TopicsForType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_TopicsForType_Request_DataReader_ptr _ptr_type;
                typedef Sample_TopicsForType_Request_DataReader_var _var_type;

                static Sample_TopicsForType_Request_DataReader_ptr _duplicate (Sample_TopicsForType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicsForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicsForType_Request_& instance) = 0;

            protected:
                Sample_TopicsForType_Request_DataReader () {};
                ~Sample_TopicsForType_Request_DataReader () {};
            private:
                Sample_TopicsForType_Request_DataReader (const Sample_TopicsForType_Request_DataReader &);
                Sample_TopicsForType_Request_DataReader & operator = (const Sample_TopicsForType_Request_DataReader &);
            };

            class  Sample_TopicsForType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_TopicsForType_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_TopicsForType_Request_DataReaderView_var _var_type;

                static Sample_TopicsForType_Request_DataReaderView_ptr _duplicate (Sample_TopicsForType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicsForType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicsForType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicsForType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicsForType_Request_& instance) = 0;

            protected:
                Sample_TopicsForType_Request_DataReaderView () {};
                ~Sample_TopicsForType_Request_DataReaderView () {};
            private:
                Sample_TopicsForType_Request_DataReaderView (const Sample_TopicsForType_Request_DataReaderView &);
                Sample_TopicsForType_Request_DataReaderView & operator = (const Sample_TopicsForType_Request_DataReaderView &);
            };
            class Sample_TopicsForType_Response_TypeSupportInterface;

            typedef Sample_TopicsForType_Response_TypeSupportInterface * Sample_TopicsForType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Response_TypeSupportInterface> Sample_TopicsForType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Response_TypeSupportInterface> Sample_TopicsForType_Response_TypeSupportInterface_out;


            class Sample_TopicsForType_Response_DataWriter;

            typedef Sample_TopicsForType_Response_DataWriter * Sample_TopicsForType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Response_DataWriter> Sample_TopicsForType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Response_DataWriter> Sample_TopicsForType_Response_DataWriter_out;


            class Sample_TopicsForType_Response_DataReader;

            typedef Sample_TopicsForType_Response_DataReader * Sample_TopicsForType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Response_DataReader> Sample_TopicsForType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Response_DataReader> Sample_TopicsForType_Response_DataReader_out;


            class Sample_TopicsForType_Response_DataReaderView;

            typedef Sample_TopicsForType_Response_DataReaderView * Sample_TopicsForType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicsForType_Response_DataReaderView> Sample_TopicsForType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_TopicsForType_Response_DataReaderView> Sample_TopicsForType_Response_DataReaderView_out;

            struct Sample_TopicsForType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_TopicsForType_Response_, struct Sample_TopicsForType_Response_Seq_uniq_> Sample_TopicsForType_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_TopicsForType_Response_Seq> Sample_TopicsForType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_TopicsForType_Response_Seq> Sample_TopicsForType_Response_Seq_out;

            class  Sample_TopicsForType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_TopicsForType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_TopicsForType_Response_TypeSupportInterface_var _var_type;

                static Sample_TopicsForType_Response_TypeSupportInterface_ptr _duplicate (Sample_TopicsForType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_TopicsForType_Response_TypeSupportInterface () {};
                ~Sample_TopicsForType_Response_TypeSupportInterface () {};
            private:
                Sample_TopicsForType_Response_TypeSupportInterface (const Sample_TopicsForType_Response_TypeSupportInterface &);
                Sample_TopicsForType_Response_TypeSupportInterface & operator = (const Sample_TopicsForType_Response_TypeSupportInterface &);
            };

            class  Sample_TopicsForType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_TopicsForType_Response_DataWriter_ptr _ptr_type;
                typedef Sample_TopicsForType_Response_DataWriter_var _var_type;

                static Sample_TopicsForType_Response_DataWriter_ptr _duplicate (Sample_TopicsForType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_TopicsForType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_TopicsForType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_TopicsForType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_TopicsForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicsForType_Response_& instance_data) = 0;

            protected:
                Sample_TopicsForType_Response_DataWriter () {};
                ~Sample_TopicsForType_Response_DataWriter () {};
            private:
                Sample_TopicsForType_Response_DataWriter (const Sample_TopicsForType_Response_DataWriter &);
                Sample_TopicsForType_Response_DataWriter & operator = (const Sample_TopicsForType_Response_DataWriter &);
            };

            class  Sample_TopicsForType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_TopicsForType_Response_DataReader_ptr _ptr_type;
                typedef Sample_TopicsForType_Response_DataReader_var _var_type;

                static Sample_TopicsForType_Response_DataReader_ptr _duplicate (Sample_TopicsForType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicsForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicsForType_Response_& instance) = 0;

            protected:
                Sample_TopicsForType_Response_DataReader () {};
                ~Sample_TopicsForType_Response_DataReader () {};
            private:
                Sample_TopicsForType_Response_DataReader (const Sample_TopicsForType_Response_DataReader &);
                Sample_TopicsForType_Response_DataReader & operator = (const Sample_TopicsForType_Response_DataReader &);
            };

            class  Sample_TopicsForType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_TopicsForType_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_TopicsForType_Response_DataReaderView_var _var_type;

                static Sample_TopicsForType_Response_DataReaderView_ptr _duplicate (Sample_TopicsForType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicsForType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicsForType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicsForType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicsForType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicsForType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicsForType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicsForType_Response_& instance) = 0;

            protected:
                Sample_TopicsForType_Response_DataReaderView () {};
                ~Sample_TopicsForType_Response_DataReaderView () {};
            private:
                Sample_TopicsForType_Response_DataReaderView (const Sample_TopicsForType_Response_DataReaderView &);
                Sample_TopicsForType_Response_DataReaderView & operator = (const Sample_TopicsForType_Response_DataReaderView &);
            };
        }

    }

}

#endif
