#ifndef _H_E0C5F99A84247E94361CB5ADB901124C_GetActionServers__H_
#define _H_E0C5F99A84247E94361CB5ADB901124C_GetActionServers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetActionServers_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<GetActionServers_Request_> GetActionServers_Request__var;
            typedef GetActionServers_Request_& GetActionServers_Request__out;

            struct  GetActionServers_Response_
            {
                struct _action_servers__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _action_servers__seq_uniq_ > _action_servers__seq;
                typedef DDS_DCPSUStrSeq_var< _action_servers__seq > _action_servers__seq_var;
                typedef DDS_DCPSUStrSeq_out< _action_servers__seq > _action_servers__seq_out;
                _action_servers__seq action_servers_;
            };

            typedef DDS_DCPSStruct_var<GetActionServers_Response_> GetActionServers_Response__var;
            typedef DDS_DCPSStruct_out < GetActionServers_Response_> GetActionServers_Response__out;

            struct  Sample_GetActionServers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetActionServers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetActionServers_Request_> Sample_GetActionServers_Request__var;
            typedef Sample_GetActionServers_Request_& Sample_GetActionServers_Request__out;

            struct  Sample_GetActionServers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetActionServers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetActionServers_Response_> Sample_GetActionServers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetActionServers_Response_> Sample_GetActionServers_Response__out;

        }

    }

}

#endif /* _H_E0C5F99A84247E94361CB5ADB901124C_GetActionServers__H_ */
