#ifndef _H_97E3568268347B8FD09F6A53BEA3831D_GetParamNames_DCPS_H_
#define _H_97E3568268347B8FD09F6A53BEA3831D_GetParamNames_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetParamNames_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class GetParamNames_Request_TypeSupportInterface;

            typedef GetParamNames_Request_TypeSupportInterface * GetParamNames_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Request_TypeSupportInterface> GetParamNames_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Request_TypeSupportInterface> GetParamNames_Request_TypeSupportInterface_out;


            class GetParamNames_Request_DataWriter;

            typedef GetParamNames_Request_DataWriter * GetParamNames_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Request_DataWriter> GetParamNames_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Request_DataWriter> GetParamNames_Request_DataWriter_out;


            class GetParamNames_Request_DataReader;

            typedef GetParamNames_Request_DataReader * GetParamNames_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Request_DataReader> GetParamNames_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Request_DataReader> GetParamNames_Request_DataReader_out;


            class GetParamNames_Request_DataReaderView;

            typedef GetParamNames_Request_DataReaderView * GetParamNames_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Request_DataReaderView> GetParamNames_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Request_DataReaderView> GetParamNames_Request_DataReaderView_out;

            struct GetParamNames_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetParamNames_Request_, struct GetParamNames_Request_Seq_uniq_> GetParamNames_Request_Seq;
            typedef DDS_DCPSSequence_var < GetParamNames_Request_Seq> GetParamNames_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetParamNames_Request_Seq> GetParamNames_Request_Seq_out;

            class  GetParamNames_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetParamNames_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetParamNames_Request_TypeSupportInterface_var _var_type;

                static GetParamNames_Request_TypeSupportInterface_ptr _duplicate (GetParamNames_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetParamNames_Request_TypeSupportInterface () {};
                ~GetParamNames_Request_TypeSupportInterface () {};
            private:
                GetParamNames_Request_TypeSupportInterface (const GetParamNames_Request_TypeSupportInterface &);
                GetParamNames_Request_TypeSupportInterface & operator = (const GetParamNames_Request_TypeSupportInterface &);
            };

            class  GetParamNames_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetParamNames_Request_DataWriter_ptr _ptr_type;
                typedef GetParamNames_Request_DataWriter_var _var_type;

                static GetParamNames_Request_DataWriter_ptr _duplicate (GetParamNames_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetParamNames_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetParamNames_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetParamNames_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParamNames_Request_& instance_data) = 0;

            protected:
                GetParamNames_Request_DataWriter () {};
                ~GetParamNames_Request_DataWriter () {};
            private:
                GetParamNames_Request_DataWriter (const GetParamNames_Request_DataWriter &);
                GetParamNames_Request_DataWriter & operator = (const GetParamNames_Request_DataWriter &);
            };

            class  GetParamNames_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetParamNames_Request_DataReader_ptr _ptr_type;
                typedef GetParamNames_Request_DataReader_var _var_type;

                static GetParamNames_Request_DataReader_ptr _duplicate (GetParamNames_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParamNames_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParamNames_Request_& instance) = 0;

            protected:
                GetParamNames_Request_DataReader () {};
                ~GetParamNames_Request_DataReader () {};
            private:
                GetParamNames_Request_DataReader (const GetParamNames_Request_DataReader &);
                GetParamNames_Request_DataReader & operator = (const GetParamNames_Request_DataReader &);
            };

            class  GetParamNames_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetParamNames_Request_DataReaderView_ptr _ptr_type;
                typedef GetParamNames_Request_DataReaderView_var _var_type;

                static GetParamNames_Request_DataReaderView_ptr _duplicate (GetParamNames_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParamNames_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParamNames_Request_& instance) = 0;

            protected:
                GetParamNames_Request_DataReaderView () {};
                ~GetParamNames_Request_DataReaderView () {};
            private:
                GetParamNames_Request_DataReaderView (const GetParamNames_Request_DataReaderView &);
                GetParamNames_Request_DataReaderView & operator = (const GetParamNames_Request_DataReaderView &);
            };
            class GetParamNames_Response_TypeSupportInterface;

            typedef GetParamNames_Response_TypeSupportInterface * GetParamNames_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Response_TypeSupportInterface> GetParamNames_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Response_TypeSupportInterface> GetParamNames_Response_TypeSupportInterface_out;


            class GetParamNames_Response_DataWriter;

            typedef GetParamNames_Response_DataWriter * GetParamNames_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Response_DataWriter> GetParamNames_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Response_DataWriter> GetParamNames_Response_DataWriter_out;


            class GetParamNames_Response_DataReader;

            typedef GetParamNames_Response_DataReader * GetParamNames_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Response_DataReader> GetParamNames_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Response_DataReader> GetParamNames_Response_DataReader_out;


            class GetParamNames_Response_DataReaderView;

            typedef GetParamNames_Response_DataReaderView * GetParamNames_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetParamNames_Response_DataReaderView> GetParamNames_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetParamNames_Response_DataReaderView> GetParamNames_Response_DataReaderView_out;

            struct GetParamNames_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetParamNames_Response_, struct GetParamNames_Response_Seq_uniq_> GetParamNames_Response_Seq;
            typedef DDS_DCPSSequence_var < GetParamNames_Response_Seq> GetParamNames_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetParamNames_Response_Seq> GetParamNames_Response_Seq_out;

            class  GetParamNames_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetParamNames_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetParamNames_Response_TypeSupportInterface_var _var_type;

                static GetParamNames_Response_TypeSupportInterface_ptr _duplicate (GetParamNames_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetParamNames_Response_TypeSupportInterface () {};
                ~GetParamNames_Response_TypeSupportInterface () {};
            private:
                GetParamNames_Response_TypeSupportInterface (const GetParamNames_Response_TypeSupportInterface &);
                GetParamNames_Response_TypeSupportInterface & operator = (const GetParamNames_Response_TypeSupportInterface &);
            };

            class  GetParamNames_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetParamNames_Response_DataWriter_ptr _ptr_type;
                typedef GetParamNames_Response_DataWriter_var _var_type;

                static GetParamNames_Response_DataWriter_ptr _duplicate (GetParamNames_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetParamNames_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetParamNames_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetParamNames_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParamNames_Response_& instance_data) = 0;

            protected:
                GetParamNames_Response_DataWriter () {};
                ~GetParamNames_Response_DataWriter () {};
            private:
                GetParamNames_Response_DataWriter (const GetParamNames_Response_DataWriter &);
                GetParamNames_Response_DataWriter & operator = (const GetParamNames_Response_DataWriter &);
            };

            class  GetParamNames_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetParamNames_Response_DataReader_ptr _ptr_type;
                typedef GetParamNames_Response_DataReader_var _var_type;

                static GetParamNames_Response_DataReader_ptr _duplicate (GetParamNames_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParamNames_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParamNames_Response_& instance) = 0;

            protected:
                GetParamNames_Response_DataReader () {};
                ~GetParamNames_Response_DataReader () {};
            private:
                GetParamNames_Response_DataReader (const GetParamNames_Response_DataReader &);
                GetParamNames_Response_DataReader & operator = (const GetParamNames_Response_DataReader &);
            };

            class  GetParamNames_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetParamNames_Response_DataReaderView_ptr _ptr_type;
                typedef GetParamNames_Response_DataReaderView_var _var_type;

                static GetParamNames_Response_DataReaderView_ptr _duplicate (GetParamNames_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetParamNames_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetParamNames_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetParamNames_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetParamNames_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetParamNames_Response_& instance) = 0;

            protected:
                GetParamNames_Response_DataReaderView () {};
                ~GetParamNames_Response_DataReaderView () {};
            private:
                GetParamNames_Response_DataReaderView (const GetParamNames_Response_DataReaderView &);
                GetParamNames_Response_DataReaderView & operator = (const GetParamNames_Response_DataReaderView &);
            };
            class Sample_GetParamNames_Request_TypeSupportInterface;

            typedef Sample_GetParamNames_Request_TypeSupportInterface * Sample_GetParamNames_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Request_TypeSupportInterface> Sample_GetParamNames_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Request_TypeSupportInterface> Sample_GetParamNames_Request_TypeSupportInterface_out;


            class Sample_GetParamNames_Request_DataWriter;

            typedef Sample_GetParamNames_Request_DataWriter * Sample_GetParamNames_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Request_DataWriter> Sample_GetParamNames_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Request_DataWriter> Sample_GetParamNames_Request_DataWriter_out;


            class Sample_GetParamNames_Request_DataReader;

            typedef Sample_GetParamNames_Request_DataReader * Sample_GetParamNames_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Request_DataReader> Sample_GetParamNames_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Request_DataReader> Sample_GetParamNames_Request_DataReader_out;


            class Sample_GetParamNames_Request_DataReaderView;

            typedef Sample_GetParamNames_Request_DataReaderView * Sample_GetParamNames_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Request_DataReaderView> Sample_GetParamNames_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Request_DataReaderView> Sample_GetParamNames_Request_DataReaderView_out;

            struct Sample_GetParamNames_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetParamNames_Request_, struct Sample_GetParamNames_Request_Seq_uniq_> Sample_GetParamNames_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetParamNames_Request_Seq> Sample_GetParamNames_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetParamNames_Request_Seq> Sample_GetParamNames_Request_Seq_out;

            class  Sample_GetParamNames_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetParamNames_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetParamNames_Request_TypeSupportInterface_var _var_type;

                static Sample_GetParamNames_Request_TypeSupportInterface_ptr _duplicate (Sample_GetParamNames_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetParamNames_Request_TypeSupportInterface () {};
                ~Sample_GetParamNames_Request_TypeSupportInterface () {};
            private:
                Sample_GetParamNames_Request_TypeSupportInterface (const Sample_GetParamNames_Request_TypeSupportInterface &);
                Sample_GetParamNames_Request_TypeSupportInterface & operator = (const Sample_GetParamNames_Request_TypeSupportInterface &);
            };

            class  Sample_GetParamNames_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetParamNames_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetParamNames_Request_DataWriter_var _var_type;

                static Sample_GetParamNames_Request_DataWriter_ptr _duplicate (Sample_GetParamNames_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetParamNames_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetParamNames_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetParamNames_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetParamNames_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParamNames_Request_& instance_data) = 0;

            protected:
                Sample_GetParamNames_Request_DataWriter () {};
                ~Sample_GetParamNames_Request_DataWriter () {};
            private:
                Sample_GetParamNames_Request_DataWriter (const Sample_GetParamNames_Request_DataWriter &);
                Sample_GetParamNames_Request_DataWriter & operator = (const Sample_GetParamNames_Request_DataWriter &);
            };

            class  Sample_GetParamNames_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetParamNames_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetParamNames_Request_DataReader_var _var_type;

                static Sample_GetParamNames_Request_DataReader_ptr _duplicate (Sample_GetParamNames_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParamNames_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParamNames_Request_& instance) = 0;

            protected:
                Sample_GetParamNames_Request_DataReader () {};
                ~Sample_GetParamNames_Request_DataReader () {};
            private:
                Sample_GetParamNames_Request_DataReader (const Sample_GetParamNames_Request_DataReader &);
                Sample_GetParamNames_Request_DataReader & operator = (const Sample_GetParamNames_Request_DataReader &);
            };

            class  Sample_GetParamNames_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetParamNames_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetParamNames_Request_DataReaderView_var _var_type;

                static Sample_GetParamNames_Request_DataReaderView_ptr _duplicate (Sample_GetParamNames_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParamNames_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParamNames_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParamNames_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParamNames_Request_& instance) = 0;

            protected:
                Sample_GetParamNames_Request_DataReaderView () {};
                ~Sample_GetParamNames_Request_DataReaderView () {};
            private:
                Sample_GetParamNames_Request_DataReaderView (const Sample_GetParamNames_Request_DataReaderView &);
                Sample_GetParamNames_Request_DataReaderView & operator = (const Sample_GetParamNames_Request_DataReaderView &);
            };
            class Sample_GetParamNames_Response_TypeSupportInterface;

            typedef Sample_GetParamNames_Response_TypeSupportInterface * Sample_GetParamNames_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Response_TypeSupportInterface> Sample_GetParamNames_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Response_TypeSupportInterface> Sample_GetParamNames_Response_TypeSupportInterface_out;


            class Sample_GetParamNames_Response_DataWriter;

            typedef Sample_GetParamNames_Response_DataWriter * Sample_GetParamNames_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Response_DataWriter> Sample_GetParamNames_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Response_DataWriter> Sample_GetParamNames_Response_DataWriter_out;


            class Sample_GetParamNames_Response_DataReader;

            typedef Sample_GetParamNames_Response_DataReader * Sample_GetParamNames_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Response_DataReader> Sample_GetParamNames_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Response_DataReader> Sample_GetParamNames_Response_DataReader_out;


            class Sample_GetParamNames_Response_DataReaderView;

            typedef Sample_GetParamNames_Response_DataReaderView * Sample_GetParamNames_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetParamNames_Response_DataReaderView> Sample_GetParamNames_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetParamNames_Response_DataReaderView> Sample_GetParamNames_Response_DataReaderView_out;

            struct Sample_GetParamNames_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetParamNames_Response_, struct Sample_GetParamNames_Response_Seq_uniq_> Sample_GetParamNames_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetParamNames_Response_Seq> Sample_GetParamNames_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetParamNames_Response_Seq> Sample_GetParamNames_Response_Seq_out;

            class  Sample_GetParamNames_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetParamNames_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetParamNames_Response_TypeSupportInterface_var _var_type;

                static Sample_GetParamNames_Response_TypeSupportInterface_ptr _duplicate (Sample_GetParamNames_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetParamNames_Response_TypeSupportInterface () {};
                ~Sample_GetParamNames_Response_TypeSupportInterface () {};
            private:
                Sample_GetParamNames_Response_TypeSupportInterface (const Sample_GetParamNames_Response_TypeSupportInterface &);
                Sample_GetParamNames_Response_TypeSupportInterface & operator = (const Sample_GetParamNames_Response_TypeSupportInterface &);
            };

            class  Sample_GetParamNames_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetParamNames_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetParamNames_Response_DataWriter_var _var_type;

                static Sample_GetParamNames_Response_DataWriter_ptr _duplicate (Sample_GetParamNames_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetParamNames_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetParamNames_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetParamNames_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetParamNames_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParamNames_Response_& instance_data) = 0;

            protected:
                Sample_GetParamNames_Response_DataWriter () {};
                ~Sample_GetParamNames_Response_DataWriter () {};
            private:
                Sample_GetParamNames_Response_DataWriter (const Sample_GetParamNames_Response_DataWriter &);
                Sample_GetParamNames_Response_DataWriter & operator = (const Sample_GetParamNames_Response_DataWriter &);
            };

            class  Sample_GetParamNames_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetParamNames_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetParamNames_Response_DataReader_var _var_type;

                static Sample_GetParamNames_Response_DataReader_ptr _duplicate (Sample_GetParamNames_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParamNames_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParamNames_Response_& instance) = 0;

            protected:
                Sample_GetParamNames_Response_DataReader () {};
                ~Sample_GetParamNames_Response_DataReader () {};
            private:
                Sample_GetParamNames_Response_DataReader (const Sample_GetParamNames_Response_DataReader &);
                Sample_GetParamNames_Response_DataReader & operator = (const Sample_GetParamNames_Response_DataReader &);
            };

            class  Sample_GetParamNames_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetParamNames_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetParamNames_Response_DataReaderView_var _var_type;

                static Sample_GetParamNames_Response_DataReaderView_ptr _duplicate (Sample_GetParamNames_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetParamNames_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetParamNames_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetParamNames_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetParamNames_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetParamNames_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetParamNames_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetParamNames_Response_& instance) = 0;

            protected:
                Sample_GetParamNames_Response_DataReaderView () {};
                ~Sample_GetParamNames_Response_DataReaderView () {};
            private:
                Sample_GetParamNames_Response_DataReaderView (const Sample_GetParamNames_Response_DataReaderView &);
                Sample_GetParamNames_Response_DataReaderView & operator = (const Sample_GetParamNames_Response_DataReaderView &);
            };
        }

    }

}

#endif
