#ifndef _H_B4471808AC1EB9D33CE8BB9B3933829C_GetTime__H_
#define _H_B4471808AC1EB9D33CE8BB9B3933829C_GetTime__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetTime_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<GetTime_Request_> GetTime_Request__var;
            typedef GetTime_Request_& GetTime_Request__out;

            struct  GetTime_Response_
            {
                ::builtin_interfaces::msg::dds_::Time_ time_;
            };

            typedef DDS_DCPSStruct_var<GetTime_Response_> GetTime_Response__var;
            typedef GetTime_Response_& GetTime_Response__out;

            struct  Sample_GetTime_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetTime_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetTime_Request_> Sample_GetTime_Request__var;
            typedef Sample_GetTime_Request_& Sample_GetTime_Request__out;

            struct  Sample_GetTime_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::GetTime_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetTime_Response_> Sample_GetTime_Response__var;
            typedef Sample_GetTime_Response_& Sample_GetTime_Response__out;

        }

    }

}

#endif /* _H_B4471808AC1EB9D33CE8BB9B3933829C_GetTime__H_ */
