#ifndef _H_B4471808AC1EB9D33CE8BB9B3933829C_GetTime_DCPS_H_
#define _H_B4471808AC1EB9D33CE8BB9B3933829C_GetTime_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetTime_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class GetTime_Request_TypeSupportInterface;

            typedef GetTime_Request_TypeSupportInterface * GetTime_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Request_TypeSupportInterface> GetTime_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetTime_Request_TypeSupportInterface> GetTime_Request_TypeSupportInterface_out;


            class GetTime_Request_DataWriter;

            typedef GetTime_Request_DataWriter * GetTime_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Request_DataWriter> GetTime_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetTime_Request_DataWriter> GetTime_Request_DataWriter_out;


            class GetTime_Request_DataReader;

            typedef GetTime_Request_DataReader * GetTime_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Request_DataReader> GetTime_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetTime_Request_DataReader> GetTime_Request_DataReader_out;


            class GetTime_Request_DataReaderView;

            typedef GetTime_Request_DataReaderView * GetTime_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Request_DataReaderView> GetTime_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetTime_Request_DataReaderView> GetTime_Request_DataReaderView_out;

            struct GetTime_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetTime_Request_, struct GetTime_Request_Seq_uniq_> GetTime_Request_Seq;
            typedef DDS_DCPSSequence_var < GetTime_Request_Seq> GetTime_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetTime_Request_Seq> GetTime_Request_Seq_out;

            class  GetTime_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetTime_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetTime_Request_TypeSupportInterface_var _var_type;

                static GetTime_Request_TypeSupportInterface_ptr _duplicate (GetTime_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetTime_Request_TypeSupportInterface () {};
                ~GetTime_Request_TypeSupportInterface () {};
            private:
                GetTime_Request_TypeSupportInterface (const GetTime_Request_TypeSupportInterface &);
                GetTime_Request_TypeSupportInterface & operator = (const GetTime_Request_TypeSupportInterface &);
            };

            class  GetTime_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetTime_Request_DataWriter_ptr _ptr_type;
                typedef GetTime_Request_DataWriter_var _var_type;

                static GetTime_Request_DataWriter_ptr _duplicate (GetTime_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetTime_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetTime_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetTime_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetTime_Request_& instance_data) = 0;

            protected:
                GetTime_Request_DataWriter () {};
                ~GetTime_Request_DataWriter () {};
            private:
                GetTime_Request_DataWriter (const GetTime_Request_DataWriter &);
                GetTime_Request_DataWriter & operator = (const GetTime_Request_DataWriter &);
            };

            class  GetTime_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetTime_Request_DataReader_ptr _ptr_type;
                typedef GetTime_Request_DataReader_var _var_type;

                static GetTime_Request_DataReader_ptr _duplicate (GetTime_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetTime_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetTime_Request_& instance) = 0;

            protected:
                GetTime_Request_DataReader () {};
                ~GetTime_Request_DataReader () {};
            private:
                GetTime_Request_DataReader (const GetTime_Request_DataReader &);
                GetTime_Request_DataReader & operator = (const GetTime_Request_DataReader &);
            };

            class  GetTime_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetTime_Request_DataReaderView_ptr _ptr_type;
                typedef GetTime_Request_DataReaderView_var _var_type;

                static GetTime_Request_DataReaderView_ptr _duplicate (GetTime_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetTime_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetTime_Request_& instance) = 0;

            protected:
                GetTime_Request_DataReaderView () {};
                ~GetTime_Request_DataReaderView () {};
            private:
                GetTime_Request_DataReaderView (const GetTime_Request_DataReaderView &);
                GetTime_Request_DataReaderView & operator = (const GetTime_Request_DataReaderView &);
            };
            class GetTime_Response_TypeSupportInterface;

            typedef GetTime_Response_TypeSupportInterface * GetTime_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Response_TypeSupportInterface> GetTime_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetTime_Response_TypeSupportInterface> GetTime_Response_TypeSupportInterface_out;


            class GetTime_Response_DataWriter;

            typedef GetTime_Response_DataWriter * GetTime_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Response_DataWriter> GetTime_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetTime_Response_DataWriter> GetTime_Response_DataWriter_out;


            class GetTime_Response_DataReader;

            typedef GetTime_Response_DataReader * GetTime_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Response_DataReader> GetTime_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetTime_Response_DataReader> GetTime_Response_DataReader_out;


            class GetTime_Response_DataReaderView;

            typedef GetTime_Response_DataReaderView * GetTime_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetTime_Response_DataReaderView> GetTime_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetTime_Response_DataReaderView> GetTime_Response_DataReaderView_out;

            struct GetTime_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetTime_Response_, struct GetTime_Response_Seq_uniq_> GetTime_Response_Seq;
            typedef DDS_DCPSSequence_var < GetTime_Response_Seq> GetTime_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetTime_Response_Seq> GetTime_Response_Seq_out;

            class  GetTime_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetTime_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetTime_Response_TypeSupportInterface_var _var_type;

                static GetTime_Response_TypeSupportInterface_ptr _duplicate (GetTime_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetTime_Response_TypeSupportInterface () {};
                ~GetTime_Response_TypeSupportInterface () {};
            private:
                GetTime_Response_TypeSupportInterface (const GetTime_Response_TypeSupportInterface &);
                GetTime_Response_TypeSupportInterface & operator = (const GetTime_Response_TypeSupportInterface &);
            };

            class  GetTime_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetTime_Response_DataWriter_ptr _ptr_type;
                typedef GetTime_Response_DataWriter_var _var_type;

                static GetTime_Response_DataWriter_ptr _duplicate (GetTime_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetTime_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetTime_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetTime_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetTime_Response_& instance_data) = 0;

            protected:
                GetTime_Response_DataWriter () {};
                ~GetTime_Response_DataWriter () {};
            private:
                GetTime_Response_DataWriter (const GetTime_Response_DataWriter &);
                GetTime_Response_DataWriter & operator = (const GetTime_Response_DataWriter &);
            };

            class  GetTime_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetTime_Response_DataReader_ptr _ptr_type;
                typedef GetTime_Response_DataReader_var _var_type;

                static GetTime_Response_DataReader_ptr _duplicate (GetTime_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetTime_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetTime_Response_& instance) = 0;

            protected:
                GetTime_Response_DataReader () {};
                ~GetTime_Response_DataReader () {};
            private:
                GetTime_Response_DataReader (const GetTime_Response_DataReader &);
                GetTime_Response_DataReader & operator = (const GetTime_Response_DataReader &);
            };

            class  GetTime_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetTime_Response_DataReaderView_ptr _ptr_type;
                typedef GetTime_Response_DataReaderView_var _var_type;

                static GetTime_Response_DataReaderView_ptr _duplicate (GetTime_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetTime_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetTime_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetTime_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetTime_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetTime_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetTime_Response_& instance) = 0;

            protected:
                GetTime_Response_DataReaderView () {};
                ~GetTime_Response_DataReaderView () {};
            private:
                GetTime_Response_DataReaderView (const GetTime_Response_DataReaderView &);
                GetTime_Response_DataReaderView & operator = (const GetTime_Response_DataReaderView &);
            };
            class Sample_GetTime_Request_TypeSupportInterface;

            typedef Sample_GetTime_Request_TypeSupportInterface * Sample_GetTime_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Request_TypeSupportInterface> Sample_GetTime_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Request_TypeSupportInterface> Sample_GetTime_Request_TypeSupportInterface_out;


            class Sample_GetTime_Request_DataWriter;

            typedef Sample_GetTime_Request_DataWriter * Sample_GetTime_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Request_DataWriter> Sample_GetTime_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Request_DataWriter> Sample_GetTime_Request_DataWriter_out;


            class Sample_GetTime_Request_DataReader;

            typedef Sample_GetTime_Request_DataReader * Sample_GetTime_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Request_DataReader> Sample_GetTime_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Request_DataReader> Sample_GetTime_Request_DataReader_out;


            class Sample_GetTime_Request_DataReaderView;

            typedef Sample_GetTime_Request_DataReaderView * Sample_GetTime_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Request_DataReaderView> Sample_GetTime_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Request_DataReaderView> Sample_GetTime_Request_DataReaderView_out;

            struct Sample_GetTime_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetTime_Request_, struct Sample_GetTime_Request_Seq_uniq_> Sample_GetTime_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetTime_Request_Seq> Sample_GetTime_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetTime_Request_Seq> Sample_GetTime_Request_Seq_out;

            class  Sample_GetTime_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetTime_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetTime_Request_TypeSupportInterface_var _var_type;

                static Sample_GetTime_Request_TypeSupportInterface_ptr _duplicate (Sample_GetTime_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetTime_Request_TypeSupportInterface () {};
                ~Sample_GetTime_Request_TypeSupportInterface () {};
            private:
                Sample_GetTime_Request_TypeSupportInterface (const Sample_GetTime_Request_TypeSupportInterface &);
                Sample_GetTime_Request_TypeSupportInterface & operator = (const Sample_GetTime_Request_TypeSupportInterface &);
            };

            class  Sample_GetTime_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetTime_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetTime_Request_DataWriter_var _var_type;

                static Sample_GetTime_Request_DataWriter_ptr _duplicate (Sample_GetTime_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetTime_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetTime_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetTime_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetTime_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetTime_Request_& instance_data) = 0;

            protected:
                Sample_GetTime_Request_DataWriter () {};
                ~Sample_GetTime_Request_DataWriter () {};
            private:
                Sample_GetTime_Request_DataWriter (const Sample_GetTime_Request_DataWriter &);
                Sample_GetTime_Request_DataWriter & operator = (const Sample_GetTime_Request_DataWriter &);
            };

            class  Sample_GetTime_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetTime_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetTime_Request_DataReader_var _var_type;

                static Sample_GetTime_Request_DataReader_ptr _duplicate (Sample_GetTime_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetTime_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetTime_Request_& instance) = 0;

            protected:
                Sample_GetTime_Request_DataReader () {};
                ~Sample_GetTime_Request_DataReader () {};
            private:
                Sample_GetTime_Request_DataReader (const Sample_GetTime_Request_DataReader &);
                Sample_GetTime_Request_DataReader & operator = (const Sample_GetTime_Request_DataReader &);
            };

            class  Sample_GetTime_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetTime_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetTime_Request_DataReaderView_var _var_type;

                static Sample_GetTime_Request_DataReaderView_ptr _duplicate (Sample_GetTime_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetTime_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetTime_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetTime_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetTime_Request_& instance) = 0;

            protected:
                Sample_GetTime_Request_DataReaderView () {};
                ~Sample_GetTime_Request_DataReaderView () {};
            private:
                Sample_GetTime_Request_DataReaderView (const Sample_GetTime_Request_DataReaderView &);
                Sample_GetTime_Request_DataReaderView & operator = (const Sample_GetTime_Request_DataReaderView &);
            };
            class Sample_GetTime_Response_TypeSupportInterface;

            typedef Sample_GetTime_Response_TypeSupportInterface * Sample_GetTime_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Response_TypeSupportInterface> Sample_GetTime_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Response_TypeSupportInterface> Sample_GetTime_Response_TypeSupportInterface_out;


            class Sample_GetTime_Response_DataWriter;

            typedef Sample_GetTime_Response_DataWriter * Sample_GetTime_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Response_DataWriter> Sample_GetTime_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Response_DataWriter> Sample_GetTime_Response_DataWriter_out;


            class Sample_GetTime_Response_DataReader;

            typedef Sample_GetTime_Response_DataReader * Sample_GetTime_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Response_DataReader> Sample_GetTime_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Response_DataReader> Sample_GetTime_Response_DataReader_out;


            class Sample_GetTime_Response_DataReaderView;

            typedef Sample_GetTime_Response_DataReaderView * Sample_GetTime_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetTime_Response_DataReaderView> Sample_GetTime_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetTime_Response_DataReaderView> Sample_GetTime_Response_DataReaderView_out;

            struct Sample_GetTime_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetTime_Response_, struct Sample_GetTime_Response_Seq_uniq_> Sample_GetTime_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetTime_Response_Seq> Sample_GetTime_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetTime_Response_Seq> Sample_GetTime_Response_Seq_out;

            class  Sample_GetTime_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetTime_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetTime_Response_TypeSupportInterface_var _var_type;

                static Sample_GetTime_Response_TypeSupportInterface_ptr _duplicate (Sample_GetTime_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetTime_Response_TypeSupportInterface () {};
                ~Sample_GetTime_Response_TypeSupportInterface () {};
            private:
                Sample_GetTime_Response_TypeSupportInterface (const Sample_GetTime_Response_TypeSupportInterface &);
                Sample_GetTime_Response_TypeSupportInterface & operator = (const Sample_GetTime_Response_TypeSupportInterface &);
            };

            class  Sample_GetTime_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetTime_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetTime_Response_DataWriter_var _var_type;

                static Sample_GetTime_Response_DataWriter_ptr _duplicate (Sample_GetTime_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetTime_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetTime_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetTime_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetTime_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetTime_Response_& instance_data) = 0;

            protected:
                Sample_GetTime_Response_DataWriter () {};
                ~Sample_GetTime_Response_DataWriter () {};
            private:
                Sample_GetTime_Response_DataWriter (const Sample_GetTime_Response_DataWriter &);
                Sample_GetTime_Response_DataWriter & operator = (const Sample_GetTime_Response_DataWriter &);
            };

            class  Sample_GetTime_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetTime_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetTime_Response_DataReader_var _var_type;

                static Sample_GetTime_Response_DataReader_ptr _duplicate (Sample_GetTime_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetTime_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetTime_Response_& instance) = 0;

            protected:
                Sample_GetTime_Response_DataReader () {};
                ~Sample_GetTime_Response_DataReader () {};
            private:
                Sample_GetTime_Response_DataReader (const Sample_GetTime_Response_DataReader &);
                Sample_GetTime_Response_DataReader & operator = (const Sample_GetTime_Response_DataReader &);
            };

            class  Sample_GetTime_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetTime_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetTime_Response_DataReaderView_var _var_type;

                static Sample_GetTime_Response_DataReaderView_ptr _duplicate (Sample_GetTime_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetTime_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetTime_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetTime_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetTime_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetTime_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetTime_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetTime_Response_& instance) = 0;

            protected:
                Sample_GetTime_Response_DataReaderView () {};
                ~Sample_GetTime_Response_DataReaderView () {};
            private:
                Sample_GetTime_Response_DataReaderView (const Sample_GetTime_Response_DataReaderView &);
                Sample_GetTime_Response_DataReaderView & operator = (const Sample_GetTime_Response_DataReaderView &);
            };
        }

    }

}

#endif
