#ifndef _H_706F604ED9571D3E0957837D90245B47_HasParam_DCPS_H_
#define _H_706F604ED9571D3E0957837D90245B47_HasParam_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HasParam_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class HasParam_Request_TypeSupportInterface;

            typedef HasParam_Request_TypeSupportInterface * HasParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Request_TypeSupportInterface> HasParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HasParam_Request_TypeSupportInterface> HasParam_Request_TypeSupportInterface_out;


            class HasParam_Request_DataWriter;

            typedef HasParam_Request_DataWriter * HasParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Request_DataWriter> HasParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < HasParam_Request_DataWriter> HasParam_Request_DataWriter_out;


            class HasParam_Request_DataReader;

            typedef HasParam_Request_DataReader * HasParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Request_DataReader> HasParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < HasParam_Request_DataReader> HasParam_Request_DataReader_out;


            class HasParam_Request_DataReaderView;

            typedef HasParam_Request_DataReaderView * HasParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Request_DataReaderView> HasParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HasParam_Request_DataReaderView> HasParam_Request_DataReaderView_out;

            struct HasParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HasParam_Request_, struct HasParam_Request_Seq_uniq_> HasParam_Request_Seq;
            typedef DDS_DCPSSequence_var < HasParam_Request_Seq> HasParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < HasParam_Request_Seq> HasParam_Request_Seq_out;

            class  HasParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HasParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef HasParam_Request_TypeSupportInterface_var _var_type;

                static HasParam_Request_TypeSupportInterface_ptr _duplicate (HasParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HasParam_Request_TypeSupportInterface () {};
                ~HasParam_Request_TypeSupportInterface () {};
            private:
                HasParam_Request_TypeSupportInterface (const HasParam_Request_TypeSupportInterface &);
                HasParam_Request_TypeSupportInterface & operator = (const HasParam_Request_TypeSupportInterface &);
            };

            class  HasParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HasParam_Request_DataWriter_ptr _ptr_type;
                typedef HasParam_Request_DataWriter_var _var_type;

                static HasParam_Request_DataWriter_ptr _duplicate (HasParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HasParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HasParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HasParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HasParam_Request_& instance_data) = 0;

            protected:
                HasParam_Request_DataWriter () {};
                ~HasParam_Request_DataWriter () {};
            private:
                HasParam_Request_DataWriter (const HasParam_Request_DataWriter &);
                HasParam_Request_DataWriter & operator = (const HasParam_Request_DataWriter &);
            };

            class  HasParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HasParam_Request_DataReader_ptr _ptr_type;
                typedef HasParam_Request_DataReader_var _var_type;

                static HasParam_Request_DataReader_ptr _duplicate (HasParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HasParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HasParam_Request_& instance) = 0;

            protected:
                HasParam_Request_DataReader () {};
                ~HasParam_Request_DataReader () {};
            private:
                HasParam_Request_DataReader (const HasParam_Request_DataReader &);
                HasParam_Request_DataReader & operator = (const HasParam_Request_DataReader &);
            };

            class  HasParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HasParam_Request_DataReaderView_ptr _ptr_type;
                typedef HasParam_Request_DataReaderView_var _var_type;

                static HasParam_Request_DataReaderView_ptr _duplicate (HasParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HasParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HasParam_Request_& instance) = 0;

            protected:
                HasParam_Request_DataReaderView () {};
                ~HasParam_Request_DataReaderView () {};
            private:
                HasParam_Request_DataReaderView (const HasParam_Request_DataReaderView &);
                HasParam_Request_DataReaderView & operator = (const HasParam_Request_DataReaderView &);
            };
            class HasParam_Response_TypeSupportInterface;

            typedef HasParam_Response_TypeSupportInterface * HasParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Response_TypeSupportInterface> HasParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HasParam_Response_TypeSupportInterface> HasParam_Response_TypeSupportInterface_out;


            class HasParam_Response_DataWriter;

            typedef HasParam_Response_DataWriter * HasParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Response_DataWriter> HasParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < HasParam_Response_DataWriter> HasParam_Response_DataWriter_out;


            class HasParam_Response_DataReader;

            typedef HasParam_Response_DataReader * HasParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Response_DataReader> HasParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < HasParam_Response_DataReader> HasParam_Response_DataReader_out;


            class HasParam_Response_DataReaderView;

            typedef HasParam_Response_DataReaderView * HasParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HasParam_Response_DataReaderView> HasParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HasParam_Response_DataReaderView> HasParam_Response_DataReaderView_out;

            struct HasParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HasParam_Response_, struct HasParam_Response_Seq_uniq_> HasParam_Response_Seq;
            typedef DDS_DCPSSequence_var < HasParam_Response_Seq> HasParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < HasParam_Response_Seq> HasParam_Response_Seq_out;

            class  HasParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HasParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef HasParam_Response_TypeSupportInterface_var _var_type;

                static HasParam_Response_TypeSupportInterface_ptr _duplicate (HasParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HasParam_Response_TypeSupportInterface () {};
                ~HasParam_Response_TypeSupportInterface () {};
            private:
                HasParam_Response_TypeSupportInterface (const HasParam_Response_TypeSupportInterface &);
                HasParam_Response_TypeSupportInterface & operator = (const HasParam_Response_TypeSupportInterface &);
            };

            class  HasParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HasParam_Response_DataWriter_ptr _ptr_type;
                typedef HasParam_Response_DataWriter_var _var_type;

                static HasParam_Response_DataWriter_ptr _duplicate (HasParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HasParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HasParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HasParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HasParam_Response_& instance_data) = 0;

            protected:
                HasParam_Response_DataWriter () {};
                ~HasParam_Response_DataWriter () {};
            private:
                HasParam_Response_DataWriter (const HasParam_Response_DataWriter &);
                HasParam_Response_DataWriter & operator = (const HasParam_Response_DataWriter &);
            };

            class  HasParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HasParam_Response_DataReader_ptr _ptr_type;
                typedef HasParam_Response_DataReader_var _var_type;

                static HasParam_Response_DataReader_ptr _duplicate (HasParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HasParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HasParam_Response_& instance) = 0;

            protected:
                HasParam_Response_DataReader () {};
                ~HasParam_Response_DataReader () {};
            private:
                HasParam_Response_DataReader (const HasParam_Response_DataReader &);
                HasParam_Response_DataReader & operator = (const HasParam_Response_DataReader &);
            };

            class  HasParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HasParam_Response_DataReaderView_ptr _ptr_type;
                typedef HasParam_Response_DataReaderView_var _var_type;

                static HasParam_Response_DataReaderView_ptr _duplicate (HasParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HasParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HasParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HasParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HasParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HasParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HasParam_Response_& instance) = 0;

            protected:
                HasParam_Response_DataReaderView () {};
                ~HasParam_Response_DataReaderView () {};
            private:
                HasParam_Response_DataReaderView (const HasParam_Response_DataReaderView &);
                HasParam_Response_DataReaderView & operator = (const HasParam_Response_DataReaderView &);
            };
            class Sample_HasParam_Request_TypeSupportInterface;

            typedef Sample_HasParam_Request_TypeSupportInterface * Sample_HasParam_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Request_TypeSupportInterface> Sample_HasParam_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Request_TypeSupportInterface> Sample_HasParam_Request_TypeSupportInterface_out;


            class Sample_HasParam_Request_DataWriter;

            typedef Sample_HasParam_Request_DataWriter * Sample_HasParam_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Request_DataWriter> Sample_HasParam_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Request_DataWriter> Sample_HasParam_Request_DataWriter_out;


            class Sample_HasParam_Request_DataReader;

            typedef Sample_HasParam_Request_DataReader * Sample_HasParam_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Request_DataReader> Sample_HasParam_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Request_DataReader> Sample_HasParam_Request_DataReader_out;


            class Sample_HasParam_Request_DataReaderView;

            typedef Sample_HasParam_Request_DataReaderView * Sample_HasParam_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Request_DataReaderView> Sample_HasParam_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Request_DataReaderView> Sample_HasParam_Request_DataReaderView_out;

            struct Sample_HasParam_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_HasParam_Request_, struct Sample_HasParam_Request_Seq_uniq_> Sample_HasParam_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_HasParam_Request_Seq> Sample_HasParam_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HasParam_Request_Seq> Sample_HasParam_Request_Seq_out;

            class  Sample_HasParam_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HasParam_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HasParam_Request_TypeSupportInterface_var _var_type;

                static Sample_HasParam_Request_TypeSupportInterface_ptr _duplicate (Sample_HasParam_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HasParam_Request_TypeSupportInterface () {};
                ~Sample_HasParam_Request_TypeSupportInterface () {};
            private:
                Sample_HasParam_Request_TypeSupportInterface (const Sample_HasParam_Request_TypeSupportInterface &);
                Sample_HasParam_Request_TypeSupportInterface & operator = (const Sample_HasParam_Request_TypeSupportInterface &);
            };

            class  Sample_HasParam_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HasParam_Request_DataWriter_ptr _ptr_type;
                typedef Sample_HasParam_Request_DataWriter_var _var_type;

                static Sample_HasParam_Request_DataWriter_ptr _duplicate (Sample_HasParam_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HasParam_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HasParam_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HasParam_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HasParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HasParam_Request_& instance_data) = 0;

            protected:
                Sample_HasParam_Request_DataWriter () {};
                ~Sample_HasParam_Request_DataWriter () {};
            private:
                Sample_HasParam_Request_DataWriter (const Sample_HasParam_Request_DataWriter &);
                Sample_HasParam_Request_DataWriter & operator = (const Sample_HasParam_Request_DataWriter &);
            };

            class  Sample_HasParam_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HasParam_Request_DataReader_ptr _ptr_type;
                typedef Sample_HasParam_Request_DataReader_var _var_type;

                static Sample_HasParam_Request_DataReader_ptr _duplicate (Sample_HasParam_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HasParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HasParam_Request_& instance) = 0;

            protected:
                Sample_HasParam_Request_DataReader () {};
                ~Sample_HasParam_Request_DataReader () {};
            private:
                Sample_HasParam_Request_DataReader (const Sample_HasParam_Request_DataReader &);
                Sample_HasParam_Request_DataReader & operator = (const Sample_HasParam_Request_DataReader &);
            };

            class  Sample_HasParam_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HasParam_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_HasParam_Request_DataReaderView_var _var_type;

                static Sample_HasParam_Request_DataReaderView_ptr _duplicate (Sample_HasParam_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HasParam_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HasParam_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HasParam_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HasParam_Request_& instance) = 0;

            protected:
                Sample_HasParam_Request_DataReaderView () {};
                ~Sample_HasParam_Request_DataReaderView () {};
            private:
                Sample_HasParam_Request_DataReaderView (const Sample_HasParam_Request_DataReaderView &);
                Sample_HasParam_Request_DataReaderView & operator = (const Sample_HasParam_Request_DataReaderView &);
            };
            class Sample_HasParam_Response_TypeSupportInterface;

            typedef Sample_HasParam_Response_TypeSupportInterface * Sample_HasParam_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Response_TypeSupportInterface> Sample_HasParam_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Response_TypeSupportInterface> Sample_HasParam_Response_TypeSupportInterface_out;


            class Sample_HasParam_Response_DataWriter;

            typedef Sample_HasParam_Response_DataWriter * Sample_HasParam_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Response_DataWriter> Sample_HasParam_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Response_DataWriter> Sample_HasParam_Response_DataWriter_out;


            class Sample_HasParam_Response_DataReader;

            typedef Sample_HasParam_Response_DataReader * Sample_HasParam_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Response_DataReader> Sample_HasParam_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Response_DataReader> Sample_HasParam_Response_DataReader_out;


            class Sample_HasParam_Response_DataReaderView;

            typedef Sample_HasParam_Response_DataReaderView * Sample_HasParam_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HasParam_Response_DataReaderView> Sample_HasParam_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HasParam_Response_DataReaderView> Sample_HasParam_Response_DataReaderView_out;

            struct Sample_HasParam_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_HasParam_Response_, struct Sample_HasParam_Response_Seq_uniq_> Sample_HasParam_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_HasParam_Response_Seq> Sample_HasParam_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HasParam_Response_Seq> Sample_HasParam_Response_Seq_out;

            class  Sample_HasParam_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HasParam_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HasParam_Response_TypeSupportInterface_var _var_type;

                static Sample_HasParam_Response_TypeSupportInterface_ptr _duplicate (Sample_HasParam_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HasParam_Response_TypeSupportInterface () {};
                ~Sample_HasParam_Response_TypeSupportInterface () {};
            private:
                Sample_HasParam_Response_TypeSupportInterface (const Sample_HasParam_Response_TypeSupportInterface &);
                Sample_HasParam_Response_TypeSupportInterface & operator = (const Sample_HasParam_Response_TypeSupportInterface &);
            };

            class  Sample_HasParam_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HasParam_Response_DataWriter_ptr _ptr_type;
                typedef Sample_HasParam_Response_DataWriter_var _var_type;

                static Sample_HasParam_Response_DataWriter_ptr _duplicate (Sample_HasParam_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HasParam_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HasParam_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HasParam_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HasParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HasParam_Response_& instance_data) = 0;

            protected:
                Sample_HasParam_Response_DataWriter () {};
                ~Sample_HasParam_Response_DataWriter () {};
            private:
                Sample_HasParam_Response_DataWriter (const Sample_HasParam_Response_DataWriter &);
                Sample_HasParam_Response_DataWriter & operator = (const Sample_HasParam_Response_DataWriter &);
            };

            class  Sample_HasParam_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HasParam_Response_DataReader_ptr _ptr_type;
                typedef Sample_HasParam_Response_DataReader_var _var_type;

                static Sample_HasParam_Response_DataReader_ptr _duplicate (Sample_HasParam_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HasParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HasParam_Response_& instance) = 0;

            protected:
                Sample_HasParam_Response_DataReader () {};
                ~Sample_HasParam_Response_DataReader () {};
            private:
                Sample_HasParam_Response_DataReader (const Sample_HasParam_Response_DataReader &);
                Sample_HasParam_Response_DataReader & operator = (const Sample_HasParam_Response_DataReader &);
            };

            class  Sample_HasParam_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HasParam_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_HasParam_Response_DataReaderView_var _var_type;

                static Sample_HasParam_Response_DataReaderView_ptr _duplicate (Sample_HasParam_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HasParam_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HasParam_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HasParam_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HasParam_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HasParam_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HasParam_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HasParam_Response_& instance) = 0;

            protected:
                Sample_HasParam_Response_DataReaderView () {};
                ~Sample_HasParam_Response_DataReaderView () {};
            private:
                Sample_HasParam_Response_DataReaderView (const Sample_HasParam_Response_DataReaderView &);
                Sample_HasParam_Response_DataReaderView & operator = (const Sample_HasParam_Response_DataReaderView &);
            };
        }

    }

}

#endif
