#ifndef _H_512BE632714FE8327C11518CB8C6CF2F_Nodes__H_
#define _H_512BE632714FE8327C11518CB8C6CF2F_Nodes__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  Nodes_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Nodes_Request_> Nodes_Request__var;
            typedef Nodes_Request_& Nodes_Request__out;

            struct  Nodes_Response_
            {
                struct _nodes__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _nodes__seq_uniq_ > _nodes__seq;
                typedef DDS_DCPSUStrSeq_var< _nodes__seq > _nodes__seq_var;
                typedef DDS_DCPSUStrSeq_out< _nodes__seq > _nodes__seq_out;
                _nodes__seq nodes_;
            };

            typedef DDS_DCPSStruct_var<Nodes_Response_> Nodes_Response__var;
            typedef DDS_DCPSStruct_out < Nodes_Response_> Nodes_Response__out;

            struct  Sample_Nodes_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Nodes_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Nodes_Request_> Sample_Nodes_Request__var;
            typedef Sample_Nodes_Request_& Sample_Nodes_Request__out;

            struct  Sample_Nodes_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Nodes_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Nodes_Response_> Sample_Nodes_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Nodes_Response_> Sample_Nodes_Response__out;

        }

    }

}

#endif /* _H_512BE632714FE8327C11518CB8C6CF2F_Nodes__H_ */
