#ifndef _H_512BE632714FE8327C11518CB8C6CF2F_Nodes_DCPS_H_
#define _H_512BE632714FE8327C11518CB8C6CF2F_Nodes_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Nodes_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class Nodes_Request_TypeSupportInterface;

            typedef Nodes_Request_TypeSupportInterface * Nodes_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Request_TypeSupportInterface> Nodes_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Nodes_Request_TypeSupportInterface> Nodes_Request_TypeSupportInterface_out;


            class Nodes_Request_DataWriter;

            typedef Nodes_Request_DataWriter * Nodes_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Request_DataWriter> Nodes_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Nodes_Request_DataWriter> Nodes_Request_DataWriter_out;


            class Nodes_Request_DataReader;

            typedef Nodes_Request_DataReader * Nodes_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Request_DataReader> Nodes_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Nodes_Request_DataReader> Nodes_Request_DataReader_out;


            class Nodes_Request_DataReaderView;

            typedef Nodes_Request_DataReaderView * Nodes_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Request_DataReaderView> Nodes_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Nodes_Request_DataReaderView> Nodes_Request_DataReaderView_out;

            struct Nodes_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Nodes_Request_, struct Nodes_Request_Seq_uniq_> Nodes_Request_Seq;
            typedef DDS_DCPSSequence_var < Nodes_Request_Seq> Nodes_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Nodes_Request_Seq> Nodes_Request_Seq_out;

            class  Nodes_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Nodes_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Nodes_Request_TypeSupportInterface_var _var_type;

                static Nodes_Request_TypeSupportInterface_ptr _duplicate (Nodes_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Nodes_Request_TypeSupportInterface () {};
                ~Nodes_Request_TypeSupportInterface () {};
            private:
                Nodes_Request_TypeSupportInterface (const Nodes_Request_TypeSupportInterface &);
                Nodes_Request_TypeSupportInterface & operator = (const Nodes_Request_TypeSupportInterface &);
            };

            class  Nodes_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Nodes_Request_DataWriter_ptr _ptr_type;
                typedef Nodes_Request_DataWriter_var _var_type;

                static Nodes_Request_DataWriter_ptr _duplicate (Nodes_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Nodes_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Nodes_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Nodes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Nodes_Request_& instance_data) = 0;

            protected:
                Nodes_Request_DataWriter () {};
                ~Nodes_Request_DataWriter () {};
            private:
                Nodes_Request_DataWriter (const Nodes_Request_DataWriter &);
                Nodes_Request_DataWriter & operator = (const Nodes_Request_DataWriter &);
            };

            class  Nodes_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Nodes_Request_DataReader_ptr _ptr_type;
                typedef Nodes_Request_DataReader_var _var_type;

                static Nodes_Request_DataReader_ptr _duplicate (Nodes_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Nodes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Nodes_Request_& instance) = 0;

            protected:
                Nodes_Request_DataReader () {};
                ~Nodes_Request_DataReader () {};
            private:
                Nodes_Request_DataReader (const Nodes_Request_DataReader &);
                Nodes_Request_DataReader & operator = (const Nodes_Request_DataReader &);
            };

            class  Nodes_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Nodes_Request_DataReaderView_ptr _ptr_type;
                typedef Nodes_Request_DataReaderView_var _var_type;

                static Nodes_Request_DataReaderView_ptr _duplicate (Nodes_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Nodes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Nodes_Request_& instance) = 0;

            protected:
                Nodes_Request_DataReaderView () {};
                ~Nodes_Request_DataReaderView () {};
            private:
                Nodes_Request_DataReaderView (const Nodes_Request_DataReaderView &);
                Nodes_Request_DataReaderView & operator = (const Nodes_Request_DataReaderView &);
            };
            class Nodes_Response_TypeSupportInterface;

            typedef Nodes_Response_TypeSupportInterface * Nodes_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Response_TypeSupportInterface> Nodes_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Nodes_Response_TypeSupportInterface> Nodes_Response_TypeSupportInterface_out;


            class Nodes_Response_DataWriter;

            typedef Nodes_Response_DataWriter * Nodes_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Response_DataWriter> Nodes_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Nodes_Response_DataWriter> Nodes_Response_DataWriter_out;


            class Nodes_Response_DataReader;

            typedef Nodes_Response_DataReader * Nodes_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Response_DataReader> Nodes_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Nodes_Response_DataReader> Nodes_Response_DataReader_out;


            class Nodes_Response_DataReaderView;

            typedef Nodes_Response_DataReaderView * Nodes_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Nodes_Response_DataReaderView> Nodes_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Nodes_Response_DataReaderView> Nodes_Response_DataReaderView_out;

            struct Nodes_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Nodes_Response_, struct Nodes_Response_Seq_uniq_> Nodes_Response_Seq;
            typedef DDS_DCPSSequence_var < Nodes_Response_Seq> Nodes_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Nodes_Response_Seq> Nodes_Response_Seq_out;

            class  Nodes_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Nodes_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Nodes_Response_TypeSupportInterface_var _var_type;

                static Nodes_Response_TypeSupportInterface_ptr _duplicate (Nodes_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Nodes_Response_TypeSupportInterface () {};
                ~Nodes_Response_TypeSupportInterface () {};
            private:
                Nodes_Response_TypeSupportInterface (const Nodes_Response_TypeSupportInterface &);
                Nodes_Response_TypeSupportInterface & operator = (const Nodes_Response_TypeSupportInterface &);
            };

            class  Nodes_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Nodes_Response_DataWriter_ptr _ptr_type;
                typedef Nodes_Response_DataWriter_var _var_type;

                static Nodes_Response_DataWriter_ptr _duplicate (Nodes_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Nodes_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Nodes_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Nodes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Nodes_Response_& instance_data) = 0;

            protected:
                Nodes_Response_DataWriter () {};
                ~Nodes_Response_DataWriter () {};
            private:
                Nodes_Response_DataWriter (const Nodes_Response_DataWriter &);
                Nodes_Response_DataWriter & operator = (const Nodes_Response_DataWriter &);
            };

            class  Nodes_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Nodes_Response_DataReader_ptr _ptr_type;
                typedef Nodes_Response_DataReader_var _var_type;

                static Nodes_Response_DataReader_ptr _duplicate (Nodes_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Nodes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Nodes_Response_& instance) = 0;

            protected:
                Nodes_Response_DataReader () {};
                ~Nodes_Response_DataReader () {};
            private:
                Nodes_Response_DataReader (const Nodes_Response_DataReader &);
                Nodes_Response_DataReader & operator = (const Nodes_Response_DataReader &);
            };

            class  Nodes_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Nodes_Response_DataReaderView_ptr _ptr_type;
                typedef Nodes_Response_DataReaderView_var _var_type;

                static Nodes_Response_DataReaderView_ptr _duplicate (Nodes_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Nodes_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Nodes_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Nodes_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Nodes_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Nodes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Nodes_Response_& instance) = 0;

            protected:
                Nodes_Response_DataReaderView () {};
                ~Nodes_Response_DataReaderView () {};
            private:
                Nodes_Response_DataReaderView (const Nodes_Response_DataReaderView &);
                Nodes_Response_DataReaderView & operator = (const Nodes_Response_DataReaderView &);
            };
            class Sample_Nodes_Request_TypeSupportInterface;

            typedef Sample_Nodes_Request_TypeSupportInterface * Sample_Nodes_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Request_TypeSupportInterface> Sample_Nodes_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Request_TypeSupportInterface> Sample_Nodes_Request_TypeSupportInterface_out;


            class Sample_Nodes_Request_DataWriter;

            typedef Sample_Nodes_Request_DataWriter * Sample_Nodes_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Request_DataWriter> Sample_Nodes_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Request_DataWriter> Sample_Nodes_Request_DataWriter_out;


            class Sample_Nodes_Request_DataReader;

            typedef Sample_Nodes_Request_DataReader * Sample_Nodes_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Request_DataReader> Sample_Nodes_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Request_DataReader> Sample_Nodes_Request_DataReader_out;


            class Sample_Nodes_Request_DataReaderView;

            typedef Sample_Nodes_Request_DataReaderView * Sample_Nodes_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Request_DataReaderView> Sample_Nodes_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Request_DataReaderView> Sample_Nodes_Request_DataReaderView_out;

            struct Sample_Nodes_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Nodes_Request_, struct Sample_Nodes_Request_Seq_uniq_> Sample_Nodes_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Nodes_Request_Seq> Sample_Nodes_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Nodes_Request_Seq> Sample_Nodes_Request_Seq_out;

            class  Sample_Nodes_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Nodes_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Nodes_Request_TypeSupportInterface_var _var_type;

                static Sample_Nodes_Request_TypeSupportInterface_ptr _duplicate (Sample_Nodes_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Nodes_Request_TypeSupportInterface () {};
                ~Sample_Nodes_Request_TypeSupportInterface () {};
            private:
                Sample_Nodes_Request_TypeSupportInterface (const Sample_Nodes_Request_TypeSupportInterface &);
                Sample_Nodes_Request_TypeSupportInterface & operator = (const Sample_Nodes_Request_TypeSupportInterface &);
            };

            class  Sample_Nodes_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Nodes_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Nodes_Request_DataWriter_var _var_type;

                static Sample_Nodes_Request_DataWriter_ptr _duplicate (Sample_Nodes_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Nodes_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Nodes_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Nodes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Nodes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Nodes_Request_& instance_data) = 0;

            protected:
                Sample_Nodes_Request_DataWriter () {};
                ~Sample_Nodes_Request_DataWriter () {};
            private:
                Sample_Nodes_Request_DataWriter (const Sample_Nodes_Request_DataWriter &);
                Sample_Nodes_Request_DataWriter & operator = (const Sample_Nodes_Request_DataWriter &);
            };

            class  Sample_Nodes_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Nodes_Request_DataReader_ptr _ptr_type;
                typedef Sample_Nodes_Request_DataReader_var _var_type;

                static Sample_Nodes_Request_DataReader_ptr _duplicate (Sample_Nodes_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Nodes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Nodes_Request_& instance) = 0;

            protected:
                Sample_Nodes_Request_DataReader () {};
                ~Sample_Nodes_Request_DataReader () {};
            private:
                Sample_Nodes_Request_DataReader (const Sample_Nodes_Request_DataReader &);
                Sample_Nodes_Request_DataReader & operator = (const Sample_Nodes_Request_DataReader &);
            };

            class  Sample_Nodes_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Nodes_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Nodes_Request_DataReaderView_var _var_type;

                static Sample_Nodes_Request_DataReaderView_ptr _duplicate (Sample_Nodes_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Nodes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Nodes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Nodes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Nodes_Request_& instance) = 0;

            protected:
                Sample_Nodes_Request_DataReaderView () {};
                ~Sample_Nodes_Request_DataReaderView () {};
            private:
                Sample_Nodes_Request_DataReaderView (const Sample_Nodes_Request_DataReaderView &);
                Sample_Nodes_Request_DataReaderView & operator = (const Sample_Nodes_Request_DataReaderView &);
            };
            class Sample_Nodes_Response_TypeSupportInterface;

            typedef Sample_Nodes_Response_TypeSupportInterface * Sample_Nodes_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Response_TypeSupportInterface> Sample_Nodes_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Response_TypeSupportInterface> Sample_Nodes_Response_TypeSupportInterface_out;


            class Sample_Nodes_Response_DataWriter;

            typedef Sample_Nodes_Response_DataWriter * Sample_Nodes_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Response_DataWriter> Sample_Nodes_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Response_DataWriter> Sample_Nodes_Response_DataWriter_out;


            class Sample_Nodes_Response_DataReader;

            typedef Sample_Nodes_Response_DataReader * Sample_Nodes_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Response_DataReader> Sample_Nodes_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Response_DataReader> Sample_Nodes_Response_DataReader_out;


            class Sample_Nodes_Response_DataReaderView;

            typedef Sample_Nodes_Response_DataReaderView * Sample_Nodes_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Nodes_Response_DataReaderView> Sample_Nodes_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Nodes_Response_DataReaderView> Sample_Nodes_Response_DataReaderView_out;

            struct Sample_Nodes_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Nodes_Response_, struct Sample_Nodes_Response_Seq_uniq_> Sample_Nodes_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Nodes_Response_Seq> Sample_Nodes_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Nodes_Response_Seq> Sample_Nodes_Response_Seq_out;

            class  Sample_Nodes_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Nodes_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Nodes_Response_TypeSupportInterface_var _var_type;

                static Sample_Nodes_Response_TypeSupportInterface_ptr _duplicate (Sample_Nodes_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Nodes_Response_TypeSupportInterface () {};
                ~Sample_Nodes_Response_TypeSupportInterface () {};
            private:
                Sample_Nodes_Response_TypeSupportInterface (const Sample_Nodes_Response_TypeSupportInterface &);
                Sample_Nodes_Response_TypeSupportInterface & operator = (const Sample_Nodes_Response_TypeSupportInterface &);
            };

            class  Sample_Nodes_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Nodes_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Nodes_Response_DataWriter_var _var_type;

                static Sample_Nodes_Response_DataWriter_ptr _duplicate (Sample_Nodes_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Nodes_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Nodes_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Nodes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Nodes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Nodes_Response_& instance_data) = 0;

            protected:
                Sample_Nodes_Response_DataWriter () {};
                ~Sample_Nodes_Response_DataWriter () {};
            private:
                Sample_Nodes_Response_DataWriter (const Sample_Nodes_Response_DataWriter &);
                Sample_Nodes_Response_DataWriter & operator = (const Sample_Nodes_Response_DataWriter &);
            };

            class  Sample_Nodes_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Nodes_Response_DataReader_ptr _ptr_type;
                typedef Sample_Nodes_Response_DataReader_var _var_type;

                static Sample_Nodes_Response_DataReader_ptr _duplicate (Sample_Nodes_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Nodes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Nodes_Response_& instance) = 0;

            protected:
                Sample_Nodes_Response_DataReader () {};
                ~Sample_Nodes_Response_DataReader () {};
            private:
                Sample_Nodes_Response_DataReader (const Sample_Nodes_Response_DataReader &);
                Sample_Nodes_Response_DataReader & operator = (const Sample_Nodes_Response_DataReader &);
            };

            class  Sample_Nodes_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Nodes_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Nodes_Response_DataReaderView_var _var_type;

                static Sample_Nodes_Response_DataReaderView_ptr _duplicate (Sample_Nodes_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Nodes_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Nodes_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Nodes_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Nodes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Nodes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Nodes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Nodes_Response_& instance) = 0;

            protected:
                Sample_Nodes_Response_DataReaderView () {};
                ~Sample_Nodes_Response_DataReaderView () {};
            private:
                Sample_Nodes_Response_DataReaderView (const Sample_Nodes_Response_DataReaderView &);
                Sample_Nodes_Response_DataReaderView & operator = (const Sample_Nodes_Response_DataReaderView &);
            };
        }

    }

}

#endif
