#ifndef _H_839EE94BC50DA29502C66CA2E0D0A317_ServiceNode_DCPS_H_
#define _H_839EE94BC50DA29502C66CA2E0D0A317_ServiceNode_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceNode_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class ServiceNode_Request_TypeSupportInterface;

            typedef ServiceNode_Request_TypeSupportInterface * ServiceNode_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Request_TypeSupportInterface> ServiceNode_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Request_TypeSupportInterface> ServiceNode_Request_TypeSupportInterface_out;


            class ServiceNode_Request_DataWriter;

            typedef ServiceNode_Request_DataWriter * ServiceNode_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Request_DataWriter> ServiceNode_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Request_DataWriter> ServiceNode_Request_DataWriter_out;


            class ServiceNode_Request_DataReader;

            typedef ServiceNode_Request_DataReader * ServiceNode_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Request_DataReader> ServiceNode_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Request_DataReader> ServiceNode_Request_DataReader_out;


            class ServiceNode_Request_DataReaderView;

            typedef ServiceNode_Request_DataReaderView * ServiceNode_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Request_DataReaderView> ServiceNode_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Request_DataReaderView> ServiceNode_Request_DataReaderView_out;

            struct ServiceNode_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceNode_Request_, struct ServiceNode_Request_Seq_uniq_> ServiceNode_Request_Seq;
            typedef DDS_DCPSSequence_var < ServiceNode_Request_Seq> ServiceNode_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceNode_Request_Seq> ServiceNode_Request_Seq_out;

            class  ServiceNode_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceNode_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceNode_Request_TypeSupportInterface_var _var_type;

                static ServiceNode_Request_TypeSupportInterface_ptr _duplicate (ServiceNode_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceNode_Request_TypeSupportInterface () {};
                ~ServiceNode_Request_TypeSupportInterface () {};
            private:
                ServiceNode_Request_TypeSupportInterface (const ServiceNode_Request_TypeSupportInterface &);
                ServiceNode_Request_TypeSupportInterface & operator = (const ServiceNode_Request_TypeSupportInterface &);
            };

            class  ServiceNode_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceNode_Request_DataWriter_ptr _ptr_type;
                typedef ServiceNode_Request_DataWriter_var _var_type;

                static ServiceNode_Request_DataWriter_ptr _duplicate (ServiceNode_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceNode_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceNode_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceNode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceNode_Request_& instance_data) = 0;

            protected:
                ServiceNode_Request_DataWriter () {};
                ~ServiceNode_Request_DataWriter () {};
            private:
                ServiceNode_Request_DataWriter (const ServiceNode_Request_DataWriter &);
                ServiceNode_Request_DataWriter & operator = (const ServiceNode_Request_DataWriter &);
            };

            class  ServiceNode_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceNode_Request_DataReader_ptr _ptr_type;
                typedef ServiceNode_Request_DataReader_var _var_type;

                static ServiceNode_Request_DataReader_ptr _duplicate (ServiceNode_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceNode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceNode_Request_& instance) = 0;

            protected:
                ServiceNode_Request_DataReader () {};
                ~ServiceNode_Request_DataReader () {};
            private:
                ServiceNode_Request_DataReader (const ServiceNode_Request_DataReader &);
                ServiceNode_Request_DataReader & operator = (const ServiceNode_Request_DataReader &);
            };

            class  ServiceNode_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceNode_Request_DataReaderView_ptr _ptr_type;
                typedef ServiceNode_Request_DataReaderView_var _var_type;

                static ServiceNode_Request_DataReaderView_ptr _duplicate (ServiceNode_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceNode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceNode_Request_& instance) = 0;

            protected:
                ServiceNode_Request_DataReaderView () {};
                ~ServiceNode_Request_DataReaderView () {};
            private:
                ServiceNode_Request_DataReaderView (const ServiceNode_Request_DataReaderView &);
                ServiceNode_Request_DataReaderView & operator = (const ServiceNode_Request_DataReaderView &);
            };
            class ServiceNode_Response_TypeSupportInterface;

            typedef ServiceNode_Response_TypeSupportInterface * ServiceNode_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Response_TypeSupportInterface> ServiceNode_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Response_TypeSupportInterface> ServiceNode_Response_TypeSupportInterface_out;


            class ServiceNode_Response_DataWriter;

            typedef ServiceNode_Response_DataWriter * ServiceNode_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Response_DataWriter> ServiceNode_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Response_DataWriter> ServiceNode_Response_DataWriter_out;


            class ServiceNode_Response_DataReader;

            typedef ServiceNode_Response_DataReader * ServiceNode_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Response_DataReader> ServiceNode_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Response_DataReader> ServiceNode_Response_DataReader_out;


            class ServiceNode_Response_DataReaderView;

            typedef ServiceNode_Response_DataReaderView * ServiceNode_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceNode_Response_DataReaderView> ServiceNode_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceNode_Response_DataReaderView> ServiceNode_Response_DataReaderView_out;

            struct ServiceNode_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceNode_Response_, struct ServiceNode_Response_Seq_uniq_> ServiceNode_Response_Seq;
            typedef DDS_DCPSSequence_var < ServiceNode_Response_Seq> ServiceNode_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceNode_Response_Seq> ServiceNode_Response_Seq_out;

            class  ServiceNode_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceNode_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceNode_Response_TypeSupportInterface_var _var_type;

                static ServiceNode_Response_TypeSupportInterface_ptr _duplicate (ServiceNode_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceNode_Response_TypeSupportInterface () {};
                ~ServiceNode_Response_TypeSupportInterface () {};
            private:
                ServiceNode_Response_TypeSupportInterface (const ServiceNode_Response_TypeSupportInterface &);
                ServiceNode_Response_TypeSupportInterface & operator = (const ServiceNode_Response_TypeSupportInterface &);
            };

            class  ServiceNode_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceNode_Response_DataWriter_ptr _ptr_type;
                typedef ServiceNode_Response_DataWriter_var _var_type;

                static ServiceNode_Response_DataWriter_ptr _duplicate (ServiceNode_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceNode_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceNode_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceNode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceNode_Response_& instance_data) = 0;

            protected:
                ServiceNode_Response_DataWriter () {};
                ~ServiceNode_Response_DataWriter () {};
            private:
                ServiceNode_Response_DataWriter (const ServiceNode_Response_DataWriter &);
                ServiceNode_Response_DataWriter & operator = (const ServiceNode_Response_DataWriter &);
            };

            class  ServiceNode_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceNode_Response_DataReader_ptr _ptr_type;
                typedef ServiceNode_Response_DataReader_var _var_type;

                static ServiceNode_Response_DataReader_ptr _duplicate (ServiceNode_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceNode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceNode_Response_& instance) = 0;

            protected:
                ServiceNode_Response_DataReader () {};
                ~ServiceNode_Response_DataReader () {};
            private:
                ServiceNode_Response_DataReader (const ServiceNode_Response_DataReader &);
                ServiceNode_Response_DataReader & operator = (const ServiceNode_Response_DataReader &);
            };

            class  ServiceNode_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceNode_Response_DataReaderView_ptr _ptr_type;
                typedef ServiceNode_Response_DataReaderView_var _var_type;

                static ServiceNode_Response_DataReaderView_ptr _duplicate (ServiceNode_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceNode_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceNode_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceNode_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceNode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceNode_Response_& instance) = 0;

            protected:
                ServiceNode_Response_DataReaderView () {};
                ~ServiceNode_Response_DataReaderView () {};
            private:
                ServiceNode_Response_DataReaderView (const ServiceNode_Response_DataReaderView &);
                ServiceNode_Response_DataReaderView & operator = (const ServiceNode_Response_DataReaderView &);
            };
            class Sample_ServiceNode_Request_TypeSupportInterface;

            typedef Sample_ServiceNode_Request_TypeSupportInterface * Sample_ServiceNode_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Request_TypeSupportInterface> Sample_ServiceNode_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Request_TypeSupportInterface> Sample_ServiceNode_Request_TypeSupportInterface_out;


            class Sample_ServiceNode_Request_DataWriter;

            typedef Sample_ServiceNode_Request_DataWriter * Sample_ServiceNode_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Request_DataWriter> Sample_ServiceNode_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Request_DataWriter> Sample_ServiceNode_Request_DataWriter_out;


            class Sample_ServiceNode_Request_DataReader;

            typedef Sample_ServiceNode_Request_DataReader * Sample_ServiceNode_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Request_DataReader> Sample_ServiceNode_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Request_DataReader> Sample_ServiceNode_Request_DataReader_out;


            class Sample_ServiceNode_Request_DataReaderView;

            typedef Sample_ServiceNode_Request_DataReaderView * Sample_ServiceNode_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Request_DataReaderView> Sample_ServiceNode_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Request_DataReaderView> Sample_ServiceNode_Request_DataReaderView_out;

            struct Sample_ServiceNode_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceNode_Request_, struct Sample_ServiceNode_Request_Seq_uniq_> Sample_ServiceNode_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceNode_Request_Seq> Sample_ServiceNode_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceNode_Request_Seq> Sample_ServiceNode_Request_Seq_out;

            class  Sample_ServiceNode_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceNode_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceNode_Request_TypeSupportInterface_var _var_type;

                static Sample_ServiceNode_Request_TypeSupportInterface_ptr _duplicate (Sample_ServiceNode_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceNode_Request_TypeSupportInterface () {};
                ~Sample_ServiceNode_Request_TypeSupportInterface () {};
            private:
                Sample_ServiceNode_Request_TypeSupportInterface (const Sample_ServiceNode_Request_TypeSupportInterface &);
                Sample_ServiceNode_Request_TypeSupportInterface & operator = (const Sample_ServiceNode_Request_TypeSupportInterface &);
            };

            class  Sample_ServiceNode_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceNode_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceNode_Request_DataWriter_var _var_type;

                static Sample_ServiceNode_Request_DataWriter_ptr _duplicate (Sample_ServiceNode_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceNode_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceNode_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceNode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceNode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceNode_Request_& instance_data) = 0;

            protected:
                Sample_ServiceNode_Request_DataWriter () {};
                ~Sample_ServiceNode_Request_DataWriter () {};
            private:
                Sample_ServiceNode_Request_DataWriter (const Sample_ServiceNode_Request_DataWriter &);
                Sample_ServiceNode_Request_DataWriter & operator = (const Sample_ServiceNode_Request_DataWriter &);
            };

            class  Sample_ServiceNode_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceNode_Request_DataReader_ptr _ptr_type;
                typedef Sample_ServiceNode_Request_DataReader_var _var_type;

                static Sample_ServiceNode_Request_DataReader_ptr _duplicate (Sample_ServiceNode_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceNode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceNode_Request_& instance) = 0;

            protected:
                Sample_ServiceNode_Request_DataReader () {};
                ~Sample_ServiceNode_Request_DataReader () {};
            private:
                Sample_ServiceNode_Request_DataReader (const Sample_ServiceNode_Request_DataReader &);
                Sample_ServiceNode_Request_DataReader & operator = (const Sample_ServiceNode_Request_DataReader &);
            };

            class  Sample_ServiceNode_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceNode_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceNode_Request_DataReaderView_var _var_type;

                static Sample_ServiceNode_Request_DataReaderView_ptr _duplicate (Sample_ServiceNode_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceNode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceNode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceNode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceNode_Request_& instance) = 0;

            protected:
                Sample_ServiceNode_Request_DataReaderView () {};
                ~Sample_ServiceNode_Request_DataReaderView () {};
            private:
                Sample_ServiceNode_Request_DataReaderView (const Sample_ServiceNode_Request_DataReaderView &);
                Sample_ServiceNode_Request_DataReaderView & operator = (const Sample_ServiceNode_Request_DataReaderView &);
            };
            class Sample_ServiceNode_Response_TypeSupportInterface;

            typedef Sample_ServiceNode_Response_TypeSupportInterface * Sample_ServiceNode_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Response_TypeSupportInterface> Sample_ServiceNode_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Response_TypeSupportInterface> Sample_ServiceNode_Response_TypeSupportInterface_out;


            class Sample_ServiceNode_Response_DataWriter;

            typedef Sample_ServiceNode_Response_DataWriter * Sample_ServiceNode_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Response_DataWriter> Sample_ServiceNode_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Response_DataWriter> Sample_ServiceNode_Response_DataWriter_out;


            class Sample_ServiceNode_Response_DataReader;

            typedef Sample_ServiceNode_Response_DataReader * Sample_ServiceNode_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Response_DataReader> Sample_ServiceNode_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Response_DataReader> Sample_ServiceNode_Response_DataReader_out;


            class Sample_ServiceNode_Response_DataReaderView;

            typedef Sample_ServiceNode_Response_DataReaderView * Sample_ServiceNode_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceNode_Response_DataReaderView> Sample_ServiceNode_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceNode_Response_DataReaderView> Sample_ServiceNode_Response_DataReaderView_out;

            struct Sample_ServiceNode_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceNode_Response_, struct Sample_ServiceNode_Response_Seq_uniq_> Sample_ServiceNode_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceNode_Response_Seq> Sample_ServiceNode_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceNode_Response_Seq> Sample_ServiceNode_Response_Seq_out;

            class  Sample_ServiceNode_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceNode_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceNode_Response_TypeSupportInterface_var _var_type;

                static Sample_ServiceNode_Response_TypeSupportInterface_ptr _duplicate (Sample_ServiceNode_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceNode_Response_TypeSupportInterface () {};
                ~Sample_ServiceNode_Response_TypeSupportInterface () {};
            private:
                Sample_ServiceNode_Response_TypeSupportInterface (const Sample_ServiceNode_Response_TypeSupportInterface &);
                Sample_ServiceNode_Response_TypeSupportInterface & operator = (const Sample_ServiceNode_Response_TypeSupportInterface &);
            };

            class  Sample_ServiceNode_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceNode_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceNode_Response_DataWriter_var _var_type;

                static Sample_ServiceNode_Response_DataWriter_ptr _duplicate (Sample_ServiceNode_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceNode_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceNode_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceNode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceNode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceNode_Response_& instance_data) = 0;

            protected:
                Sample_ServiceNode_Response_DataWriter () {};
                ~Sample_ServiceNode_Response_DataWriter () {};
            private:
                Sample_ServiceNode_Response_DataWriter (const Sample_ServiceNode_Response_DataWriter &);
                Sample_ServiceNode_Response_DataWriter & operator = (const Sample_ServiceNode_Response_DataWriter &);
            };

            class  Sample_ServiceNode_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceNode_Response_DataReader_ptr _ptr_type;
                typedef Sample_ServiceNode_Response_DataReader_var _var_type;

                static Sample_ServiceNode_Response_DataReader_ptr _duplicate (Sample_ServiceNode_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceNode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceNode_Response_& instance) = 0;

            protected:
                Sample_ServiceNode_Response_DataReader () {};
                ~Sample_ServiceNode_Response_DataReader () {};
            private:
                Sample_ServiceNode_Response_DataReader (const Sample_ServiceNode_Response_DataReader &);
                Sample_ServiceNode_Response_DataReader & operator = (const Sample_ServiceNode_Response_DataReader &);
            };

            class  Sample_ServiceNode_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceNode_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceNode_Response_DataReaderView_var _var_type;

                static Sample_ServiceNode_Response_DataReaderView_ptr _duplicate (Sample_ServiceNode_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceNode_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceNode_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceNode_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceNode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceNode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceNode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceNode_Response_& instance) = 0;

            protected:
                Sample_ServiceNode_Response_DataReaderView () {};
                ~Sample_ServiceNode_Response_DataReaderView () {};
            private:
                Sample_ServiceNode_Response_DataReaderView (const Sample_ServiceNode_Response_DataReaderView &);
                Sample_ServiceNode_Response_DataReaderView & operator = (const Sample_ServiceNode_Response_DataReaderView &);
            };
        }

    }

}

#endif
