#ifndef _H_EE81AAD4D759D9DBC2779C22957189DC_ServiceProviders__H_
#define _H_EE81AAD4D759D9DBC2779C22957189DC_ServiceProviders__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  ServiceProviders_Request_
            {
                ::DDS::String_mgr service_;
            };

            typedef DDS_DCPSStruct_var<ServiceProviders_Request_> ServiceProviders_Request__var;
            typedef DDS_DCPSStruct_out < ServiceProviders_Request_> ServiceProviders_Request__out;

            struct  ServiceProviders_Response_
            {
                struct _providers__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _providers__seq_uniq_ > _providers__seq;
                typedef DDS_DCPSUStrSeq_var< _providers__seq > _providers__seq_var;
                typedef DDS_DCPSUStrSeq_out< _providers__seq > _providers__seq_out;
                _providers__seq providers_;
            };

            typedef DDS_DCPSStruct_var<ServiceProviders_Response_> ServiceProviders_Response__var;
            typedef DDS_DCPSStruct_out < ServiceProviders_Response_> ServiceProviders_Response__out;

            struct  Sample_ServiceProviders_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceProviders_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceProviders_Request_> Sample_ServiceProviders_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceProviders_Request_> Sample_ServiceProviders_Request__out;

            struct  Sample_ServiceProviders_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::ServiceProviders_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ServiceProviders_Response_> Sample_ServiceProviders_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ServiceProviders_Response_> Sample_ServiceProviders_Response__out;

        }

    }

}

#endif /* _H_EE81AAD4D759D9DBC2779C22957189DC_ServiceProviders__H_ */
