#ifndef _H_50CE33FEEC45FE6C0EDD85013DC7448B_ServiceRequestDetails_DCPS_H_
#define _H_50CE33FEEC45FE6C0EDD85013DC7448B_ServiceRequestDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceRequestDetails_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class ServiceRequestDetails_Request_TypeSupportInterface;

            typedef ServiceRequestDetails_Request_TypeSupportInterface * ServiceRequestDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Request_TypeSupportInterface> ServiceRequestDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Request_TypeSupportInterface> ServiceRequestDetails_Request_TypeSupportInterface_out;


            class ServiceRequestDetails_Request_DataWriter;

            typedef ServiceRequestDetails_Request_DataWriter * ServiceRequestDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Request_DataWriter> ServiceRequestDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Request_DataWriter> ServiceRequestDetails_Request_DataWriter_out;


            class ServiceRequestDetails_Request_DataReader;

            typedef ServiceRequestDetails_Request_DataReader * ServiceRequestDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Request_DataReader> ServiceRequestDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Request_DataReader> ServiceRequestDetails_Request_DataReader_out;


            class ServiceRequestDetails_Request_DataReaderView;

            typedef ServiceRequestDetails_Request_DataReaderView * ServiceRequestDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Request_DataReaderView> ServiceRequestDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Request_DataReaderView> ServiceRequestDetails_Request_DataReaderView_out;

            struct ServiceRequestDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceRequestDetails_Request_, struct ServiceRequestDetails_Request_Seq_uniq_> ServiceRequestDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < ServiceRequestDetails_Request_Seq> ServiceRequestDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceRequestDetails_Request_Seq> ServiceRequestDetails_Request_Seq_out;

            class  ServiceRequestDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceRequestDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceRequestDetails_Request_TypeSupportInterface_var _var_type;

                static ServiceRequestDetails_Request_TypeSupportInterface_ptr _duplicate (ServiceRequestDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceRequestDetails_Request_TypeSupportInterface () {};
                ~ServiceRequestDetails_Request_TypeSupportInterface () {};
            private:
                ServiceRequestDetails_Request_TypeSupportInterface (const ServiceRequestDetails_Request_TypeSupportInterface &);
                ServiceRequestDetails_Request_TypeSupportInterface & operator = (const ServiceRequestDetails_Request_TypeSupportInterface &);
            };

            class  ServiceRequestDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceRequestDetails_Request_DataWriter_ptr _ptr_type;
                typedef ServiceRequestDetails_Request_DataWriter_var _var_type;

                static ServiceRequestDetails_Request_DataWriter_ptr _duplicate (ServiceRequestDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceRequestDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceRequestDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceRequestDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceRequestDetails_Request_& instance_data) = 0;

            protected:
                ServiceRequestDetails_Request_DataWriter () {};
                ~ServiceRequestDetails_Request_DataWriter () {};
            private:
                ServiceRequestDetails_Request_DataWriter (const ServiceRequestDetails_Request_DataWriter &);
                ServiceRequestDetails_Request_DataWriter & operator = (const ServiceRequestDetails_Request_DataWriter &);
            };

            class  ServiceRequestDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceRequestDetails_Request_DataReader_ptr _ptr_type;
                typedef ServiceRequestDetails_Request_DataReader_var _var_type;

                static ServiceRequestDetails_Request_DataReader_ptr _duplicate (ServiceRequestDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceRequestDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceRequestDetails_Request_& instance) = 0;

            protected:
                ServiceRequestDetails_Request_DataReader () {};
                ~ServiceRequestDetails_Request_DataReader () {};
            private:
                ServiceRequestDetails_Request_DataReader (const ServiceRequestDetails_Request_DataReader &);
                ServiceRequestDetails_Request_DataReader & operator = (const ServiceRequestDetails_Request_DataReader &);
            };

            class  ServiceRequestDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceRequestDetails_Request_DataReaderView_ptr _ptr_type;
                typedef ServiceRequestDetails_Request_DataReaderView_var _var_type;

                static ServiceRequestDetails_Request_DataReaderView_ptr _duplicate (ServiceRequestDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceRequestDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceRequestDetails_Request_& instance) = 0;

            protected:
                ServiceRequestDetails_Request_DataReaderView () {};
                ~ServiceRequestDetails_Request_DataReaderView () {};
            private:
                ServiceRequestDetails_Request_DataReaderView (const ServiceRequestDetails_Request_DataReaderView &);
                ServiceRequestDetails_Request_DataReaderView & operator = (const ServiceRequestDetails_Request_DataReaderView &);
            };
            class ServiceRequestDetails_Response_TypeSupportInterface;

            typedef ServiceRequestDetails_Response_TypeSupportInterface * ServiceRequestDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Response_TypeSupportInterface> ServiceRequestDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Response_TypeSupportInterface> ServiceRequestDetails_Response_TypeSupportInterface_out;


            class ServiceRequestDetails_Response_DataWriter;

            typedef ServiceRequestDetails_Response_DataWriter * ServiceRequestDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Response_DataWriter> ServiceRequestDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Response_DataWriter> ServiceRequestDetails_Response_DataWriter_out;


            class ServiceRequestDetails_Response_DataReader;

            typedef ServiceRequestDetails_Response_DataReader * ServiceRequestDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Response_DataReader> ServiceRequestDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Response_DataReader> ServiceRequestDetails_Response_DataReader_out;


            class ServiceRequestDetails_Response_DataReaderView;

            typedef ServiceRequestDetails_Response_DataReaderView * ServiceRequestDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceRequestDetails_Response_DataReaderView> ServiceRequestDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceRequestDetails_Response_DataReaderView> ServiceRequestDetails_Response_DataReaderView_out;

            struct ServiceRequestDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceRequestDetails_Response_, struct ServiceRequestDetails_Response_Seq_uniq_> ServiceRequestDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < ServiceRequestDetails_Response_Seq> ServiceRequestDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceRequestDetails_Response_Seq> ServiceRequestDetails_Response_Seq_out;

            class  ServiceRequestDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceRequestDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceRequestDetails_Response_TypeSupportInterface_var _var_type;

                static ServiceRequestDetails_Response_TypeSupportInterface_ptr _duplicate (ServiceRequestDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceRequestDetails_Response_TypeSupportInterface () {};
                ~ServiceRequestDetails_Response_TypeSupportInterface () {};
            private:
                ServiceRequestDetails_Response_TypeSupportInterface (const ServiceRequestDetails_Response_TypeSupportInterface &);
                ServiceRequestDetails_Response_TypeSupportInterface & operator = (const ServiceRequestDetails_Response_TypeSupportInterface &);
            };

            class  ServiceRequestDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceRequestDetails_Response_DataWriter_ptr _ptr_type;
                typedef ServiceRequestDetails_Response_DataWriter_var _var_type;

                static ServiceRequestDetails_Response_DataWriter_ptr _duplicate (ServiceRequestDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceRequestDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceRequestDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceRequestDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceRequestDetails_Response_& instance_data) = 0;

            protected:
                ServiceRequestDetails_Response_DataWriter () {};
                ~ServiceRequestDetails_Response_DataWriter () {};
            private:
                ServiceRequestDetails_Response_DataWriter (const ServiceRequestDetails_Response_DataWriter &);
                ServiceRequestDetails_Response_DataWriter & operator = (const ServiceRequestDetails_Response_DataWriter &);
            };

            class  ServiceRequestDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceRequestDetails_Response_DataReader_ptr _ptr_type;
                typedef ServiceRequestDetails_Response_DataReader_var _var_type;

                static ServiceRequestDetails_Response_DataReader_ptr _duplicate (ServiceRequestDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceRequestDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceRequestDetails_Response_& instance) = 0;

            protected:
                ServiceRequestDetails_Response_DataReader () {};
                ~ServiceRequestDetails_Response_DataReader () {};
            private:
                ServiceRequestDetails_Response_DataReader (const ServiceRequestDetails_Response_DataReader &);
                ServiceRequestDetails_Response_DataReader & operator = (const ServiceRequestDetails_Response_DataReader &);
            };

            class  ServiceRequestDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceRequestDetails_Response_DataReaderView_ptr _ptr_type;
                typedef ServiceRequestDetails_Response_DataReaderView_var _var_type;

                static ServiceRequestDetails_Response_DataReaderView_ptr _duplicate (ServiceRequestDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceRequestDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceRequestDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceRequestDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceRequestDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceRequestDetails_Response_& instance) = 0;

            protected:
                ServiceRequestDetails_Response_DataReaderView () {};
                ~ServiceRequestDetails_Response_DataReaderView () {};
            private:
                ServiceRequestDetails_Response_DataReaderView (const ServiceRequestDetails_Response_DataReaderView &);
                ServiceRequestDetails_Response_DataReaderView & operator = (const ServiceRequestDetails_Response_DataReaderView &);
            };
            class Sample_ServiceRequestDetails_Request_TypeSupportInterface;

            typedef Sample_ServiceRequestDetails_Request_TypeSupportInterface * Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Request_TypeSupportInterface> Sample_ServiceRequestDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Request_TypeSupportInterface> Sample_ServiceRequestDetails_Request_TypeSupportInterface_out;


            class Sample_ServiceRequestDetails_Request_DataWriter;

            typedef Sample_ServiceRequestDetails_Request_DataWriter * Sample_ServiceRequestDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Request_DataWriter> Sample_ServiceRequestDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Request_DataWriter> Sample_ServiceRequestDetails_Request_DataWriter_out;


            class Sample_ServiceRequestDetails_Request_DataReader;

            typedef Sample_ServiceRequestDetails_Request_DataReader * Sample_ServiceRequestDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Request_DataReader> Sample_ServiceRequestDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Request_DataReader> Sample_ServiceRequestDetails_Request_DataReader_out;


            class Sample_ServiceRequestDetails_Request_DataReaderView;

            typedef Sample_ServiceRequestDetails_Request_DataReaderView * Sample_ServiceRequestDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Request_DataReaderView> Sample_ServiceRequestDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Request_DataReaderView> Sample_ServiceRequestDetails_Request_DataReaderView_out;

            struct Sample_ServiceRequestDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceRequestDetails_Request_, struct Sample_ServiceRequestDetails_Request_Seq_uniq_> Sample_ServiceRequestDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceRequestDetails_Request_Seq> Sample_ServiceRequestDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceRequestDetails_Request_Seq> Sample_ServiceRequestDetails_Request_Seq_out;

            class  Sample_ServiceRequestDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceRequestDetails_Request_TypeSupportInterface () {};
                ~Sample_ServiceRequestDetails_Request_TypeSupportInterface () {};
            private:
                Sample_ServiceRequestDetails_Request_TypeSupportInterface (const Sample_ServiceRequestDetails_Request_TypeSupportInterface &);
                Sample_ServiceRequestDetails_Request_TypeSupportInterface & operator = (const Sample_ServiceRequestDetails_Request_TypeSupportInterface &);
            };

            class  Sample_ServiceRequestDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceRequestDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Request_DataWriter_var _var_type;

                static Sample_ServiceRequestDetails_Request_DataWriter_ptr _duplicate (Sample_ServiceRequestDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceRequestDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceRequestDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceRequestDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceRequestDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceRequestDetails_Request_& instance_data) = 0;

            protected:
                Sample_ServiceRequestDetails_Request_DataWriter () {};
                ~Sample_ServiceRequestDetails_Request_DataWriter () {};
            private:
                Sample_ServiceRequestDetails_Request_DataWriter (const Sample_ServiceRequestDetails_Request_DataWriter &);
                Sample_ServiceRequestDetails_Request_DataWriter & operator = (const Sample_ServiceRequestDetails_Request_DataWriter &);
            };

            class  Sample_ServiceRequestDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceRequestDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Request_DataReader_var _var_type;

                static Sample_ServiceRequestDetails_Request_DataReader_ptr _duplicate (Sample_ServiceRequestDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceRequestDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceRequestDetails_Request_& instance) = 0;

            protected:
                Sample_ServiceRequestDetails_Request_DataReader () {};
                ~Sample_ServiceRequestDetails_Request_DataReader () {};
            private:
                Sample_ServiceRequestDetails_Request_DataReader (const Sample_ServiceRequestDetails_Request_DataReader &);
                Sample_ServiceRequestDetails_Request_DataReader & operator = (const Sample_ServiceRequestDetails_Request_DataReader &);
            };

            class  Sample_ServiceRequestDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceRequestDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Request_DataReaderView_var _var_type;

                static Sample_ServiceRequestDetails_Request_DataReaderView_ptr _duplicate (Sample_ServiceRequestDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceRequestDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceRequestDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceRequestDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceRequestDetails_Request_& instance) = 0;

            protected:
                Sample_ServiceRequestDetails_Request_DataReaderView () {};
                ~Sample_ServiceRequestDetails_Request_DataReaderView () {};
            private:
                Sample_ServiceRequestDetails_Request_DataReaderView (const Sample_ServiceRequestDetails_Request_DataReaderView &);
                Sample_ServiceRequestDetails_Request_DataReaderView & operator = (const Sample_ServiceRequestDetails_Request_DataReaderView &);
            };
            class Sample_ServiceRequestDetails_Response_TypeSupportInterface;

            typedef Sample_ServiceRequestDetails_Response_TypeSupportInterface * Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Response_TypeSupportInterface> Sample_ServiceRequestDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Response_TypeSupportInterface> Sample_ServiceRequestDetails_Response_TypeSupportInterface_out;


            class Sample_ServiceRequestDetails_Response_DataWriter;

            typedef Sample_ServiceRequestDetails_Response_DataWriter * Sample_ServiceRequestDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Response_DataWriter> Sample_ServiceRequestDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Response_DataWriter> Sample_ServiceRequestDetails_Response_DataWriter_out;


            class Sample_ServiceRequestDetails_Response_DataReader;

            typedef Sample_ServiceRequestDetails_Response_DataReader * Sample_ServiceRequestDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Response_DataReader> Sample_ServiceRequestDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Response_DataReader> Sample_ServiceRequestDetails_Response_DataReader_out;


            class Sample_ServiceRequestDetails_Response_DataReaderView;

            typedef Sample_ServiceRequestDetails_Response_DataReaderView * Sample_ServiceRequestDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ServiceRequestDetails_Response_DataReaderView> Sample_ServiceRequestDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ServiceRequestDetails_Response_DataReaderView> Sample_ServiceRequestDetails_Response_DataReaderView_out;

            struct Sample_ServiceRequestDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ServiceRequestDetails_Response_, struct Sample_ServiceRequestDetails_Response_Seq_uniq_> Sample_ServiceRequestDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ServiceRequestDetails_Response_Seq> Sample_ServiceRequestDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ServiceRequestDetails_Response_Seq> Sample_ServiceRequestDetails_Response_Seq_out;

            class  Sample_ServiceRequestDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ServiceRequestDetails_Response_TypeSupportInterface () {};
                ~Sample_ServiceRequestDetails_Response_TypeSupportInterface () {};
            private:
                Sample_ServiceRequestDetails_Response_TypeSupportInterface (const Sample_ServiceRequestDetails_Response_TypeSupportInterface &);
                Sample_ServiceRequestDetails_Response_TypeSupportInterface & operator = (const Sample_ServiceRequestDetails_Response_TypeSupportInterface &);
            };

            class  Sample_ServiceRequestDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ServiceRequestDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Response_DataWriter_var _var_type;

                static Sample_ServiceRequestDetails_Response_DataWriter_ptr _duplicate (Sample_ServiceRequestDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ServiceRequestDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ServiceRequestDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ServiceRequestDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceRequestDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceRequestDetails_Response_& instance_data) = 0;

            protected:
                Sample_ServiceRequestDetails_Response_DataWriter () {};
                ~Sample_ServiceRequestDetails_Response_DataWriter () {};
            private:
                Sample_ServiceRequestDetails_Response_DataWriter (const Sample_ServiceRequestDetails_Response_DataWriter &);
                Sample_ServiceRequestDetails_Response_DataWriter & operator = (const Sample_ServiceRequestDetails_Response_DataWriter &);
            };

            class  Sample_ServiceRequestDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ServiceRequestDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Response_DataReader_var _var_type;

                static Sample_ServiceRequestDetails_Response_DataReader_ptr _duplicate (Sample_ServiceRequestDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceRequestDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceRequestDetails_Response_& instance) = 0;

            protected:
                Sample_ServiceRequestDetails_Response_DataReader () {};
                ~Sample_ServiceRequestDetails_Response_DataReader () {};
            private:
                Sample_ServiceRequestDetails_Response_DataReader (const Sample_ServiceRequestDetails_Response_DataReader &);
                Sample_ServiceRequestDetails_Response_DataReader & operator = (const Sample_ServiceRequestDetails_Response_DataReader &);
            };

            class  Sample_ServiceRequestDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ServiceRequestDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ServiceRequestDetails_Response_DataReaderView_var _var_type;

                static Sample_ServiceRequestDetails_Response_DataReaderView_ptr _duplicate (Sample_ServiceRequestDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ServiceRequestDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ServiceRequestDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ServiceRequestDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ServiceRequestDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ServiceRequestDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ServiceRequestDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ServiceRequestDetails_Response_& instance) = 0;

            protected:
                Sample_ServiceRequestDetails_Response_DataReaderView () {};
                ~Sample_ServiceRequestDetails_Response_DataReaderView () {};
            private:
                Sample_ServiceRequestDetails_Response_DataReaderView (const Sample_ServiceRequestDetails_Response_DataReaderView &);
                Sample_ServiceRequestDetails_Response_DataReaderView & operator = (const Sample_ServiceRequestDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
