#ifndef _H_81F356FAF90EA7D5AECBF908FC54C7DB_Services__H_
#define _H_81F356FAF90EA7D5AECBF908FC54C7DB_Services__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  Services_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Services_Request_> Services_Request__var;
            typedef Services_Request_& Services_Request__out;

            struct  Services_Response_
            {
                struct _services__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _services__seq_uniq_ > _services__seq;
                typedef DDS_DCPSUStrSeq_var< _services__seq > _services__seq_var;
                typedef DDS_DCPSUStrSeq_out< _services__seq > _services__seq_out;
                _services__seq services_;
            };

            typedef DDS_DCPSStruct_var<Services_Response_> Services_Response__var;
            typedef DDS_DCPSStruct_out < Services_Response_> Services_Response__out;

            struct  Sample_Services_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Services_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Services_Request_> Sample_Services_Request__var;
            typedef Sample_Services_Request_& Sample_Services_Request__out;

            struct  Sample_Services_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::Services_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Services_Response_> Sample_Services_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Services_Response_> Sample_Services_Response__out;

        }

    }

}

#endif /* _H_81F356FAF90EA7D5AECBF908FC54C7DB_Services__H_ */
