#ifndef _H_F33EF0E54CA43C7E5CCBDE16D5BD60C4_SetParam__H_
#define _H_F33EF0E54CA43C7E5CCBDE16D5BD60C4_SetParam__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetParam_Request_
            {
                ::DDS::String_mgr name_;
                ::DDS::String_mgr value_;
            };

            typedef DDS_DCPSStruct_var<SetParam_Request_> SetParam_Request__var;
            typedef DDS_DCPSStruct_out < SetParam_Request_> SetParam_Request__out;

            struct  SetParam_Response_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<SetParam_Response_> SetParam_Response__var;
            typedef SetParam_Response_& SetParam_Response__out;

            struct  Sample_SetParam_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::SetParam_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetParam_Request_> Sample_SetParam_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SetParam_Request_> Sample_SetParam_Request__out;

            struct  Sample_SetParam_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rosapi::srv::dds_::SetParam_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetParam_Response_> Sample_SetParam_Response__var;
            typedef Sample_SetParam_Response_& Sample_SetParam_Response__out;

        }

    }

}

#endif /* _H_F33EF0E54CA43C7E5CCBDE16D5BD60C4_SetParam__H_ */
