#ifndef _H_E12A59EB485C01787721276547C465F2_Subscribers_DCPS_H_
#define _H_E12A59EB485C01787721276547C465F2_Subscribers_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Subscribers_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class Subscribers_Request_TypeSupportInterface;

            typedef Subscribers_Request_TypeSupportInterface * Subscribers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Request_TypeSupportInterface> Subscribers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Subscribers_Request_TypeSupportInterface> Subscribers_Request_TypeSupportInterface_out;


            class Subscribers_Request_DataWriter;

            typedef Subscribers_Request_DataWriter * Subscribers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Request_DataWriter> Subscribers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Subscribers_Request_DataWriter> Subscribers_Request_DataWriter_out;


            class Subscribers_Request_DataReader;

            typedef Subscribers_Request_DataReader * Subscribers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Request_DataReader> Subscribers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Subscribers_Request_DataReader> Subscribers_Request_DataReader_out;


            class Subscribers_Request_DataReaderView;

            typedef Subscribers_Request_DataReaderView * Subscribers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Request_DataReaderView> Subscribers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Subscribers_Request_DataReaderView> Subscribers_Request_DataReaderView_out;

            struct Subscribers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Subscribers_Request_, struct Subscribers_Request_Seq_uniq_> Subscribers_Request_Seq;
            typedef DDS_DCPSSequence_var < Subscribers_Request_Seq> Subscribers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Subscribers_Request_Seq> Subscribers_Request_Seq_out;

            class  Subscribers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Subscribers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Subscribers_Request_TypeSupportInterface_var _var_type;

                static Subscribers_Request_TypeSupportInterface_ptr _duplicate (Subscribers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Subscribers_Request_TypeSupportInterface () {};
                ~Subscribers_Request_TypeSupportInterface () {};
            private:
                Subscribers_Request_TypeSupportInterface (const Subscribers_Request_TypeSupportInterface &);
                Subscribers_Request_TypeSupportInterface & operator = (const Subscribers_Request_TypeSupportInterface &);
            };

            class  Subscribers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Subscribers_Request_DataWriter_ptr _ptr_type;
                typedef Subscribers_Request_DataWriter_var _var_type;

                static Subscribers_Request_DataWriter_ptr _duplicate (Subscribers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Subscribers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Subscribers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Subscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Subscribers_Request_& instance_data) = 0;

            protected:
                Subscribers_Request_DataWriter () {};
                ~Subscribers_Request_DataWriter () {};
            private:
                Subscribers_Request_DataWriter (const Subscribers_Request_DataWriter &);
                Subscribers_Request_DataWriter & operator = (const Subscribers_Request_DataWriter &);
            };

            class  Subscribers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Subscribers_Request_DataReader_ptr _ptr_type;
                typedef Subscribers_Request_DataReader_var _var_type;

                static Subscribers_Request_DataReader_ptr _duplicate (Subscribers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Subscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Subscribers_Request_& instance) = 0;

            protected:
                Subscribers_Request_DataReader () {};
                ~Subscribers_Request_DataReader () {};
            private:
                Subscribers_Request_DataReader (const Subscribers_Request_DataReader &);
                Subscribers_Request_DataReader & operator = (const Subscribers_Request_DataReader &);
            };

            class  Subscribers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Subscribers_Request_DataReaderView_ptr _ptr_type;
                typedef Subscribers_Request_DataReaderView_var _var_type;

                static Subscribers_Request_DataReaderView_ptr _duplicate (Subscribers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Subscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Subscribers_Request_& instance) = 0;

            protected:
                Subscribers_Request_DataReaderView () {};
                ~Subscribers_Request_DataReaderView () {};
            private:
                Subscribers_Request_DataReaderView (const Subscribers_Request_DataReaderView &);
                Subscribers_Request_DataReaderView & operator = (const Subscribers_Request_DataReaderView &);
            };
            class Subscribers_Response_TypeSupportInterface;

            typedef Subscribers_Response_TypeSupportInterface * Subscribers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Response_TypeSupportInterface> Subscribers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Subscribers_Response_TypeSupportInterface> Subscribers_Response_TypeSupportInterface_out;


            class Subscribers_Response_DataWriter;

            typedef Subscribers_Response_DataWriter * Subscribers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Response_DataWriter> Subscribers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Subscribers_Response_DataWriter> Subscribers_Response_DataWriter_out;


            class Subscribers_Response_DataReader;

            typedef Subscribers_Response_DataReader * Subscribers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Response_DataReader> Subscribers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Subscribers_Response_DataReader> Subscribers_Response_DataReader_out;


            class Subscribers_Response_DataReaderView;

            typedef Subscribers_Response_DataReaderView * Subscribers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Subscribers_Response_DataReaderView> Subscribers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Subscribers_Response_DataReaderView> Subscribers_Response_DataReaderView_out;

            struct Subscribers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Subscribers_Response_, struct Subscribers_Response_Seq_uniq_> Subscribers_Response_Seq;
            typedef DDS_DCPSSequence_var < Subscribers_Response_Seq> Subscribers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Subscribers_Response_Seq> Subscribers_Response_Seq_out;

            class  Subscribers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Subscribers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Subscribers_Response_TypeSupportInterface_var _var_type;

                static Subscribers_Response_TypeSupportInterface_ptr _duplicate (Subscribers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Subscribers_Response_TypeSupportInterface () {};
                ~Subscribers_Response_TypeSupportInterface () {};
            private:
                Subscribers_Response_TypeSupportInterface (const Subscribers_Response_TypeSupportInterface &);
                Subscribers_Response_TypeSupportInterface & operator = (const Subscribers_Response_TypeSupportInterface &);
            };

            class  Subscribers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Subscribers_Response_DataWriter_ptr _ptr_type;
                typedef Subscribers_Response_DataWriter_var _var_type;

                static Subscribers_Response_DataWriter_ptr _duplicate (Subscribers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Subscribers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Subscribers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Subscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Subscribers_Response_& instance_data) = 0;

            protected:
                Subscribers_Response_DataWriter () {};
                ~Subscribers_Response_DataWriter () {};
            private:
                Subscribers_Response_DataWriter (const Subscribers_Response_DataWriter &);
                Subscribers_Response_DataWriter & operator = (const Subscribers_Response_DataWriter &);
            };

            class  Subscribers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Subscribers_Response_DataReader_ptr _ptr_type;
                typedef Subscribers_Response_DataReader_var _var_type;

                static Subscribers_Response_DataReader_ptr _duplicate (Subscribers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Subscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Subscribers_Response_& instance) = 0;

            protected:
                Subscribers_Response_DataReader () {};
                ~Subscribers_Response_DataReader () {};
            private:
                Subscribers_Response_DataReader (const Subscribers_Response_DataReader &);
                Subscribers_Response_DataReader & operator = (const Subscribers_Response_DataReader &);
            };

            class  Subscribers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Subscribers_Response_DataReaderView_ptr _ptr_type;
                typedef Subscribers_Response_DataReaderView_var _var_type;

                static Subscribers_Response_DataReaderView_ptr _duplicate (Subscribers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Subscribers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Subscribers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Subscribers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Subscribers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Subscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Subscribers_Response_& instance) = 0;

            protected:
                Subscribers_Response_DataReaderView () {};
                ~Subscribers_Response_DataReaderView () {};
            private:
                Subscribers_Response_DataReaderView (const Subscribers_Response_DataReaderView &);
                Subscribers_Response_DataReaderView & operator = (const Subscribers_Response_DataReaderView &);
            };
            class Sample_Subscribers_Request_TypeSupportInterface;

            typedef Sample_Subscribers_Request_TypeSupportInterface * Sample_Subscribers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Request_TypeSupportInterface> Sample_Subscribers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Request_TypeSupportInterface> Sample_Subscribers_Request_TypeSupportInterface_out;


            class Sample_Subscribers_Request_DataWriter;

            typedef Sample_Subscribers_Request_DataWriter * Sample_Subscribers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Request_DataWriter> Sample_Subscribers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Request_DataWriter> Sample_Subscribers_Request_DataWriter_out;


            class Sample_Subscribers_Request_DataReader;

            typedef Sample_Subscribers_Request_DataReader * Sample_Subscribers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Request_DataReader> Sample_Subscribers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Request_DataReader> Sample_Subscribers_Request_DataReader_out;


            class Sample_Subscribers_Request_DataReaderView;

            typedef Sample_Subscribers_Request_DataReaderView * Sample_Subscribers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Request_DataReaderView> Sample_Subscribers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Request_DataReaderView> Sample_Subscribers_Request_DataReaderView_out;

            struct Sample_Subscribers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Subscribers_Request_, struct Sample_Subscribers_Request_Seq_uniq_> Sample_Subscribers_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Subscribers_Request_Seq> Sample_Subscribers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Subscribers_Request_Seq> Sample_Subscribers_Request_Seq_out;

            class  Sample_Subscribers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Subscribers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Subscribers_Request_TypeSupportInterface_var _var_type;

                static Sample_Subscribers_Request_TypeSupportInterface_ptr _duplicate (Sample_Subscribers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Subscribers_Request_TypeSupportInterface () {};
                ~Sample_Subscribers_Request_TypeSupportInterface () {};
            private:
                Sample_Subscribers_Request_TypeSupportInterface (const Sample_Subscribers_Request_TypeSupportInterface &);
                Sample_Subscribers_Request_TypeSupportInterface & operator = (const Sample_Subscribers_Request_TypeSupportInterface &);
            };

            class  Sample_Subscribers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Subscribers_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Subscribers_Request_DataWriter_var _var_type;

                static Sample_Subscribers_Request_DataWriter_ptr _duplicate (Sample_Subscribers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Subscribers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Subscribers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Subscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Subscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Subscribers_Request_& instance_data) = 0;

            protected:
                Sample_Subscribers_Request_DataWriter () {};
                ~Sample_Subscribers_Request_DataWriter () {};
            private:
                Sample_Subscribers_Request_DataWriter (const Sample_Subscribers_Request_DataWriter &);
                Sample_Subscribers_Request_DataWriter & operator = (const Sample_Subscribers_Request_DataWriter &);
            };

            class  Sample_Subscribers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Subscribers_Request_DataReader_ptr _ptr_type;
                typedef Sample_Subscribers_Request_DataReader_var _var_type;

                static Sample_Subscribers_Request_DataReader_ptr _duplicate (Sample_Subscribers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Subscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Subscribers_Request_& instance) = 0;

            protected:
                Sample_Subscribers_Request_DataReader () {};
                ~Sample_Subscribers_Request_DataReader () {};
            private:
                Sample_Subscribers_Request_DataReader (const Sample_Subscribers_Request_DataReader &);
                Sample_Subscribers_Request_DataReader & operator = (const Sample_Subscribers_Request_DataReader &);
            };

            class  Sample_Subscribers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Subscribers_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Subscribers_Request_DataReaderView_var _var_type;

                static Sample_Subscribers_Request_DataReaderView_ptr _duplicate (Sample_Subscribers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Subscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Subscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Subscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Subscribers_Request_& instance) = 0;

            protected:
                Sample_Subscribers_Request_DataReaderView () {};
                ~Sample_Subscribers_Request_DataReaderView () {};
            private:
                Sample_Subscribers_Request_DataReaderView (const Sample_Subscribers_Request_DataReaderView &);
                Sample_Subscribers_Request_DataReaderView & operator = (const Sample_Subscribers_Request_DataReaderView &);
            };
            class Sample_Subscribers_Response_TypeSupportInterface;

            typedef Sample_Subscribers_Response_TypeSupportInterface * Sample_Subscribers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Response_TypeSupportInterface> Sample_Subscribers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Response_TypeSupportInterface> Sample_Subscribers_Response_TypeSupportInterface_out;


            class Sample_Subscribers_Response_DataWriter;

            typedef Sample_Subscribers_Response_DataWriter * Sample_Subscribers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Response_DataWriter> Sample_Subscribers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Response_DataWriter> Sample_Subscribers_Response_DataWriter_out;


            class Sample_Subscribers_Response_DataReader;

            typedef Sample_Subscribers_Response_DataReader * Sample_Subscribers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Response_DataReader> Sample_Subscribers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Response_DataReader> Sample_Subscribers_Response_DataReader_out;


            class Sample_Subscribers_Response_DataReaderView;

            typedef Sample_Subscribers_Response_DataReaderView * Sample_Subscribers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Subscribers_Response_DataReaderView> Sample_Subscribers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Subscribers_Response_DataReaderView> Sample_Subscribers_Response_DataReaderView_out;

            struct Sample_Subscribers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Subscribers_Response_, struct Sample_Subscribers_Response_Seq_uniq_> Sample_Subscribers_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Subscribers_Response_Seq> Sample_Subscribers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Subscribers_Response_Seq> Sample_Subscribers_Response_Seq_out;

            class  Sample_Subscribers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Subscribers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Subscribers_Response_TypeSupportInterface_var _var_type;

                static Sample_Subscribers_Response_TypeSupportInterface_ptr _duplicate (Sample_Subscribers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Subscribers_Response_TypeSupportInterface () {};
                ~Sample_Subscribers_Response_TypeSupportInterface () {};
            private:
                Sample_Subscribers_Response_TypeSupportInterface (const Sample_Subscribers_Response_TypeSupportInterface &);
                Sample_Subscribers_Response_TypeSupportInterface & operator = (const Sample_Subscribers_Response_TypeSupportInterface &);
            };

            class  Sample_Subscribers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Subscribers_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Subscribers_Response_DataWriter_var _var_type;

                static Sample_Subscribers_Response_DataWriter_ptr _duplicate (Sample_Subscribers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Subscribers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Subscribers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Subscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Subscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Subscribers_Response_& instance_data) = 0;

            protected:
                Sample_Subscribers_Response_DataWriter () {};
                ~Sample_Subscribers_Response_DataWriter () {};
            private:
                Sample_Subscribers_Response_DataWriter (const Sample_Subscribers_Response_DataWriter &);
                Sample_Subscribers_Response_DataWriter & operator = (const Sample_Subscribers_Response_DataWriter &);
            };

            class  Sample_Subscribers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Subscribers_Response_DataReader_ptr _ptr_type;
                typedef Sample_Subscribers_Response_DataReader_var _var_type;

                static Sample_Subscribers_Response_DataReader_ptr _duplicate (Sample_Subscribers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Subscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Subscribers_Response_& instance) = 0;

            protected:
                Sample_Subscribers_Response_DataReader () {};
                ~Sample_Subscribers_Response_DataReader () {};
            private:
                Sample_Subscribers_Response_DataReader (const Sample_Subscribers_Response_DataReader &);
                Sample_Subscribers_Response_DataReader & operator = (const Sample_Subscribers_Response_DataReader &);
            };

            class  Sample_Subscribers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Subscribers_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Subscribers_Response_DataReaderView_var _var_type;

                static Sample_Subscribers_Response_DataReaderView_ptr _duplicate (Sample_Subscribers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Subscribers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Subscribers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Subscribers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Subscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Subscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Subscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Subscribers_Response_& instance) = 0;

            protected:
                Sample_Subscribers_Response_DataReaderView () {};
                ~Sample_Subscribers_Response_DataReaderView () {};
            private:
                Sample_Subscribers_Response_DataReaderView (const Sample_Subscribers_Response_DataReaderView &);
                Sample_Subscribers_Response_DataReaderView & operator = (const Sample_Subscribers_Response_DataReaderView &);
            };
        }

    }

}

#endif
