#ifndef _H_48449DAB6605FEBAF8C4082CCAA457F0_TopicType_DCPS_H_
#define _H_48449DAB6605FEBAF8C4082CCAA457F0_TopicType_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TopicType_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class TopicType_Request_TypeSupportInterface;

            typedef TopicType_Request_TypeSupportInterface * TopicType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Request_TypeSupportInterface> TopicType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TopicType_Request_TypeSupportInterface> TopicType_Request_TypeSupportInterface_out;


            class TopicType_Request_DataWriter;

            typedef TopicType_Request_DataWriter * TopicType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Request_DataWriter> TopicType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < TopicType_Request_DataWriter> TopicType_Request_DataWriter_out;


            class TopicType_Request_DataReader;

            typedef TopicType_Request_DataReader * TopicType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Request_DataReader> TopicType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < TopicType_Request_DataReader> TopicType_Request_DataReader_out;


            class TopicType_Request_DataReaderView;

            typedef TopicType_Request_DataReaderView * TopicType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Request_DataReaderView> TopicType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TopicType_Request_DataReaderView> TopicType_Request_DataReaderView_out;

            struct TopicType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TopicType_Request_, struct TopicType_Request_Seq_uniq_> TopicType_Request_Seq;
            typedef DDS_DCPSSequence_var < TopicType_Request_Seq> TopicType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < TopicType_Request_Seq> TopicType_Request_Seq_out;

            class  TopicType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TopicType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef TopicType_Request_TypeSupportInterface_var _var_type;

                static TopicType_Request_TypeSupportInterface_ptr _duplicate (TopicType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TopicType_Request_TypeSupportInterface () {};
                ~TopicType_Request_TypeSupportInterface () {};
            private:
                TopicType_Request_TypeSupportInterface (const TopicType_Request_TypeSupportInterface &);
                TopicType_Request_TypeSupportInterface & operator = (const TopicType_Request_TypeSupportInterface &);
            };

            class  TopicType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TopicType_Request_DataWriter_ptr _ptr_type;
                typedef TopicType_Request_DataWriter_var _var_type;

                static TopicType_Request_DataWriter_ptr _duplicate (TopicType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TopicType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TopicType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TopicType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicType_Request_& instance_data) = 0;

            protected:
                TopicType_Request_DataWriter () {};
                ~TopicType_Request_DataWriter () {};
            private:
                TopicType_Request_DataWriter (const TopicType_Request_DataWriter &);
                TopicType_Request_DataWriter & operator = (const TopicType_Request_DataWriter &);
            };

            class  TopicType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TopicType_Request_DataReader_ptr _ptr_type;
                typedef TopicType_Request_DataReader_var _var_type;

                static TopicType_Request_DataReader_ptr _duplicate (TopicType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicType_Request_& instance) = 0;

            protected:
                TopicType_Request_DataReader () {};
                ~TopicType_Request_DataReader () {};
            private:
                TopicType_Request_DataReader (const TopicType_Request_DataReader &);
                TopicType_Request_DataReader & operator = (const TopicType_Request_DataReader &);
            };

            class  TopicType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TopicType_Request_DataReaderView_ptr _ptr_type;
                typedef TopicType_Request_DataReaderView_var _var_type;

                static TopicType_Request_DataReaderView_ptr _duplicate (TopicType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicType_Request_& instance) = 0;

            protected:
                TopicType_Request_DataReaderView () {};
                ~TopicType_Request_DataReaderView () {};
            private:
                TopicType_Request_DataReaderView (const TopicType_Request_DataReaderView &);
                TopicType_Request_DataReaderView & operator = (const TopicType_Request_DataReaderView &);
            };
            class TopicType_Response_TypeSupportInterface;

            typedef TopicType_Response_TypeSupportInterface * TopicType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Response_TypeSupportInterface> TopicType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TopicType_Response_TypeSupportInterface> TopicType_Response_TypeSupportInterface_out;


            class TopicType_Response_DataWriter;

            typedef TopicType_Response_DataWriter * TopicType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Response_DataWriter> TopicType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < TopicType_Response_DataWriter> TopicType_Response_DataWriter_out;


            class TopicType_Response_DataReader;

            typedef TopicType_Response_DataReader * TopicType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Response_DataReader> TopicType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < TopicType_Response_DataReader> TopicType_Response_DataReader_out;


            class TopicType_Response_DataReaderView;

            typedef TopicType_Response_DataReaderView * TopicType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TopicType_Response_DataReaderView> TopicType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TopicType_Response_DataReaderView> TopicType_Response_DataReaderView_out;

            struct TopicType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TopicType_Response_, struct TopicType_Response_Seq_uniq_> TopicType_Response_Seq;
            typedef DDS_DCPSSequence_var < TopicType_Response_Seq> TopicType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < TopicType_Response_Seq> TopicType_Response_Seq_out;

            class  TopicType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TopicType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef TopicType_Response_TypeSupportInterface_var _var_type;

                static TopicType_Response_TypeSupportInterface_ptr _duplicate (TopicType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TopicType_Response_TypeSupportInterface () {};
                ~TopicType_Response_TypeSupportInterface () {};
            private:
                TopicType_Response_TypeSupportInterface (const TopicType_Response_TypeSupportInterface &);
                TopicType_Response_TypeSupportInterface & operator = (const TopicType_Response_TypeSupportInterface &);
            };

            class  TopicType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TopicType_Response_DataWriter_ptr _ptr_type;
                typedef TopicType_Response_DataWriter_var _var_type;

                static TopicType_Response_DataWriter_ptr _duplicate (TopicType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TopicType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TopicType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TopicType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicType_Response_& instance_data) = 0;

            protected:
                TopicType_Response_DataWriter () {};
                ~TopicType_Response_DataWriter () {};
            private:
                TopicType_Response_DataWriter (const TopicType_Response_DataWriter &);
                TopicType_Response_DataWriter & operator = (const TopicType_Response_DataWriter &);
            };

            class  TopicType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TopicType_Response_DataReader_ptr _ptr_type;
                typedef TopicType_Response_DataReader_var _var_type;

                static TopicType_Response_DataReader_ptr _duplicate (TopicType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicType_Response_& instance) = 0;

            protected:
                TopicType_Response_DataReader () {};
                ~TopicType_Response_DataReader () {};
            private:
                TopicType_Response_DataReader (const TopicType_Response_DataReader &);
                TopicType_Response_DataReader & operator = (const TopicType_Response_DataReader &);
            };

            class  TopicType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TopicType_Response_DataReaderView_ptr _ptr_type;
                typedef TopicType_Response_DataReaderView_var _var_type;

                static TopicType_Response_DataReaderView_ptr _duplicate (TopicType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TopicType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TopicType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TopicType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TopicType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TopicType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TopicType_Response_& instance) = 0;

            protected:
                TopicType_Response_DataReaderView () {};
                ~TopicType_Response_DataReaderView () {};
            private:
                TopicType_Response_DataReaderView (const TopicType_Response_DataReaderView &);
                TopicType_Response_DataReaderView & operator = (const TopicType_Response_DataReaderView &);
            };
            class Sample_TopicType_Request_TypeSupportInterface;

            typedef Sample_TopicType_Request_TypeSupportInterface * Sample_TopicType_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Request_TypeSupportInterface> Sample_TopicType_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Request_TypeSupportInterface> Sample_TopicType_Request_TypeSupportInterface_out;


            class Sample_TopicType_Request_DataWriter;

            typedef Sample_TopicType_Request_DataWriter * Sample_TopicType_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Request_DataWriter> Sample_TopicType_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Request_DataWriter> Sample_TopicType_Request_DataWriter_out;


            class Sample_TopicType_Request_DataReader;

            typedef Sample_TopicType_Request_DataReader * Sample_TopicType_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Request_DataReader> Sample_TopicType_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Request_DataReader> Sample_TopicType_Request_DataReader_out;


            class Sample_TopicType_Request_DataReaderView;

            typedef Sample_TopicType_Request_DataReaderView * Sample_TopicType_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Request_DataReaderView> Sample_TopicType_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Request_DataReaderView> Sample_TopicType_Request_DataReaderView_out;

            struct Sample_TopicType_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_TopicType_Request_, struct Sample_TopicType_Request_Seq_uniq_> Sample_TopicType_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_TopicType_Request_Seq> Sample_TopicType_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_TopicType_Request_Seq> Sample_TopicType_Request_Seq_out;

            class  Sample_TopicType_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_TopicType_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_TopicType_Request_TypeSupportInterface_var _var_type;

                static Sample_TopicType_Request_TypeSupportInterface_ptr _duplicate (Sample_TopicType_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_TopicType_Request_TypeSupportInterface () {};
                ~Sample_TopicType_Request_TypeSupportInterface () {};
            private:
                Sample_TopicType_Request_TypeSupportInterface (const Sample_TopicType_Request_TypeSupportInterface &);
                Sample_TopicType_Request_TypeSupportInterface & operator = (const Sample_TopicType_Request_TypeSupportInterface &);
            };

            class  Sample_TopicType_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_TopicType_Request_DataWriter_ptr _ptr_type;
                typedef Sample_TopicType_Request_DataWriter_var _var_type;

                static Sample_TopicType_Request_DataWriter_ptr _duplicate (Sample_TopicType_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_TopicType_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_TopicType_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_TopicType_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_TopicType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicType_Request_& instance_data) = 0;

            protected:
                Sample_TopicType_Request_DataWriter () {};
                ~Sample_TopicType_Request_DataWriter () {};
            private:
                Sample_TopicType_Request_DataWriter (const Sample_TopicType_Request_DataWriter &);
                Sample_TopicType_Request_DataWriter & operator = (const Sample_TopicType_Request_DataWriter &);
            };

            class  Sample_TopicType_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_TopicType_Request_DataReader_ptr _ptr_type;
                typedef Sample_TopicType_Request_DataReader_var _var_type;

                static Sample_TopicType_Request_DataReader_ptr _duplicate (Sample_TopicType_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicType_Request_& instance) = 0;

            protected:
                Sample_TopicType_Request_DataReader () {};
                ~Sample_TopicType_Request_DataReader () {};
            private:
                Sample_TopicType_Request_DataReader (const Sample_TopicType_Request_DataReader &);
                Sample_TopicType_Request_DataReader & operator = (const Sample_TopicType_Request_DataReader &);
            };

            class  Sample_TopicType_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_TopicType_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_TopicType_Request_DataReaderView_var _var_type;

                static Sample_TopicType_Request_DataReaderView_ptr _duplicate (Sample_TopicType_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicType_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicType_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicType_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicType_Request_& instance) = 0;

            protected:
                Sample_TopicType_Request_DataReaderView () {};
                ~Sample_TopicType_Request_DataReaderView () {};
            private:
                Sample_TopicType_Request_DataReaderView (const Sample_TopicType_Request_DataReaderView &);
                Sample_TopicType_Request_DataReaderView & operator = (const Sample_TopicType_Request_DataReaderView &);
            };
            class Sample_TopicType_Response_TypeSupportInterface;

            typedef Sample_TopicType_Response_TypeSupportInterface * Sample_TopicType_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Response_TypeSupportInterface> Sample_TopicType_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Response_TypeSupportInterface> Sample_TopicType_Response_TypeSupportInterface_out;


            class Sample_TopicType_Response_DataWriter;

            typedef Sample_TopicType_Response_DataWriter * Sample_TopicType_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Response_DataWriter> Sample_TopicType_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Response_DataWriter> Sample_TopicType_Response_DataWriter_out;


            class Sample_TopicType_Response_DataReader;

            typedef Sample_TopicType_Response_DataReader * Sample_TopicType_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Response_DataReader> Sample_TopicType_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Response_DataReader> Sample_TopicType_Response_DataReader_out;


            class Sample_TopicType_Response_DataReaderView;

            typedef Sample_TopicType_Response_DataReaderView * Sample_TopicType_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_TopicType_Response_DataReaderView> Sample_TopicType_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_TopicType_Response_DataReaderView> Sample_TopicType_Response_DataReaderView_out;

            struct Sample_TopicType_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_TopicType_Response_, struct Sample_TopicType_Response_Seq_uniq_> Sample_TopicType_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_TopicType_Response_Seq> Sample_TopicType_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_TopicType_Response_Seq> Sample_TopicType_Response_Seq_out;

            class  Sample_TopicType_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_TopicType_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_TopicType_Response_TypeSupportInterface_var _var_type;

                static Sample_TopicType_Response_TypeSupportInterface_ptr _duplicate (Sample_TopicType_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_TopicType_Response_TypeSupportInterface () {};
                ~Sample_TopicType_Response_TypeSupportInterface () {};
            private:
                Sample_TopicType_Response_TypeSupportInterface (const Sample_TopicType_Response_TypeSupportInterface &);
                Sample_TopicType_Response_TypeSupportInterface & operator = (const Sample_TopicType_Response_TypeSupportInterface &);
            };

            class  Sample_TopicType_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_TopicType_Response_DataWriter_ptr _ptr_type;
                typedef Sample_TopicType_Response_DataWriter_var _var_type;

                static Sample_TopicType_Response_DataWriter_ptr _duplicate (Sample_TopicType_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_TopicType_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_TopicType_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_TopicType_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_TopicType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicType_Response_& instance_data) = 0;

            protected:
                Sample_TopicType_Response_DataWriter () {};
                ~Sample_TopicType_Response_DataWriter () {};
            private:
                Sample_TopicType_Response_DataWriter (const Sample_TopicType_Response_DataWriter &);
                Sample_TopicType_Response_DataWriter & operator = (const Sample_TopicType_Response_DataWriter &);
            };

            class  Sample_TopicType_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_TopicType_Response_DataReader_ptr _ptr_type;
                typedef Sample_TopicType_Response_DataReader_var _var_type;

                static Sample_TopicType_Response_DataReader_ptr _duplicate (Sample_TopicType_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicType_Response_& instance) = 0;

            protected:
                Sample_TopicType_Response_DataReader () {};
                ~Sample_TopicType_Response_DataReader () {};
            private:
                Sample_TopicType_Response_DataReader (const Sample_TopicType_Response_DataReader &);
                Sample_TopicType_Response_DataReader & operator = (const Sample_TopicType_Response_DataReader &);
            };

            class  Sample_TopicType_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_TopicType_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_TopicType_Response_DataReaderView_var _var_type;

                static Sample_TopicType_Response_DataReaderView_ptr _duplicate (Sample_TopicType_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_TopicType_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_TopicType_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_TopicType_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_TopicType_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_TopicType_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_TopicType_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_TopicType_Response_& instance) = 0;

            protected:
                Sample_TopicType_Response_DataReaderView () {};
                ~Sample_TopicType_Response_DataReaderView () {};
            private:
                Sample_TopicType_Response_DataReaderView (const Sample_TopicType_Response_DataReaderView &);
                Sample_TopicType_Response_DataReaderView & operator = (const Sample_TopicType_Response_DataReaderView &);
            };
        }

    }

}

#endif
