#ifndef _H_F77F25E40F584F9A80133C6AA5131CA0_Topics_DCPS_H_
#define _H_F77F25E40F584F9A80133C6AA5131CA0_Topics_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Topics_.h"


namespace rosapi
{
    namespace srv
    {
        namespace dds_
        {
            class Topics_Request_TypeSupportInterface;

            typedef Topics_Request_TypeSupportInterface * Topics_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Topics_Request_TypeSupportInterface> Topics_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Topics_Request_TypeSupportInterface> Topics_Request_TypeSupportInterface_out;


            class Topics_Request_DataWriter;

            typedef Topics_Request_DataWriter * Topics_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Topics_Request_DataWriter> Topics_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Topics_Request_DataWriter> Topics_Request_DataWriter_out;


            class Topics_Request_DataReader;

            typedef Topics_Request_DataReader * Topics_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Topics_Request_DataReader> Topics_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Topics_Request_DataReader> Topics_Request_DataReader_out;


            class Topics_Request_DataReaderView;

            typedef Topics_Request_DataReaderView * Topics_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Topics_Request_DataReaderView> Topics_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Topics_Request_DataReaderView> Topics_Request_DataReaderView_out;

            struct Topics_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Topics_Request_, struct Topics_Request_Seq_uniq_> Topics_Request_Seq;
            typedef DDS_DCPSSequence_var < Topics_Request_Seq> Topics_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Topics_Request_Seq> Topics_Request_Seq_out;

            class  Topics_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Topics_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Topics_Request_TypeSupportInterface_var _var_type;

                static Topics_Request_TypeSupportInterface_ptr _duplicate (Topics_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Topics_Request_TypeSupportInterface () {};
                ~Topics_Request_TypeSupportInterface () {};
            private:
                Topics_Request_TypeSupportInterface (const Topics_Request_TypeSupportInterface &);
                Topics_Request_TypeSupportInterface & operator = (const Topics_Request_TypeSupportInterface &);
            };

            class  Topics_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Topics_Request_DataWriter_ptr _ptr_type;
                typedef Topics_Request_DataWriter_var _var_type;

                static Topics_Request_DataWriter_ptr _duplicate (Topics_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Topics_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Topics_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Topics_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Topics_Request_& instance_data) = 0;

            protected:
                Topics_Request_DataWriter () {};
                ~Topics_Request_DataWriter () {};
            private:
                Topics_Request_DataWriter (const Topics_Request_DataWriter &);
                Topics_Request_DataWriter & operator = (const Topics_Request_DataWriter &);
            };

            class  Topics_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Topics_Request_DataReader_ptr _ptr_type;
                typedef Topics_Request_DataReader_var _var_type;

                static Topics_Request_DataReader_ptr _duplicate (Topics_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Topics_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Topics_Request_& instance) = 0;

            protected:
                Topics_Request_DataReader () {};
                ~Topics_Request_DataReader () {};
            private:
                Topics_Request_DataReader (const Topics_Request_DataReader &);
                Topics_Request_DataReader & operator = (const Topics_Request_DataReader &);
            };

            class  Topics_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Topics_Request_DataReaderView_ptr _ptr_type;
                typedef Topics_Request_DataReaderView_var _var_type;

                static Topics_Request_DataReaderView_ptr _duplicate (Topics_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Topics_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Topics_Request_& instance) = 0;

            protected:
                Topics_Request_DataReaderView () {};
                ~Topics_Request_DataReaderView () {};
            private:
                Topics_Request_DataReaderView (const Topics_Request_DataReaderView &);
                Topics_Request_DataReaderView & operator = (const Topics_Request_DataReaderView &);
            };
            class Topics_Response_TypeSupportInterface;

            typedef Topics_Response_TypeSupportInterface * Topics_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Topics_Response_TypeSupportInterface> Topics_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Topics_Response_TypeSupportInterface> Topics_Response_TypeSupportInterface_out;


            class Topics_Response_DataWriter;

            typedef Topics_Response_DataWriter * Topics_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Topics_Response_DataWriter> Topics_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Topics_Response_DataWriter> Topics_Response_DataWriter_out;


            class Topics_Response_DataReader;

            typedef Topics_Response_DataReader * Topics_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Topics_Response_DataReader> Topics_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Topics_Response_DataReader> Topics_Response_DataReader_out;


            class Topics_Response_DataReaderView;

            typedef Topics_Response_DataReaderView * Topics_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Topics_Response_DataReaderView> Topics_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Topics_Response_DataReaderView> Topics_Response_DataReaderView_out;

            struct Topics_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Topics_Response_, struct Topics_Response_Seq_uniq_> Topics_Response_Seq;
            typedef DDS_DCPSSequence_var < Topics_Response_Seq> Topics_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Topics_Response_Seq> Topics_Response_Seq_out;

            class  Topics_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Topics_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Topics_Response_TypeSupportInterface_var _var_type;

                static Topics_Response_TypeSupportInterface_ptr _duplicate (Topics_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Topics_Response_TypeSupportInterface () {};
                ~Topics_Response_TypeSupportInterface () {};
            private:
                Topics_Response_TypeSupportInterface (const Topics_Response_TypeSupportInterface &);
                Topics_Response_TypeSupportInterface & operator = (const Topics_Response_TypeSupportInterface &);
            };

            class  Topics_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Topics_Response_DataWriter_ptr _ptr_type;
                typedef Topics_Response_DataWriter_var _var_type;

                static Topics_Response_DataWriter_ptr _duplicate (Topics_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Topics_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Topics_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Topics_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Topics_Response_& instance_data) = 0;

            protected:
                Topics_Response_DataWriter () {};
                ~Topics_Response_DataWriter () {};
            private:
                Topics_Response_DataWriter (const Topics_Response_DataWriter &);
                Topics_Response_DataWriter & operator = (const Topics_Response_DataWriter &);
            };

            class  Topics_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Topics_Response_DataReader_ptr _ptr_type;
                typedef Topics_Response_DataReader_var _var_type;

                static Topics_Response_DataReader_ptr _duplicate (Topics_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Topics_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Topics_Response_& instance) = 0;

            protected:
                Topics_Response_DataReader () {};
                ~Topics_Response_DataReader () {};
            private:
                Topics_Response_DataReader (const Topics_Response_DataReader &);
                Topics_Response_DataReader & operator = (const Topics_Response_DataReader &);
            };

            class  Topics_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Topics_Response_DataReaderView_ptr _ptr_type;
                typedef Topics_Response_DataReaderView_var _var_type;

                static Topics_Response_DataReaderView_ptr _duplicate (Topics_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Topics_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Topics_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Topics_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Topics_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Topics_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Topics_Response_& instance) = 0;

            protected:
                Topics_Response_DataReaderView () {};
                ~Topics_Response_DataReaderView () {};
            private:
                Topics_Response_DataReaderView (const Topics_Response_DataReaderView &);
                Topics_Response_DataReaderView & operator = (const Topics_Response_DataReaderView &);
            };
            class Sample_Topics_Request_TypeSupportInterface;

            typedef Sample_Topics_Request_TypeSupportInterface * Sample_Topics_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Request_TypeSupportInterface> Sample_Topics_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Request_TypeSupportInterface> Sample_Topics_Request_TypeSupportInterface_out;


            class Sample_Topics_Request_DataWriter;

            typedef Sample_Topics_Request_DataWriter * Sample_Topics_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Request_DataWriter> Sample_Topics_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Request_DataWriter> Sample_Topics_Request_DataWriter_out;


            class Sample_Topics_Request_DataReader;

            typedef Sample_Topics_Request_DataReader * Sample_Topics_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Request_DataReader> Sample_Topics_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Request_DataReader> Sample_Topics_Request_DataReader_out;


            class Sample_Topics_Request_DataReaderView;

            typedef Sample_Topics_Request_DataReaderView * Sample_Topics_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Request_DataReaderView> Sample_Topics_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Request_DataReaderView> Sample_Topics_Request_DataReaderView_out;

            struct Sample_Topics_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Topics_Request_, struct Sample_Topics_Request_Seq_uniq_> Sample_Topics_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Topics_Request_Seq> Sample_Topics_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Topics_Request_Seq> Sample_Topics_Request_Seq_out;

            class  Sample_Topics_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Topics_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Topics_Request_TypeSupportInterface_var _var_type;

                static Sample_Topics_Request_TypeSupportInterface_ptr _duplicate (Sample_Topics_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Topics_Request_TypeSupportInterface () {};
                ~Sample_Topics_Request_TypeSupportInterface () {};
            private:
                Sample_Topics_Request_TypeSupportInterface (const Sample_Topics_Request_TypeSupportInterface &);
                Sample_Topics_Request_TypeSupportInterface & operator = (const Sample_Topics_Request_TypeSupportInterface &);
            };

            class  Sample_Topics_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Topics_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Topics_Request_DataWriter_var _var_type;

                static Sample_Topics_Request_DataWriter_ptr _duplicate (Sample_Topics_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Topics_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Topics_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Topics_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Topics_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Topics_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Topics_Request_& instance_data) = 0;

            protected:
                Sample_Topics_Request_DataWriter () {};
                ~Sample_Topics_Request_DataWriter () {};
            private:
                Sample_Topics_Request_DataWriter (const Sample_Topics_Request_DataWriter &);
                Sample_Topics_Request_DataWriter & operator = (const Sample_Topics_Request_DataWriter &);
            };

            class  Sample_Topics_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Topics_Request_DataReader_ptr _ptr_type;
                typedef Sample_Topics_Request_DataReader_var _var_type;

                static Sample_Topics_Request_DataReader_ptr _duplicate (Sample_Topics_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Topics_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Topics_Request_& instance) = 0;

            protected:
                Sample_Topics_Request_DataReader () {};
                ~Sample_Topics_Request_DataReader () {};
            private:
                Sample_Topics_Request_DataReader (const Sample_Topics_Request_DataReader &);
                Sample_Topics_Request_DataReader & operator = (const Sample_Topics_Request_DataReader &);
            };

            class  Sample_Topics_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Topics_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Topics_Request_DataReaderView_var _var_type;

                static Sample_Topics_Request_DataReaderView_ptr _duplicate (Sample_Topics_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Topics_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Topics_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Topics_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Topics_Request_& instance) = 0;

            protected:
                Sample_Topics_Request_DataReaderView () {};
                ~Sample_Topics_Request_DataReaderView () {};
            private:
                Sample_Topics_Request_DataReaderView (const Sample_Topics_Request_DataReaderView &);
                Sample_Topics_Request_DataReaderView & operator = (const Sample_Topics_Request_DataReaderView &);
            };
            class Sample_Topics_Response_TypeSupportInterface;

            typedef Sample_Topics_Response_TypeSupportInterface * Sample_Topics_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Response_TypeSupportInterface> Sample_Topics_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Response_TypeSupportInterface> Sample_Topics_Response_TypeSupportInterface_out;


            class Sample_Topics_Response_DataWriter;

            typedef Sample_Topics_Response_DataWriter * Sample_Topics_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Response_DataWriter> Sample_Topics_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Response_DataWriter> Sample_Topics_Response_DataWriter_out;


            class Sample_Topics_Response_DataReader;

            typedef Sample_Topics_Response_DataReader * Sample_Topics_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Response_DataReader> Sample_Topics_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Response_DataReader> Sample_Topics_Response_DataReader_out;


            class Sample_Topics_Response_DataReaderView;

            typedef Sample_Topics_Response_DataReaderView * Sample_Topics_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Topics_Response_DataReaderView> Sample_Topics_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Topics_Response_DataReaderView> Sample_Topics_Response_DataReaderView_out;

            struct Sample_Topics_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Topics_Response_, struct Sample_Topics_Response_Seq_uniq_> Sample_Topics_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Topics_Response_Seq> Sample_Topics_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Topics_Response_Seq> Sample_Topics_Response_Seq_out;

            class  Sample_Topics_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Topics_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Topics_Response_TypeSupportInterface_var _var_type;

                static Sample_Topics_Response_TypeSupportInterface_ptr _duplicate (Sample_Topics_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Topics_Response_TypeSupportInterface () {};
                ~Sample_Topics_Response_TypeSupportInterface () {};
            private:
                Sample_Topics_Response_TypeSupportInterface (const Sample_Topics_Response_TypeSupportInterface &);
                Sample_Topics_Response_TypeSupportInterface & operator = (const Sample_Topics_Response_TypeSupportInterface &);
            };

            class  Sample_Topics_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Topics_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Topics_Response_DataWriter_var _var_type;

                static Sample_Topics_Response_DataWriter_ptr _duplicate (Sample_Topics_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Topics_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Topics_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Topics_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Topics_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Topics_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Topics_Response_& instance_data) = 0;

            protected:
                Sample_Topics_Response_DataWriter () {};
                ~Sample_Topics_Response_DataWriter () {};
            private:
                Sample_Topics_Response_DataWriter (const Sample_Topics_Response_DataWriter &);
                Sample_Topics_Response_DataWriter & operator = (const Sample_Topics_Response_DataWriter &);
            };

            class  Sample_Topics_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Topics_Response_DataReader_ptr _ptr_type;
                typedef Sample_Topics_Response_DataReader_var _var_type;

                static Sample_Topics_Response_DataReader_ptr _duplicate (Sample_Topics_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Topics_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Topics_Response_& instance) = 0;

            protected:
                Sample_Topics_Response_DataReader () {};
                ~Sample_Topics_Response_DataReader () {};
            private:
                Sample_Topics_Response_DataReader (const Sample_Topics_Response_DataReader &);
                Sample_Topics_Response_DataReader & operator = (const Sample_Topics_Response_DataReader &);
            };

            class  Sample_Topics_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Topics_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Topics_Response_DataReaderView_var _var_type;

                static Sample_Topics_Response_DataReaderView_ptr _duplicate (Sample_Topics_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Topics_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Topics_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Topics_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Topics_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Topics_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Topics_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Topics_Response_& instance) = 0;

            protected:
                Sample_Topics_Response_DataReaderView () {};
                ~Sample_Topics_Response_DataReaderView () {};
            private:
                Sample_Topics_Response_DataReaderView (const Sample_Topics_Response_DataReaderView &);
                Sample_Topics_Response_DataReaderView & operator = (const Sample_Topics_Response_DataReaderView &);
            };
        }

    }

}

#endif
